;----------------------------------------------------------------
;	X68k High-speed Assembler
;		G[E[jO
;		< error.s >
;
;	$Id: error.s,v 2.3  1999 10/ 8(Fri) 21:04:21 M.Kamada Exp $
;
;		Copyright 1990-94  by Y.Nakamura
;		          1997-99  by M.Kamada
;----------------------------------------------------------------

	.include	doscall.mac
	.include	has.equ
	.include	tmpcode.equ
	.include	symbol.equ

	.cpu	68000
	.text


;----------------------------------------------------------------
;	G[E[jO[`
;----------------------------------------------------------------

;----------------------------------------------------------------
;	[jO[`
;----------------------------------------------------------------

warntbl	.macro
	warn	1,4,abswarn,		'΃AhbVOł'
	warn	1,4,absshwarn,		'΃V[gAhbVOł'
	warn	1,3,shortwarn,		'AhXWX^ %s.w ōXVĂ܂'
	warn	1,3,shortwarn_cmpa,	'AhXWX^ %s.w ŔrĂ܂'
	warn	1,3,shvalwarn_absw,	'΃V[gAhX -$8000`$7FFF ͈̔͊Oł'
	warn	1,3,shvalwarn_d16,	'ItZbg -32768`32767 ͈̔͊Oł'
	warn	1,3,shvalwarn_d8,	'ItZbg -128`127 ͈̔͊Oł'
	warn	1,1,reglwarn,		'WX^Xg̕\Lsł'
	warn	1,1,alignwarn,		'%s ̃f[^̃ACgsł'
	warn	1,1,alignwarn_op,	'߂AhXɔzu܂'
	warn	1,1,softwarn,		'%s ̓\tgEFAG~[VŎs܂'
	warn	1,1,f43gwarn,		'_߂̒ NOP }܂ (Gb^΍)'
	warn	1,1,movetouspwarn,	'MOVE to USP ̒O MOVEA.L A0,A0 }܂ (Gb^΍)'
	warn	1,1,insigbitwarn,	'CCR/SR ̖`̃rbg𑀍삵Ă܂'
	warn	1,1,indexszwarn,	'CfbNX̃TCYw肳Ă܂'
	warn	1,1,redefwarn_set,	'V{ %s  .set(=) ŏ㏑܂'
	warn	1,1,redefwarn_offsym,	'V{ %s  .offsym ŏ㏑܂'
	warn	1,1,ds_negative_warn,	'%s ̈ł'

	.endm

warn	.macro	cnt,lvl,lab,str
lab::
  .if cnt+0
	movem.l	d0-d1,-(sp)
	moveq.l	#n,d0
n = n+(cnt+0)
	moveq.l	#lvl,d1
	bra	warnout
  .endif
	.endm

n = 0
	warntbl

warnout:
	cmp.b	(WARNLEVEL,a6),d1
	bhi	warnout9
warnout1:
	movem.l	d3/a0-a2,-(sp)
	add.w	d0,d0			;[jOԍ~2
	move.w	(warn_msg_tbl,pc,d0.w),d0
	lea.l	(warn_msg_tbl,pc,d0.w),a2
	move.l	(ERRMESSYM,a6),d3
	moveq.l	#0,d1
	bsr	printerr
	cmpi.b	#3,(ASMPASS,a6)
	bne	warnout2
	tst.b	(MAKEPRN,a6)
	beq	warnout8
warnout2:				;pX1/pX3PRNt@C쐬ꍇ
	move.w	#STDOUT,-(sp)
	pea.l	(LINEBUF,a6)		;s̓e\
	DOS	_FPUTS
	pea.l	(crlf_msg,pc)
	DOS	_PRINT
	lea.l	(10,sp),sp
warnout8:
	movem.l	(sp)+,d3/a0-a2
warnout9:
	movem.l	(sp)+,d0-d1
warnout99:
	rts

warn	.macro	cnt,lvl,lab,str
  .if cnt+0
	.dc.w	m_&lab-warn_msg_tbl
  .endif
	.endm

warn_msg_tbl:
	warntbl

warn	.macro	cnt,lvl,lab,str
  .if cnt+0
m_&lab:
	mes	str
	.dc.b	0
  .endif
	.endm

	warntbl
	.even


;----------------------------------------------------------------
;	G[[`
;----------------------------------------------------------------

errtbl	.macro
	error	1,forcederr,		'.fail ɂG['
	error	1,redeferr,		'V{ %s ͊ɒ`Ă܂'
	error	1,redeferr_predefine,	'vft@CV{ %s Ē`悤Ƃ܂'
	error	1,redeferr_set,		'V{ %s  .set(=) ȊOŒ`Ă܂'
	error	1,redeferr_offsym,	'V{ %s  .offsym ȊOŒ`Ă܂'
	error	1,badopeerr,		'߂߂ł܂'
	error	1,badopeerr_local,	'[Jx̋Lqsł'
	error	0,ilsymerr_value
	error	0,ilsymerr_local
	error	0,ilsymerr_real
	error	1,ilsymerr_regsym,	'V{ %s ͎ނقȂ̂Ŏg܂'
	error	1,ilsymerr_register,	'V{ %s ̓WX^Ȃ̂Ŏg܂'
	error	1,ilsymerr_predefxdef,	'vft@CV{ %s ͊O`錾ł܂'
	error	1,ilsymerr_predefxref,	'vft@CV{ %s ͊OQƐ錾ł܂'
	error	1,ilsymerr_predefglobl,	'vft@CV{ %s ̓O[o錾ł܂'
	error	1,ilsymerr_lookfor,	'V{ %s ̒`Qƕ@ƖĂ܂'
	error	1,exprerr,		'LqԈĂ܂'
	error	1,exprerr_ea,		'AhX߂ł܂'
	error	1,exprerr_cannotscale,	'XP[t@N^͎wł܂'
	error	1,exprerr_scalefactor,	'XP[t@N^̎w肪ԈĂ܂'
	error	1,exprerr_fullformat,	'ttH[}bg̃AhbVO͎g܂'
	error	1,exprerr_immediate,	'C~fBGCgf[^߂ł܂'
	error	1,regerr,		'włȂWX^ł'
	error	1,regerr_opc,		'̃AhbVOł opc ͎g܂'
	error	1,iladrerr,		'włȂAhbVOł'
	error	0,ilsizeerr_op		;' %s ɂ͎włȂTCYł'
	error	0,ilsizeerr_pseudo	;'^ %s ɂ͎włȂTCYł'
	error	0,ilsizeerr_moveusp	;'MOVE USP ̓O[hTCŶݎw\ł'
	error	0,ilsizeerr_cf_acc	;'MOVE ACC ̓O[hTCŶݎw\ł'
	error	0,ilsizeerr_fpn		;'_WX^ڃAhbVO͊gTCŶݎw\ł'
	error	0,ilsizeerr_fprn	;'ėpWX^ڃAhbVO̓O[hTCŶݎw\ł'
	error	0,ilsizeerr_fpcr	;'FPCR/FPIAR/FPSR ̓O[hTCŶݎw\ł'
	error	0,ilsizeerr_fmovemfpn	;'FMOVEM FPn ͊gTCŶݎw\ł'
	error	0,ilsizeerr_fmovemfpcr	;'FMOVEM FPcr ̓O[hTCŶݎw\ł'
	error	0,ilsizeerr_cf_long	;'5200/5300 ł̓O[hTCŶݎw\ł'
	error	0,ilsizeerr_cf_bccl	;'5200/5300 ł̓O[hTCY̑Ε͂ł܂'
	error	1,ilsizeerr,		'włȂTCYł'
	error	0,ilsizeerr_pseudo_no
	error	1,ilsizeerr_op_no,	'%s ɂ̓TCYwł܂'
	error	1,ilsizeerr_ccr,	'%s to CCR ̓oCgTCŶݎw\ł'
	error	1,ilsizeerr_sr,		'%s to SR ̓[hTCŶݎw\ł'
	error	1,ilsizeerr_an,		'AhXWX^̓oCgTCYŃANZXł܂'
	error	1,ilsizeerr_movetosr,	'MOVE to CCR/SR ̓[hTCŶݎw\ł'
	error	1,ilsizeerr_movefrsr,	'MOVE from CCR/SR ̓[hTCŶݎw\ł'
	error	1,ilsizeerr_000_long,	'68000/68010 ł̓O[hTCY͎wł܂'
	error	1,ilsizeerr_sftrotmem,	'ɑ΂VtgE[e[g̓[hTCŶݎw\ł'
	error	1,ilsizeerr_bitmem,	'ɑ΂rbg̓oCgTCŶݎw\ł'
	error	1,ilsizeerr_bitreg,	'f[^WX^ɑ΂rbg̓O[hTCŶݎw\ł'
	error	1,ilsizeerr_000_bccl,	'68000/68010 ł̓O[hTCY̑Ε͂ł܂'
	error	1,ilsizeerr_trapcc,	'IyĥȂ TRAPcc ɂ̓TCYwł܂'
	error	1,iloprerr,		'sȃIyhł'
	error	1,iloprerr_not_fixed,	'm肵Ă܂'
	error	1,iloprerr_too_many,	'%s ̃Iyh܂'
	error	1,iloprerr_pseudo_many,	'%s ̈܂'
	error	1,iloprerr_local,	'[Jx̎QƂsł'
	error	1,iloprerr_ds_negative,	'%s ̈ł'
	error	1,iloprerr_end_xref,	'.end ɊOQƒl͎wł܂'
	error	1,undefsymerr,		'V{ %s `ł'
	error	1,undefsymerr_local,	'[Jx`ł'
	error	1,undefsymerr_offsym,	'lmł܂'
	error	1,divzeroerr,		'0 ŏZ܂'
	error	1,ilrelerr_outside,	'ItZbg͈͊Oł'
	error	1,ilrelerr_const,	'萔ł͂ȂAhXlKvł'
	error	1,overflowerr,		'I[o[t[܂'
	error	1,ilvalueerr,		'sȒlł'
	error	1,ilquickerr_addsubq,	'f[^ 1`8 ͈̔͊Oł'
	error	1,ilquickerr_moveq,	'f[^ -128`127 ͈̔͊Oł'
	error	1,ilquickerr_mov3q,	'f[^ -1,1`7 ͈̔͊Oł'
	error	0,ilquickerr_sftrot
	error	1,ilsfterr,		'VtgE[e[g̃JEg 1`8 ͈̔͊Oł'
	error	1,featureerr_cpu,	'Ή cpu ł'
	error	1,featureerr_xref,	'OQƒl̖ߍ݂͂ł܂'
	error	1,nosymerr_macro,	'}N܂'
	error	1,nosymerr_pseudo,	'%s Œ`V{܂'
	error	1,tooinclderr,		'.include ̃lXg[܂'
	error	1,nofileerr,		'%s t@C܂'
	error	1,mismacerr_exitm,	'}NWJł͂Ȃ̂ %s ܂'
	error	0,mismacerr_endm
	error	0,mismacerr_local
	error	1,mismacerr_sizem,	'}N`ł͂Ȃ̂ %s ܂'
	error	1,mismacerr_eof,	'.endm ܂'
	error	1,toomanylocsymerr,	'1 ̃}N̒̃[JV{܂'
	error	1,macnesterr,		'}ÑlXg[܂'
	error	0,misiferr_else
	error	0,misiferr_elseif
	error	1,misiferr_endif,	'%s ɑΉ .if ܂'
	error	1,misiferr_else_elseif,	'.else ̌ .elseif ܂'
	error	1,misiferr_eof,		'.endif ܂'
	error	1,termerr_doublequote,	'"`"Ă܂'
	error	1,termerr_singlequote,	"'`'Ă܂"
	error	1,termerr_bracket,	'<`>Ă܂'
	error	1,ilinterr,		'̋LqԈĂ܂'
	error	1,offsymalignerr,	'.offsym  %s ͎wł܂'
	.endm

error	.macro	cnt,lab,str
lab::
  .if cnt+0
	moveq.l	#n,d0
n = n+(cnt+0)
	bra	errout
  .endif
	.endm

n = 0
	errtbl

errout::
	move.l	(ERRMESSYM,a6),d3
errout_d3::
	cmpi.b	#3,(ASMPASS,a6)
	beq	errout9			;pX3ȊOł̓G[bZ[Wo͂Ȃ
	or.w	#T_ERROR,d0		;T_ERROR|G[ԍ
	bsrl	wrtobjd0w,d2		;t@CɃG[R[ho
	move.w	(ERRMESSYM+0,a6),d0
	bsrl	wrtobjd0w,d2		;G[bZ[WɖߍރV{
	move.w	(ERRMESSYM+2,a6),d0
	bsrl	wrtobjd0w,d2
	bra	errout91		;pX3ł̓e|R[ho͂Kv͂Ȃ

errout9:
	add.w	d0,d0			;G[ԍ~2
	move.w	(err_msg_tbl,pc,d0.w),d0
	lea.l	(err_msg_tbl,pc,d0.w),a2
	moveq.l	#1,d1
	bsr	printerr
errout91:
	addq.w	#1,(NUMOFERR,a6)
	movea.l	(SPSAVE,a6),sp
	move.l	(ERRRET,a6),-(sp)
	rts				;G[畜A

error	.macro	cnt,lab,str
  .if cnt+0
	.dc.w	m_&lab-err_msg_tbl
  .endif
	.endm

err_msg_tbl:
	errtbl

error	.macro	cnt,lab,str
  .if cnt+0
m_&lab:
	.dc.b	str,0
  .endif
	.endm

	errtbl
	.even

;----------------------------------------------------------------
;	G[E[jObZ[Wo͂
;<d1.w:0='Warning',1='Error'
;<d3.l:(ERRMESSYM,a6),%s郁bZ[Włd3=0͕s
;<a2.l:bZ[Wւ̃|C^
printerr:
	link	a5,#-128
	movem.l	d0/d3/a0-a1,-(sp)
	lea.l	(-128,a5),a0
	movea.l	(INPFILE,a6),a1		;t@Cւ̃|C^
	moveq.l	#16,d0
printerr1:
	subq.w	#1,d0
	move.b	(a1)+,(a0)+		;t@C]
	bne	printerr1
	subq.l	#1,a0
	tst.w	d0
	bmi	printerr3
printerr2:
	move.b	#' ',(a0)+		;]Xy[XŖ߂
	dbra	d0,printerr2
printerr3:
	move.b	#' ',(a0)+
	move.w	d1,-(sp)
	move.l	(LINENUM,a6),d0
	moveq.l	#5,d1			;(5Ń[TvX)
	cmp.l	#100000,d0
	bcs	printerr4
	moveq.l	#0,d1			;6ȏɂȂȂ獶l
printerr4:
	move.l	d2,-(sp)
	bsrl	convdec,d2		;sԍ
	move.l	(sp)+,d2
	move.w	(sp)+,d1
	lea.l	(warn_msg,pc),a1
	tst.w	d1
	beq	printerr5
	lea.l	(error_msg,pc),a1
printerr5:
	bsr	strcpy
	movea.l	a2,a1
	bra	printerr51

printerr50:
	move.b	d0,(a0)+
printerr51:
	move.b	(a1)+,d0
	beq	printerr53
	cmp.b	#'%',d0
	bne	printerr50
	cmpi.b	#'s',(a1)
	bne	printerr50
	addq.l	#1,a1
	exg.l	d3,a1
	cmpi.b	#ST_OPCODE,(SYM_TYPE,a1)
	bne	printerr52		;߂łȂ
	tst.w	(SYM_ARCH,a1)
	bne	printerr52		;^߂łȂ
	move.b	#'.',(a0)+		;^߂̐擪'.'t
printerr52:
	movea.l	(SYM_NAME,a1),a1
	bsr	strcpy
	movea.l	d3,a1
	bra	printerr51

printerr53:
  .if UNIX_NEWLINE=0
	move.b	#CR,(a0)+
  .endif
	move.b	#LF,(a0)+
	clr.b	(a0)
printerr6:
	lea.l	(-128,a5),a0
	bsrl	prnstdout,d0		;WóEPRNt@CɃG[bZ[W\
	movem.l	(sp)+,d0/d3/a0-a1
	unlk	a5
	rts

strcpy:
	move.b	(a1)+,(a0)+
	bne	strcpy
	subq.l	#1,a0
	rts

;----------------------------------------------------------------
;	G[E[jObZ[W
warn_msg:	.dc.b	': Warning: ',0
error_msg:	.dc.b	': Error: ',0

crlf_msg::	.dc.b	CRLF,0
	.even


;----------------------------------------------------------------
	.end

;----------------------------------------------------------------
;	$Log: error.s,v $
;	Revision 2.3  1999 10/ 8(Fri) 21:04:21 M.Kamada
;	+86 ilsymerrו
;	+86 ilsizeerrו
;	+86 sR[h̕ύXɑΉ
;	+86 EUCΉ
;	+86 '%s ɊOQƒl͎wł܂'
;	+86 foo fequ foõG[bZ[W
;
;	Revision 2.2  1999  6/ 9(Wed) 23:37:52 M.Kamada
;	+85 .offsymŃV{w肪Ƃ.even/.quad/.alignG[ɂ
;	+85 .ds̈̂Ƃ.text/.dataZNVł̓G[,̑̓[jO
;
;	Revision 2.1  1999  4/24(Sat) 03:14:35 M.Kamada
;	+84 }Ñ[JV{ƃoXG[osC
;
;	Revision 2.0  1999  3/16(Tue) 03:46:21 M.Kamada
;	+83 G[bZ[W̋^߂̐擪'.'t
;	+83 u[Jx̎QƂsłvǉ
;
;	Revision 1.9  1999  3/ 6(Sat) 21:50:58 M.Kamada
;	+82 G[bZ[W{ꉻ
;	+82 ^߂̃p[^ꍇ̃G[`FbN
;	+82 error.s̍\ύX
;
;	Revision 1.8  1999  2/27(Sat) 23:39:49 M.Kamada
;	+81 \[XXg̃tH[}bgύX(st@C+80Ƃ܂)
;
;	Revision 1.7  1998  3/30(Mon) 21:37:41 M.Kamada
;	+61 warning: insignificant bitǉ
;
;	Revision 1.6  1998  1/10(Sat) 15:44:52 M.Kamada
;	+56 MOVE to USP̃Gb^
;
;	Revision 1.5  1997 10/29(Wed) 21:51:23 M.Kamada
;	+52 Lqꂽ64bit𒴂G[
;	+52 misc.s̑ΌĂяoO
;	+52 strcpy
;
;	Revision 1.4  1997  9/14(Sun) 16:25:55 M.Kamada
;	+46 error.s𕪗
;
;	Revision 1.3  1997  3/20(Thu) 15:52:18 M.Kamada
;	+23 terminator not foundG[
;
;	Revision 1.2  1996 12/15(Sun) 14:13:22 M.Kamada
;	+02 68060Ή
;		\tgEFAG~[Ṽ[jOǉ
;	+07 F43G΍
;		F43G΍̃[jOǉ
;
;	Revision 1.1  1994/02/13  14:10:18  nakamura
;	Initial revision
;
;
