;----------------------------------------------------------------
;	X68k High-speed Assembler
;		}NWJ
;		< macro.s >
;
;	$Id: macro.s,v 2.2  1999 10/ 8(Fri) 21:51:41 M.Kamada Exp $
;
;		Copyright 1990-94  by Y.Nakamura
;		          1997-99  by M.Kamada
;----------------------------------------------------------------

	.include	has.equ
	.include	cputype.equ
	.include	register.equ
	.include	tmpcode.equ
	.include	symbol.equ

	.cpu	68000
	.text


;----------------------------------------------------------------
;	}N`^߂̃AZu
;----------------------------------------------------------------

;----------------------------------------------------------------
;	<V{>	macro	[<Xg>]
~~macro::
	move.b	(a0),d0
	cmp.b	#'*',d0
	beq	~~macro1
	cmp.b	#';',d0			;g[h̃Rg
	bne	~~macro2
~~macro1:				;Xg̈ʒuɃRgꍇ
	tst.b	(a0)+
	bne	~~macro1
	subq.l	#1,a0
	move.l	a0,(LINEPTR,a6)
~~macro2:
	move.w	(LABNAMELEN,a6),d1
	bmi	nosymerr_macro		;}NȂ
	move.w	#-1,(LABNAMELEN,a6)	;`̂Ńx
	movea.l	(LABNAMEPTR,a6),a0
	bsr	isdefdmac
	tst.w	d0
	beq	~~macro5
	bsr	defmacsymbol		;Vo^
~~macro5:
	move.w	#T_MACDEF,d0
	bsr	wrtobjd0w
	move.l	a1,d0			;V{ւ̃|C^
	bsr	wrtd0l
	move.l	(TEMPPTR,a6),d0
	bsr	wrtd0l			;`eւ̃|C^
	move.l	d0,(SYM_DEFINE,a1)
	move.l	a1,(MACSYMPTR,a6)
	movea.l	(LINEPTR,a6),a0
	lea.l	(LOCSYMBUF,a6),a1	;(}NXgo^obt@)
	bsr	defpara			;}NXg̓o^
	move.l	a1,(MACDEFEND,a6)
	clr.w	(MACLOCSNO,a6)
	clr.b	(MACMODE,a6)		;`̂̓}N
	bra	defmacro		;}N`̃C[`

;----------------------------------------------------------------
;	exitm
~~exitm::
	tst.w	(MACNEST,a6)
	beq	mismacerr_exitm		;}NWJłȂ΃G[
	move.w	#T_EXITM,d0
	bsr	wrtobjd0w
	bra	macexexitm		;WJ̃}NI

;----------------------------------------------------------------
;	endm
~~endm::				;(~~endm != ~~localɂ)
	bra	mismacerr_endm		;}N`[`Oł̓G[

;----------------------------------------------------------------
;	local	<V{>[,<V{>,c]
~~local::
	bra	mismacerr_local		;}N`[`Oł̓G[

;----------------------------------------------------------------
;	sizem	<V{>
~~sizem::
	bra	mismacerr_sizem		;}N`[`Oł̓G[


;----------------------------------------------------------------
;	g^߂̃AZu
;----------------------------------------------------------------

;----------------------------------------------------------------
;	.rept	<>
~~rept::
	bsr	deflabel		;sɃx`Ă
	bsr	calcconst
	tst.l	d1			;JԂ(1`65535)
	beq	~~reptskip
	cmp.l	#$10000,d1
	bcc	ilvalueerr
	move.l	(TEMPPTR,a6),-(sp)
	move.w	d1,-(sp)
	move.b	#-1,(MACMODE,a6)
	bsr	defmacro		;JԂs̓eǂݍ
	move.w	#T_REPT,d0
	bsr	wrtobjd0w
	move.w	(sp),d0			;JԂ
	bsr	wrtd0w
	move.l	(2,sp),d0		;JԂeւ̃|C^
	bsr	wrtd0l
	move.w	(sp)+,d0
	move.l	(sp)+,a0
	suba.l	a1,a1
	bra	exmacsetup		;̍sreptJn

~~reptskip:				;0̌JԂJԂsXLbv
	move.b	#-1,(MACMODE,a6)
	bra	defmacro		;JԂs̓eǂݍ

;----------------------------------------------------------------
;	.irp	<>,<>[,<>c]
~~irp0:
	tst.b	(a0)
	beq	iloprerr		;Ȃ
	lea.l	(LOCSYMBUF,a6),a1	;(Xgo^obt@)
	st.b	(a1)+			;$FF $00 $01
	sf.b	(a1)+
	move.b	#$01,(a1)+
	bsr	getpara			;𓾂
	clr.b	(a1)
	tst.w	d0
	beq	~~irp00			;Ȃ
	moveq.l	#0,d1
	movea.l	(TEMPPTR,a6),a1
	rts

~~irp00:
	addq.l	#4,sp			;(X^bN␳)
	bra	~~reptskip

~~irp::
	bsr	deflabel		;sɃx`Ă
	bsr	~~irp0			;𓾂
	move.l	a1,-(sp)
~~irp1:
	addq.w	#1,d1
	bsr	getmacpara		;Xg𓾂
	tst.w	d0
	bne	~~irp1
~~irp2:
	move.l	a1,(TEMPPTR,a6)
	move.l	a1,-(sp)
	move.w	d1,-(sp)		;̐
	move.b	#1,(MACMODE,a6)
	bsr	defmacro		;JԂs̓eǂݍ
	move.w	#T_IRP,d0
	bsr	wrtobjd0w
	move.w	(sp),d0			;JԂ
	bsr	wrtd0w
	move.l	(6,sp),d0		;Xgւ̃|C^
	bsr	wrtd0l
	move.l	(2,sp),d0		;JԂeւ̃|C^
	bsr	wrtd0l
	move.w	(sp)+,d0
	movea.l	(sp)+,a0
	movea.l	(sp)+,a1
	bra	exmacsetup		;̍sirp/irpcJn

;----------------------------------------------------------------
;	.irpc	<>,<>
~~irpc::
	bsr	deflabel		;sɃx`Ă
	bsr	~~irp0
	move.l	a1,-(sp)

	moveq.l	#0,d1
	move.b	(a0)+,d2
	cmp.b	#'"',d2
	beq	~~irpc1
	cmp.b	#"'",d2
	beq	~~irpc1
	moveq.l	#0,d2
	subq.l	#1,a0
~~irpc1:				;𕶎Ƃɕ
	move.b	(a0)+,d0
	bmi	~~irpc3
	beq	~~irpc8
	cmp.b	d0,d2
	beq	~~irpc9
	tst.b	d2
	bne	~~irpc2			;('`' / "`" Ɉ͂܂ꂽXy[X͎)
	cmp.b	#' ',d0
	bls	~~irpc9
~~irpc2:
	move.b	d0,(a1)+
	clr.b	(a1)+
	addq.w	#1,d1
	bra	~~irpc1

~~irpc3:
  .if EUCSRC=0
	cmp.b	#$E0,d0
	bcc	~~irpc4
	cmp.b	#$A0,d0
	bcc	~~irpc2			;pJ^Ji
  .else
	bra	~~irpc2			;EUC
  .endif
~~irpc4:				;2oCg
	addq.w	#1,d1
	move.b	d0,(a1)+
	move.b	(a0)+,(a1)+		;2oCg2oCg
	beq	~~irpc8
	clr.b	(a1)+
	bra	~~irpc1

~~irpc8:
	tst.b	d2
	bne	~~irpc91
~~irpc9:
	tst.w	d1
	beq	~~irp00			;Ȃ
	bra	~~irp2

~~irpc91:
;'`'"`"ĂȂ
	cmp.b	#"'",d2
	beq	termerr_singlequote
	bra	termerr_doublequote


;----------------------------------------------------------------
;	}N/rept/irp/irpc߂̓o^
;----------------------------------------------------------------
;}ÑTCYwi[郍[JV{.sizem^߂œo^.
;.sizem.localƂقړ,}N̓Ŏgp\,XV\.
;}No^̎_.sizem[JV{ԍ$FFFFœo^.
;}NWJ̎_.sizem̃[JV{΂ɃTCYi[.
;}N̈̌o^郍[JV{̃[JV{ԍ$FFFE
defmacro:
	move.w	#T_MDEFBGN,d0		;}N`Jn
	bsr	wrtobjd0w
	st.b	(ISIFSKIP,a6)		;G[`FbN͂Ȃ
	st.b	(ISMACDEF,a6)
	clr.w	(REPTSKIPNEST,a6)
defmacro1:
	bsr	getline			;1sǂݍ
	tst.w	d0
	bmi	defmacro9		;`Ƀ\[XIĂ܂
	or.w	#T_LINE,d0		;1sJn
	bsr	wrtobjd0w
	bsr	encodeline		;x̏Ɩ߂̃R[h
	tst.b	(ISMACRO,a6)
	bne	defmacro2		;}N
	move.l	(CMDTBLPTR,a6),d0
	beq	defmacro2		;߂Ȃ
	movea.l	d0,a1
	move.l	(SYM_FUNC,a1),a1
	lea.l	(~~macro,pc),a2
	cmpa.l	a1,a2
	beq	defmacnest
	lea.l	(~~endm,pc),a2
	cmpa.l	a1,a2
	beq	defmacend
	lea.l	(~~local,pc),a2
	cmpa.l	a1,a2
	beq	defmaclocal
	lea.l	(~~sizem,pc),a2
	cmpa.l	a1,a2
	beq	defmacsizem
	lea.l	(~~rept,pc),a2
	cmpa.l	a1,a2
	beq	defmacnest
	lea.l	(~~irp,pc),a2
	cmpa.l	a1,a2
	beq	defmacnest
	lea.l	(~~irpc,pc),a2
	cmpa.l	a1,a2
	beq	defmacnest
defmacro2:
	bsr	defmacline		;}Ns1s̃R[huEo^
	bra	defmacro1

;----------------------------------------------------------------
;	`Ƀ\[XIĂ܂
defmacro9:
	st.b	(ISASMEND,a6)		;I
defmacro99:
	move.w	#T_MDEFEND,d0		;}N`I
	bsr	wrtobjd0w
	sf.b	(ISIFSKIP,a6)
	sf.b	(ISMACDEF,a6)
	bra	mismacerr_eof

;----------------------------------------------------------------
;	macro/rept/irp/irpcɂ`̃lXg
defmacnest:
;REPTSKIPNEST𑝂₷OɃlXg̊JnsWJĂȂ,
;lXg̊JnsɃ[JxƂɍ
	bsr	defmacline		;}Ns1s̃R[huEo^
	addq.w	#1,(REPTSKIPNEST,a6)
	bra	defmacro1

;----------------------------------------------------------------
;	endm
defmacend:
	subq.w	#1,(REPTSKIPNEST,a6)
	bcc	defmacro2		;lXeBOĂreptɑΉendm
defmacend1:
	movea.l	(TEMPPTR,a6),a0
	st.b	(a0)+			;IR[h $FF $00 $00
	sf.b	(a0)+
	sf.b	(a0)+
	move.l	a0,(TEMPPTR,a6)
	sf.b	(ISIFSKIP,a6)
	tst.b	(MACMODE,a6)
	bne	defmacend9		;rept/irp/irpc`̏ꍇ
	movea.l	(MACSYMPTR,a6),a0
	move.w	(MACLOCSNO,a6),(SYM_MACLOCS,a0)	;[JV{̐
defmacend9:
	move.w	#-1,(LABNAMELEN,a6)	;endmsɃx疳
	move.w	#T_MDEFEND,d0		;}N`I
	bsr	wrtobjd0w
	sf.b	(ISMACDEF,a6)
	rts

;----------------------------------------------------------------
;	local	<V{>[,<V{>,c]
defmaclocal:
	tst.b	(MACMODE,a6)
	bne	defmacro2		;rept/irp/irpco^͖
	movea.l	(LINEPTR,a6),a0
	movea.l	(MACDEFEND,a6),a1
	move.l	a6,d0
	add.l	#LOCSYMBUF+LOCSYMBUFSIZE,d0
	cmpa.l	d0,a1
	bcc	defmac_locsymover
	tst.b	(a0)
	beq	defmaclocal9		;XgȂ
defmaclocal1:
	move.b	#$FE,(a1)+		;([JV{}[N)
	addq.w	#1,(MACLOCSNO,a6)
	move.b	(MACLOCSNO,a6),(a1)+	;high
	move.b	(MACLOCSNO+1,a6),(a1)+	;low
	bsr	getpara			;$FE [[JV{ԍhigh,low] p[^` $00
	tst.w	d0
	bne	defmaclocal1
defmaclocal9:
	clr.b	(a1)
	move.l	a1,(MACDEFEND,a6)
	bra	defmacro1

;----------------------------------------------------------------
;1̃}N̒̃[JV{ēo^łȂƂ
defmac_locsymover:
	st.b	(ISASMEND,a6)		;I
	move.w	#T_MDEFEND,d0		;}N`I
	bsr	wrtobjd0w
	sf.b	(ISIFSKIP,a6)
	sf.b	(ISMACDEF,a6)
	bra	toomanylocsymerr

;----------------------------------------------------------------
;	sizem	<V{>
defmacsizem:
	tst.b	(MACMODE,a6)
	bne	defmacro2		;rept/irp/irpco^͖
	movea.l	(LINEPTR,a6),a0
	movea.l	(MACDEFEND,a6),a1
	move.l	a6,d0
	add.l	#LOCSYMBUF+LOCSYMBUFSIZE,d0
	cmpa.l	d0,a1
	bcc	defmac_locsymover
	tst.b	(a0)
	beq	defmacsizem9		;XgȂ
	move.b	#$FE,(a1)+		;([JV{}[N)
;.sizem̃V{??xxxxɂȂȂ̂MACLOCSNO(a6)𑝂₳ȂĂ悢
	st.b	(a1)+			;TCYp̃[JV{
	st.b	(a1)+
	bsr	getpara			;$FE $FF $FF p[^` $00
	tst.w	d0
	beq	defmacsizem8		;2Ȃ
	move.b	#$FE,(a1)+		;([JV{}[N)
;.sizem̃V{??xxxxɂȂȂ̂MACLOCSNO(a6)𑝂₳ȂĂ悢
	st.b	(a1)+			;̌p̃[JV{
	move.b	#$FE,(a1)+
	bsr	getpara			;$FE $FF $FE p[^` $00
defmacsizem8:
					;]vȃp[^͖
defmacsizem9:
	clr.b	(a1)
	move.l	a1,(MACDEFEND,a6)
	bra	defmacro1

;----------------------------------------------------------------
;	}Ns1s̃R[huEo^
defmacline:
	lea.l	(LINEBUF,a6),a0
	movea.l	(TEMPPTR,a6),a2
	tst.b	(MACMODE,a6)
	bpl	defmacline1
defmacline0:
	move.b	(a0)+,(a2)+		;repto^Ȃs̓e]̂
	bne	defmacline0
	move.l	a2,(TEMPPTR,a6)
	bra	memcheck

defmacline1:
	move.b	(a0),d0
	beq	defmacline9		;sI
	cmp.b	#"'",d0
	beq	defmacstr
	cmp.b	#'"',d0
	beq	defmacstr
	cmp.b	#'&',d0
	bne	defmacline2
	addq.l	#1,a0
	cmp.b	#'&',(a0)
	bne	defmacline1
	move.b	(a0)+,(a2)+		;'&&''&'
	bra	defmacline1

defmacline2:
	lea.l	(LOCSYMBUF,a6),a4	;(Xgo^obt@)
	movea.l	a0,a3
defmacline3:
	movea.l	a3,a0
	move.b	(a4)+,d3		;$FF()/$FE([JV{)
	beq	defmacline7
	move.b	(a4)+,d4		;/[JV{ԍ
	lsl.w	#8,d4
	move.b	(a4)+,d4		;[JV{ԍlow
;macro̒reptƂ̂ŏȗ
;	tst.w	REPTSKIPNEST(a6)
;	beq	defmacline4		;lXgĂȂ
;	cmpi.b	#'@',(a4)		;macrolXgĂƂ@`͒uȂ
;	beq	defmacline5
defmacline4:
	bsr	getword			;o^Ă鉼Ɣr
defmacline41:
	cmpm.b	(a0)+,(a4)+
	dbne	d1,defmacline41
	bne	defmacline5
	tst.b	(a4)
	bne	defmacline4		;(2ȏ̉)
	move.b	d3,(a2)+		;uׂ
	ror.w	#8,d4
	move.b	d4,(a2)+
	rol.w	#8,d4
	move.b	d4,(a2)+
	bra	defmacline1

defmacline5:
	subq.l	#1,a4
defmacline6:
	tst.b	(a4)+
	bne	defmacline6
	bra	defmacline3

defmacline7:				;uׂȂ
	bsr	getword
	tst.b	(MACMODE,a6)
	bne	defmacline8		;rept/irp/irpco^͖
;macro̒reptƂ̂ŏȗ
;	tst.w	REPTSKIPNEST(a6)
;	bne	defmacline8		;lXg̓̒`͖
	cmpi.b	#'@',(a0)
	bne	defmacline8		;@Ŏn܂ĂȂ
	move.b	(1,a0),d0		;2
	cmp.b	#'@',d0
	beq	defmacline8		;@@`(3ȏłLZ邱)
	cmp.w	#1,d1			;P̒-1(PꂪȂƂ0)
	blo	defmacline8		;1Ȃ
	bhi	defmacline71		;3ȏ
	or.b	#$20,d0			;@Ŏn܂2̂Ƃ2ڂmF
	cmp.b	#'b',d0
	beq	defmacline8		;@b
	cmp.b	#'f',d0
	beq	defmacline8		;@f
defmacline71:
;@`[JV{ƃ}N̖{̂ɓo^
	movea.l	(MACDEFEND,a6),a1
	move.l	a6,d0
	add.l	#LOCSYMBUF+LOCSYMBUFSIZE,d0
	cmpa.l	d0,a1
	bcc	defmac_locsymover
	moveq.l	#$FE,d0			;([JV{}[N)
	move.b	d0,(a1)+		;[JV{ɓo^
	move.b	d0,(a2)+		;}N̖{̂ɓo^
	addq.w	#1,(MACLOCSNO,a6)
	move.b	(MACLOCSNO,a6),(a1)+	;[JV{ԍ
	move.b	(MACLOCSNO+1,a6),(a1)+
	move.b	(MACLOCSNO,a6),(a2)+	;[JV{ԍ
	move.b	(MACLOCSNO+1,a6),(a2)+
defmacline72:
	move.b	(a0)+,(a1)+		;@`
	dbra	d1,defmacline72
	clr.b	(a1)+
	clr.b	(a1)
	move.l	a1,(MACDEFEND,a6)
	bra	defmacline1

defmacline8:
	move.b	(a0)+,(a2)+
	dbra	d1,defmacline8
	bra	defmacline1

defmacline9:				;sI
	clr.b	(a2)+
	move.l	a2,(TEMPPTR,a6)
	bra	memcheck

defmacstr:				;̏
	move.b	d0,d1
	move.b	(a0)+,(a2)+
defmacstr1:
	move.b	(a0)+,d0
	beq	defmacline9		;̓rōsI
	bmi	defmacstr10
	cmp.b	#'&',d0
	beq	defmacstr3
	move.b	d0,(a2)+
	cmp.b	d0,d1
	bne	defmacstr1
	bra	defmacline1		;񂪏I

defmacstr3:				;񒆂'&`'͒ȗΏۂƂ
	lea.l	(LOCSYMBUF,a6),a1	;(Xgo^obt@)
defmacstr4:
	move.b	(a1)+,d2		;$FF()/$FE([JV{)
	beq	defmacstr8
	move.b	(a1)+,d3		;/[JV{ԍhigh
	lsl.w	#8,d3
	move.b	(a1)+,d3		;low
	movea.l	a0,a3
defmacstr5:				;o^Ă鉼Ɣr
	move.b	(a1)+,d0
	beq	defmacstr9
	cmp.b	(a3)+,d0
	beq	defmacstr5
defmacstr6:
	tst.b	(a1)+
	bne	defmacstr6
	bra	defmacstr4

defmacstr8:				;uׂȂ
	move.b	#'&',(a2)+
	bra	defmacstr1

defmacstr9:				;uׂ
	move.b	d2,(a2)+
	ror.w	#8,d3
	move.b	d3,(a2)+		;high
	rol.w	#8,d3
	move.b	d3,(a2)+		;low
	movea.l	a3,a0
	bra	defmacstr1

defmacstr10:
	move.b	d0,(a2)+
  .if EUCSRC=0
	cmp.b	#$E0,d0
	bcc	defmacstr11
	cmp.b	#$A0,d0
	bcc	defmacstr1		;pJȉꍇ
  .else
	bra	defmacstr1		;EUC
  .endif
defmacstr11:
	move.b	(a0)+,d0		;2oCg2oCg
	beq	defmacline9		;2oCgڂ$00̏ꍇ
	move.b	d0,(a2)+
	bra	defmacstr1


;----------------------------------------------------------------
;	}N߂̃AZu
;----------------------------------------------------------------
domacro::
	move.w	#T_MACEXT,d0
	move.b	(CMDOPSIZE,a6),d0	;Iy[VTCY
	bsr	wrtobjd0w		;}NWJJn
	movea.l	(CMDTBLPTR,a6),a1
	move.l	a1,d0
	bsr	wrtd0l			;V{e[uւ̃|C^
	move.l	(LINEPTR,a6),d0
	lea.l	(LINEBUF,a6),a0
	sub.l	a0,d0
	bsr	wrtd0w			;ւ̃ItZbg
	move.l	a1,-(sp)
	movea.l	(SYM_DEFINE,a1),a0	;`eւ̃|C^
	clr.w	d0
	bsr	exmacsetup		;}NWJ
	movea.l	(sp)+,a1
	move.b	(CMDOPSIZE,a6),(MACSIZE,a6)	;Iy[VTCY
	move.w	(SYM_MACLOCS,a1),d0
	add.w	d0,(MACLOCSMAX,a6)
	movea.l	(LINEPTR,a6),a0
	movea.l	(MACPARAEND,a6),a1
	bsr	defmacpara		;}NXg̓o^
	move.l	a1,(MACPARAEND,a6)
	rts


;----------------------------------------------------------------
;	}NߓWJ
;----------------------------------------------------------------

;----------------------------------------------------------------
;	}NWJ̏
;	in :d0.w=JԂ(0Ȃ}N)
;	    a0=o^sւ̃|C^/a1=Xgւ̃|C^(irp/irpcWJ̏ꍇ)
exmacsetup::
	move.w	(MACREPTNEST,a6),d1
	cmp.w	#MACROMAXNEST,d1
	bcc	exmacsetup9		;}ÑlXg[
	tst.w	d1
	bne	exmacsetup1
	lea.l	(MACINF,a6),a2		;ŏ̃}NWJ̏ꍇ
	move.l	a2,(MACINFPTR,a6)
	lea.l	(MACPARABUF,a6),a2
	move.l	a2,(MACPARAPTR,a6)
	move.l	a2,(MACPARAEND,a6)
	clr.b	(a2)
exmacsetup1:
	movea.l	(MACINFPTR,a6),a2	;܂ł̏ۑ
	move.l	(MACLBGNPTR,a6),(a2)+	;	WJJns|C^
	move.l	(MACLPTR,a6),(a2)+	;	݂̓WJs|C^
	move.l	(MACPARAPTR,a6),(a2)+	;	obt@|C^
	move.w	(MACLOCSBGN,a6),(a2)+	;	[JV{Jnԍ
	move.w	(IFNEST,a6),(a2)+	;	iflXeBOx
	move.w	(REPTCOUNT,a6),(a2)+	;	JԂ
	move.l	(IRPPARAPTR,a6),(a2)+	;	irp/irpcXg|C^
	move.b	(MACSIZE,a6),(a2)+	;
	move.b	(MACCOUNT,a6),(a2)+	;
	move.l	a2,(MACINFPTR,a6)
	move.l	a0,(MACLPTR,a6)		;}N`sւ̃|C^
	move.l	a0,(MACLBGNPTR,a6)
	addq.w	#1,(MACREPTNEST,a6)
	move.l	(MACPARAEND,a6),(MACPARAPTR,a6)
	move.w	(MACLOCSMAX,a6),(MACLOCSBGN,a6)
	move.w	d0,(REPTCOUNT,a6)
	beq	exmacsetup3
exmacsetup2:
	move.l	a1,d0
	bne	exmacsetup4
	rts				;reptWJ̏ꍇ

exmacsetup3:				;}NWJ̏ꍇ
	addq.w	#1,(MACNEST,a6)
	rts

exmacsetup4:				;irp/irpcWJ̏ꍇ
	movea.l	(MACPARAPTR,a6),a0
	st.b	(a0)+			;()$FF $00 $01
	sf.b	(a0)+
	move.b	#$01,(a0)+
	bsr	strcpy			;Xg1
	move.l	a1,(IRPPARAPTR,a6)
	addq.l	#1,a0
	clr.b	(a0)
	move.l	a0,(MACPARAEND,a6)
	rts

exmacsetup9:				;}NWJ𒆎~ăG[
	clr.w	(MACREPTNEST,a6)
	clr.w	(MACNEST,a6)
	bra	macnesterr

;----------------------------------------------------------------
;	exitm߂̏
macexexitm0:
	bsr	macexexit		;܂łɃlXgĂrept𔲂Ă
macexexitm::
	tst.w	(REPTCOUNT,a6)
	bne	macexexitm0

;----------------------------------------------------------------
;	WJ̃}ÑlXeBO1i󂭂
macexexit:
	movea.l	(MACINFPTR,a6),a0
	tst.w	(REPTCOUNT,a6)
	bne	macexexit1
	subq.w	#1,(MACNEST,a6)
macexexit1:
	movea.l	(MACPARAPTR,a6),a1
	move.l	a1,(MACPARAEND,a6)
	clr.b	(a1)
	move.b	-(a0),(MACCOUNT,a6)
	move.b	-(a0),(MACSIZE,a6)
	move.l	-(a0),(IRPPARAPTR,a6)
	move.w	-(a0),(REPTCOUNT,a6)
	move.w	-(a0),(IFNEST,a6)
	move.w	-(a0),(MACLOCSBGN,a6)
	move.l	-(a0),(MACPARAPTR,a6)
	move.l	-(a0),(MACLPTR,a6)
	move.l	-(a0),(MACLBGNPTR,a6)
	move.l	a0,(MACINFPTR,a6)
	subq.w	#1,(MACREPTNEST,a6)
	rts

;----------------------------------------------------------------
;	}N`s1sǂݍݓWJ
macexline::
	movem.l	d1-d3/a0-a2,-(sp)
	movea.l	(MACLPTR,a6),a2
	lea.l	(LINEBUF,a6),a0
	moveq.l	#0,d3
macexline1:
	move.b	(a2)+,d0
	beq	macexline9
	bmi	macexline5
	tst.b	d3
	beq	macexline3
	cmp.b	d0,d3
	bne	macexline2
	moveq.l	#0,d3
macexline2
	move.b	d0,(a0)+
	bra	macexline1

macexline3:
	cmp.b	#'%',d0
	beq	macexlsym		;V{l
	cmp.b	#"'",d0
	beq	macexline4
	cmp.b	#'"',d0
	bne	macexline2
macexline4:
	move.b	d0,d3
	bra	macexline2

macexline5:
	cmp.b	#$FF,d0
	beq	macexlpara		;,IR[h
	cmp.b	#$FE,d0
	beq	macexllocs		;[JV{
	move.b	d0,(a0)+
  .if EUCSRC=0
	cmp.b	#$E0,d0
	bcc	macexline6
	cmp.b	#$A0,d0
	bcc	macexline1
  .else
	bra	macexline1		;EUC
  .endif
macexline6:				;2oCg̏ꍇ
	move.b	(a2)+,(a0)+
	bne	macexline1
	subq.l	#1,a0
macexline9:
	clr.b	(a0)+
	move.l	a2,(MACLPTR,a6)
	movem.l	(sp)+,d1-d3/a0-a2
	moveq.l	#0,d0
	rts

macexlendm:				;}N`s̏I
	move.w	(REPTCOUNT,a6),d0
	beq	macexlendm1
	subq.w	#1,d0
	beq	macexlendm1
	move.w	d0,(REPTCOUNT,a6)
	move.l	(MACLBGNPTR,a6),(MACLPTR,a6)	;rept̎̌JԂ
	movea.l	(IRPPARAPTR,a6),a1
	bsr	exmacsetup2		;irp/irpcȂ玟̎
	bra	macexlendm2

macexlendm1:
	bsr	macexexit		;}ÑlXeBO1i󂭂Ȃ
macexlendm2:
	movem.l	(sp)+,d1-d3/a0-a2
	moveq.l	#-1,d0
	rts

macexlpara:				;
	move.b	(a2)+,d1		;high
	lsl.w	#8,d1
	move.b	(a2)+,d1		;low
	tst.w	d1
	beq	macexlendm		;endms̏ꍇ
	bsr	macexlpara0
	tst.b	d0
	beq	macexline1		;ΉȂ
	bsr	strcpy			;̓e]
	bra	macexline1

macexlpara0:				;XgΉ
	movem.l	d1-d2,-(sp)
	move.b	d1,d2			;low
	lsr.w	#8,d1			;high
	movea.l	(MACPARAPTR,a6),a1
	bra	macexlpara2

macexlpara05:
	addq.l	#1,a1
macexlpara1:				;̎
	tst.b	(a1)+
	bne	macexlpara1
macexlpara2:
	move.b	(a1)+,d0
	beq	macexlpara3		;XgI
	cmp.b	(a1)+,d1		;high
	bne	macexlpara05
	cmp.b	(a1)+,d2		;low
	bne	macexlpara1		;ԍႤ
macexlpara3:
	movem.l	(sp)+,d1-d2
	rts

macexllocs:				;[JV{
	move.b	(a2)+,d0		;high
	lsl.w	#8,d0
	move.b	(a2)+,d0		;low
	cmp.w	#$FFFE,d0
	bcc	macexllocs3
	move.b	#'?',(a0)+		;V{'??xxxx'(xxxx=416i)ɒu
	move.b	#'?',(a0)+
	add.w	(MACLOCSBGN,a6),d0
	bsr	convhex4
	bra	macexline1

macexllocs3:
	bne	macexllocs1
	moveq.l	#0,d0
	move.b	(MACCOUNT,a6),d0
	moveq.l	#0,d1			;(l)
	bsr	convdec
	bra	macexline1

macexllocs1:
	clr.w	d0
	move.b	(MACSIZE,a6),d0
	bpl	macexllocs2
	move.b	#' ',(a0)+		;TCYwȂ
	move.b	#' ',(a0)+
	bra	macexline1

macexllocs2:
	move.b	#'.',(a0)+		;TCYw肠
	move.b	(macexllocs9,pc,d0.w),(a0)+
	bra	macexline1

macexllocs9:
	.dc.b	'bwlsdxpq'
	.even

macexlsym:				;V{l
	exg.l	a0,a2
	tst.b	(ISMACDEF,a6)
	bne	macexlsym9		;macro/rept/irp/irpc̓o^
	cmpi.b	#$FF,(a0)
	bne	macexlsym1
	move.b	(1,a0),d1		;̏ꍇcԍ𓾂high
	lsl.w	#8,d1
	move.b	(2,a0),d1		;low
	bsr	macexlpara0
	tst.b	d0
	beq	macexlsym9		;ΉȂ
	move.l	a0,-(sp)
	movea.l	a1,a0
	bsr	strlen
	bsr	isdefdsym		;̈̓V{Ƃēo^Ă邩?
	movea.l	(sp)+,a0
	bra	macexlsym2

macexlsym1:
	bsr	getword			;'%'̌̌𔲂o
	tst.w	d2
	bmi	macexlsym9		;ꂪoȂ
	bsr	isdefdsym		;̌̓V{Ƃēo^Ă邩?
macexlsym2:
	tst.w	d0
	bmi	macexlsym9		;o^ĂȂ
	tst.b	(SYM_TYPE,a1)		;cmpi.b #ST_VALUE,(SYM_TYPE,a1)
					;lV{?
	bne	macexlsym9
	cmpi.b	#SA_DEFINE,(SYM_ATTRIB,a1)	;V{͒`ς݂?
	blo	macexlsym9
	tst.b	(SYM_SECTION,a1)	;V{͒萔?
	bne	macexlsym9
	exg.l	a0,a2
	move.l	(SYM_VALUE,a1),d0	;V{̒l
	moveq.l	#0,d1			;(l)
	bsr	convdec
	exg.l	a0,a2
	bsr	getword
	movea.l	a1,a0
	exg.l	a0,a2
	bra	macexline1

macexlsym9:
	exg.l	a0,a2
	move.b	#'%',(a0)+
	bra	macexline1

;----------------------------------------------------------------
;	}NXgo^
;	in :a0=Xgւ̃|C^
;	    a1=Xo^obt@ւ̃|C^
;	out:a0=XgIʒuւ̃|C^
;	    a1=o^̃obt@ւ̃|C^
defmacpara::
	clr.w	d1
	move.b	(a0),d0
	beq	defmacpara9		;XgȂ
defmacpara1:
	st.b	(a1)+			;(}[N)
	addq.w	#1,d1
	ror.w	#8,d1
	move.b	d1,(a1)+		;high
	rol.w	#8,d1
	move.b	d1,(a1)+		;low
	bsr	getmacpara		;$FF [ԍhigh,low] p[^` $00
	tst.w	d0
	bne	defmacpara1
defmacpara9:
	move.b	d1,(MACCOUNT,a6)	;}N̈̌
	clr.b	(a1)
	rts

;----------------------------------------------------------------
;	}NXg1𓾂
;	in :a0=Xgւ̃|C^/a1=obt@ւ̃|C^
;	out:d0.l=0Ȃ炻̈ŏI
getmacpara::
	cmpi.b	#'<',(a0)		;'<`>'̂܂ܒʂ
	beq	getmacparars
	moveq.l	#0,d3			;'(`)','[`]','{`}'̃lXeBO
getmacpara0:
	move.b	(a0)+,d0
	move.b	d0,(a1)+		;؂肪܂œ]
	bmi	getmacpara2
	cmp.b	#"'",d0			;'`',"`"͕
	beq	getmacparastr
	cmp.b	#'"',d0
	beq	getmacparastr
	cmp.b	#'(',d0			;ʂ̎n܂
	beq	getmacparapb
	cmp.b	#'[',d0
	beq	getmacparapb
	cmp.b	#'{',d0
	beq	getmacparapb
	cmp.b	#')',d0			;ʂ̏I
	beq	getmacparape
	cmp.b	#']',d0
	beq	getmacparape
	cmp.b	#'}',d0
	beq	getmacparape
	cmp.b	#'%',d0			;V{l
	beq	getmacparasym
	cmp.b	#'!',d0			;1̂܂ܒʂ
	beq	getmacpararc
	cmp.b	#',',d0
	beq	getmacpara1
	cmp.b	#' ',d0
	bhi	getmacpara0
	bra	getpara1

getmacpara1:
	tst.w	d3
	beq	getpara5
	bra	getmacpara0

getmacpara2:
  .if EUCSRC=0
	cmp.b	#$E0,d0
	bcc	getmacpara3
	cmp.b	#$A0,d0
	bcc	getmacpara0		;pJȉꍇ
  .else
	bra	getmacpara0		;EUC
  .endif
getmacpara3:
	move.b	(a0)+,d0		;2oCg2oCg
	move.b	d0,(a1)+
	bne	getmacpara0
	bra	getpara1		;2oCgڂ$00̏ꍇ

getmacparastr:				;̏
	move.b	(a0)+,d2
	move.b	d2,(a1)+
	beq	getmacparastr01		;sIĂ܂
	bmi	getmacparastr1
	cmp.b	d2,d0
	bne	getmacparastr
	bra	getmacpara0

getmacparastr1:
  .if EUCSRC=0
	cmp.b	#$E0,d2
	bcc	getmacparastr2
	cmp.b	#$A0,d2
	bcc	getmacparastr		;pJȉꍇ
  .else
	bra	getmacparastr		;EUC
  .endif
getmacparastr2:
	move.b	(a0)+,d2		;2oCg2oCg
	move.b	d2,(a1)+
	bne	getmacparastr
	bra	iloprerr		;2oCgڂ$00̏ꍇ

getmacparastr01:
	cmp.b	#"'",d0
	beq	termerr_singlequote
	bra	termerr_doublequote

getmacparapb:				;ʂ̎n܂
	addq.w	#1,d3
	bra	getmacpara0

getmacparape:				;ʂ̏I
	subq.w	#1,d3
	bcc	getmacpara0
	moveq.l	#0,d3			;')',']','}'̐
	bra	getmacpara0

getmacpararc:
	move.b	(a0)+,d0		;'!'̂Ƃ1͂̂܂ܒʂ
	move.b	d0,(-1,a1)
	beq	iloprerr		;'!'ōsI
	bpl	getmacpara0
  .if EUCSRC=0
	cmp.b	#$E0,d0
	bcc	getmacpararc1
	cmp.b	#$A0,d0
	bcc	getmacpara0		;pJȉꍇ
  .else
	bra	getmacpara0		;EUC
  .endif
getmacpararc1:
	move.b	(a0)+,d0		;2oCg2oCg
	move.b	d0,(a1)+
	bne	getmacpara0
	bra	iloprerr		;2oCgڂ$00̏ꍇ

getmacparasym:				;V{l
	movem.l	d1/a1,-(sp)
	bsr	getword			;'%'̌̌𔲂o
	tst.w	d2
	bmi	getmacparasym9		;ꂪoȂ
	bsr	isdefdsym		;̌̓V{Ƃēo^Ă邩?
	tst.w	d0
	bmi	getmacparasym9		;o^ĂȂ
	tst.b	(SYM_TYPE,a1)		;cmpi.b #ST_VALUE,(SYM_TYPE,a1)
					;lV{?
	bne	getmacparasym9
	cmpi.b	#SA_DEFINE,(SYM_ATTRIB,a1)	;V{͒`ς݂/
	blo	getmacparasym9
	tst.b	(SYM_SECTION,a1)	;V{͒萔?
	bne	getmacparasym9
	move.l	(SYM_VALUE,a1),d0	;V{̒l
	moveq.l	#0,d1			;(l)
	movea.l	a0,a1
	movea.l	(4,sp),a0
	subq.l	#1,a0
	bsr	convdec
	move.l	a0,(4,sp)		;l̏Iʒu
	movea.l	a1,a0
	bsr	getword
	movea.l	a1,a0
getmacparasym9:
	movem.l	(sp)+,d1/a1
	bra	getmacpara0

getmacparars:				;'<`>'̊Ԃ͂̂̕܂ܒʂ
	addq.l	#1,a0
getmacparars1:
	move.b	(a0)+,d0
getmacparars2:
	move.b	d0,(a1)+
	beq	termerr_bracket		;Ή'>'Ȃ܂܍sI
	bmi	getmacparars3
	cmp.b	#'>',d0
	bne	getmacparars1
	move.b	(a0)+,d0
	cmp.b	#',',d0
	beq	getpara5		;'>'ŏIÃp[^
	cmp.b	#' ',d0
	bhi	getmacparars2		;'>'̌ɕƂ͏I[LłȂ
	bra	getpara1

getmacparars3:
  .if EUCSRC=0
	cmp.b	#$E0,d0
	bcc	getmacparars4
	cmp.b	#$A0,d0
	bcc	getmacparars1		;pJȉꍇ
  .else
	bra	getmacparars1		;EUC
  .endif
getmacparars4:
	move.b	(a0)+,d0		;2oCg2oCg
	move.b	d0,(a1)+
	bne	getmacparars1
	bra	iloprerr

;----------------------------------------------------------------
;	Xgo^
;	in :a0=Xgւ̃|C^
;	    a1=Xo^obt@ւ̃|C^
;	out:a0=XgIʒuւ̃|C^
;	    a1=o^̃obt@ւ̃|C^
defpara::
	clr.w	d1
	move.b	(a0),d0
	beq	defpara9		;XgȂ
defpara1:
	st.b	(a1)+			;(}[N)
	addq.w	#1,d1			;ԍ1`
	ror.w	#8,d1
	move.b	d1,(a1)+		;high
	rol.w	#8,d1
	move.b	d1,(a1)+		;low
	bsr	getpara			;$FF [ԍhigh,low] p[^` $00
	tst.w	d0
	bne	defpara1
defpara9:
	clr.b	(a1)
	rts

;----------------------------------------------------------------
;	Xg1𓾂
;	in :a0=Xgւ̃|C^/a1=obt@ւ̃|C^
;	out:d0.l=0Ȃ炻̈ŏI
getpara::
	move.b	(a0)+,d0
	move.b	d0,(a1)+		;؂肪܂œ]
	bmi	getpara2
	cmp.b	#',',d0
	beq	getpara5
	cmp.b	#' ',d0
	bhi	getpara
getpara1:
	clr.b	(-1,a1)
	subq.l	#1,a0
	bsr	skipspc
	moveq.l	#-1,d0
	cmp.b	#',',(a0)+
	bne	getpara9
	bra	skipspc			;܂

getpara9:
	moveq.l	#0,d0
	rts

getpara2:
  .if EUCSRC=0
	cmp.b	#$E0,d0
	bcc	getpara3
	cmp.b	#$A0,d0
	bcc	getpara			;pJȉꍇ
  .else
	bra	getpara			;EUC
  .endif
getpara3:
	move.b	(a0)+,d0		;2oCg2oCg
	move.b	d0,(a1)+
	bne	getpara
	bra	getpara1		;2oCgڂ$00̏ꍇ

getpara5:
	clr.b	(-1,a1)
	moveq.l	#-1,d0
	bra	skipspc			;܂


;----------------------------------------------------------------
	.end

;----------------------------------------------------------------
;	$Log: macro.s,v $
;	Revision 2.2  1999 10/ 8(Fri) 21:51:41 M.Kamada
;	+86 EUCΉ
;
;	Revision 2.1  1999  4/28(Wed) 22:21:13 M.Kamada
;	+84 }Ñ[JV{ƃoXG[osC
;	+84 1̃}NŃ[JV{254ȏo^ł
;
;	Revision 2.0  1999  3/ 2(Tue) 20:20:23 M.Kamada
;	+82 G[bZ[W{ꉻ
;	+82 skiphasspcp~
;
;	Revision 1.9  1999  2/27(Sat) 23:42:25 M.Kamada
;	+81 \[XXg̃tH[}bgύX(st@C+80Ƃ܂)
;
;	Revision 1.8  1998  8/26(Wed) 13:26:52 M.Kamada
;	+76 }N[JV{@`2ȏ`ƌ듮삷
;
;	Revision 1.7  1998  8/21(Fri) 03:14:51 M.Kamada
;	+74 }N`@`IɃ[J錾
;
;	Revision 1.6  1998  8/18(Tue) 20:03:08 M.Kamada
;	+72 .sizem̑2̃[JV{Ƀ}N̈̌`
;
;	Revision 1.5  1998  1/24(Sat) 22:07:35 M.Kamada
;	+57 ^.sizemǉ
;
;	Revision 1.4  1997  9/15(Mon) 15:58:48 M.Kamada
;	+46 ST_VALUE=0ōœK
;
;	Revision 1.3  1997  9/15(Mon) 03:58:42 M.Kamada
;	+45 }N$oprcntŃp[^,}N$opsizeŃTCYwQ,shiftV
;
;	Revision 1.2  1997  6/24(Tue) 22:01:14 M.Kamada
;	+34 vft@CV{ɑΉ
;
;	Revision 1.1  1994/02/13  14:38:38  nakamura
;	Initial revision
;
;
