;----------------------------------------------------------------
;	X68k High-speed Assembler
;		s̃R[hƉ
;		< encode.s >
;
;	$Id: encode.s,v 3.2  1999 10/ 8(Fri) 21:48:40 M.Kamada Exp $
;
;		Copyright 1990-94  by Y.Nakamura
;			  1997-99  by M.Kamada
;----------------------------------------------------------------

	.include	has.equ
	.include	tmpcode.equ
	.include	register.equ
	.include	symbol.equ

	.cpu	68000
	.text


;----------------------------------------------------------------
;	x`
deflabel00:
;	move.l	a1,(ERRMESSYM,a6)
	move.b	(SYM_TYPE,a1),d0
;	beq	ilsymerr_value		;ST_VALUE
	subq.b	#ST_REAL,d0
	bcs	ilsymerr_local		;ST_LOCAL
	beq	ilsymerr_real		;ST_REAL
	subq.b	#ST_REGSYM-ST_REAL,d0
	beq	ilsymerr_regsym		;ST_REGSYM
	bra	ilsymerr_register	;ST_REGISTER

deflabel::
	movem.l	d0-d2/a0-a2,-(sp)
	tst.b	(ISIFSKIP,a6)
	bne	deflabel9		;.ifs̓ǂݔ΂Ȃ̂Œ`̕KvȂ
	move.w	(LABNAMELEN,a6),d1
	bmi	deflabel9		;`郉xȂ
	movea.l	(LABNAMEPTR,a6),a0
deflabel7:
	bsr	isdefdsym
	tst.w	d0
	beq	deflabel8		;łɓo^
	moveq.l	#ST_VALUE,d2		;lV{
	bsr	defsymbol		;Vo^
	sf.b	(SYM_FIRST,a6)
	bra	deflabel85

deflabel8:
	move.l	a1,(ERRMESSYM,a6)
	tst.b	(SYM_TYPE,a1)		;cmpi.b #ST_VALUE,(SYM_TYPE,a1)
					;V{̃^Cv
	bne	deflabel00		;^Cv̈قȂV{ƏdĂ
;offsym̂Ƃ̓vft@CV{łȂΓd`G[oȂ
	tst.b	(SYM_ATTRIB,a1)		;(cmpi.b #SA_UNDEF,(SYMATTRIB,a1))
	beq	deflabel81		;`Ȃ̂ŖȂ
	cmpi.b	#SA_PREDEFINE,(SYM_ATTRIB,a1)
	beq	redeferr_predefine	;vft@CV{
;SA_NODET/SA_DEFINE
	tst.b	(OFFSYMMOD,a6)
	beq	redeferr		;offsymłȂ̂œd`G[
	tst.b	(SYM_FIRST,a1)
	bgt	deflabel81
	tst.b	(OWOFFSYM,a6)		;offsym̃V{łȂ
	bne	redeferr_offsym
	bsr	redefwarn_offsym
deflabel81:
	cmpi.b	#SECT_RLCOMM,(SYM_EXTATR,a1)
	bcc	redeferr		;.xref/.commV{
deflabel85:
	tst.b	(OFFSYMMOD,a6)
	beq	deflabel850
	bgt	deflabel_offsym		;offsymŃV{
	move.b	#1,(SYM_FIRST,a1)	;offsym̃V{
deflabel850:
	move.b	#SA_DEFINE,(SYM_ATTRIB,a1)	;`σV{
	move.l	(LTOPLOC,a6),d0		;P[VJE^l
	move.l	d0,(SYM_VALUE,a1)
	cmpi.b	#SECT_TEXT,(SECTION,a6)
	bne	deflabel851
	move.l	d0,(LASTSYMLOC,a6)	;eLXgZNVōŌ
					;xɒ`P[VJE^l
deflabel851:
	move.b	(ORGNUM,a6),(SYM_ORGNUM,a1)
	move.b	(SECTION,a6),(SYM_SECTION,a1)	;ZNVԍ
	beq	deflabel88		;(萔ȂT_SYMDEF͕sv)
	move.w	#T_SYMDEF,d0
	bsr	wrtobjd0w		;V{`
	move.l	a1,d0
	bsr	wrtd0l			;V{ւ̃|C^
deflabel88:
	tst.b	(LABXDEF,a6)
	beq	deflabel9
	move.b	#SECT_XDEF,(SYM_EXTATR,a1)	;O`
deflabel9:
	movem.l	(sp)+,d0-d2/a0-a2
	rts

;a1=s̃V{
deflabel_offsym:
	move.b	#1,(SYM_FIRST,a1)	;offsym̃V{
	cmpa.l	(OFFSYMSYM,a6),a1
	beq	deflabel_offsym1
;l^V{łȂƂ
	movea.l	a1,a2
;݂̃V{(ϐ)=݂̃P[VJE^(萔)+l(萔)-V{l(ϐ)
;RPN
	move.l	(LTOPLOC,a6),d1		;݂̃P[VJE^
	add.l	(OFFSYMVAL,a6),d1	;+l
	lea.l	(RPNBUF,a6),a1
	move.w	#RPN_VALUE,(a1)+
	move.l	d1,(a1)+		;݂̃P[VJE^+l
	move.w	#RPN_SYMBOL,(a1)+
	move.l	(OFFSYMTMP,a6),(a1)+	;-V{
	move.w	#OP_SUB|RPN_OPERATOR,(a1)+	;Iy[^
	clr.w	(a1)			;GhR[h(move.w #RPN_END,(a1))
	lea.l	(RPNBUF,a6),a1
	bsr	calcrpn
	movea.l	a2,a1
	tst.w	d0
	beq	deflabel_offsym2	;萔
;萔łȂ
	move.b	#SA_NODET,(SYM_ATTRIB,a1)	;l̃V{
	move.w	#T_EQUEXPR,d0		;EAhXequ/set
	bsr	wrtobjd0w
	move.l	a1,d0
	bsr	wrtd0l			;V{ւ̃|C^
	lea.l	(RPNBUF,a6),a1
	moveq.l	#7,d1			;̃[h
	moveq.l	#SZ_LONG,d0
	bsr	wrtrpn			;o
	movea.l	a2,a1
	bra	deflabel88

;l^V{̂Ƃ
deflabel_offsym1:
	movea.l	a1,a2
;l^V{̈ʒũP[VJE^i[鉼̃V{m
	movea.l	(OFFSYMTMP,a6),a1
	clr.w	(SYM_SECTION,a1)	;(SYM_ORGNUM)
	move.b	#SA_DEFINE,(SYM_ATTRIB,a1)	;`σV{
	move.l	(LTOPLOC,a6),(SYM_VALUE,a1)	;P[VJE^l
;l^V{m
	move.l	(OFFSYMVAL,a6),d1	;l
	movea.l	a2,a1
;d1=l
;a1=V{
deflabel_offsym2:
	clr.w	(SYM_SECTION,a1)	;(SYM_ORGNUM)
	move.b	#SA_DEFINE,(SYM_ATTRIB,a1)	;`σV{
	move.l	d1,(SYM_VALUE,a1)	;V{l
;AZuXgɕ\邽ߏlo͂Ă
	move.w	#T_EQUCONST,d0		;萔equ/set
	bsr	wrtobjd0w
	move.l	a1,d0
	bsr	wrtd0l			;V{ւ̃|C^
	move.l	d1,d0
	bsr	wrtd0l			;V{l
	bra	deflabel88


;----------------------------------------------------------------
;	s̃x߁A߂̃R[h
;----------------------------------------------------------------
encodeline::
	lea.l	(LINEBUF,a6),a0
	movea.l	a0,a2
	sf.b	(LABXDEF,a6)
	move.w	#-1,(LABNAMELEN,a6)
	bsr	skipspc
	move.b	(a0),d0			;sI
	beq	encodecmd99
	cmp.b	#'*',d0			;Rg
	beq	encodecmd99
	cmp.b	#';',d0			;g[h̃Rg
	beq	encodecmd99
	cmp.b	#'#',d0
	beq	encodecmd99
encodeline1:
	cmp.b	#'.',d0			;.xxxx 
	beq	encodecmd1
	tst.b	(ISIFSKIP,a6)
	beq	encodeline2
	movea.l	a0,a1			;ifXLbv̏ꍇ
	moveq.l	#-2,d1			;xǂݔ΂
encodeline01:
	addq.w	#1,d1
	move.b	(a1)+,d0
	cmp.b	#'.',d0
	beq	encodeline02
	cmp.b	#':',d0
	beq	encodeline02
	cmp.b	#' ',d0
	bhi	encodeline01
encodeline02:
	subq.l	#1,a1
	tst.w	d1
	bmi	encodecmd9
	bra	encodeline3

encodeline2:
	bsr	getword
	tst.w	d2
	bmi	encodecmd9		;x/߂ƂĎgpłȂ
encodeline3:
	cmpi.b	#':',(a1)
	beq	encodeline8		;xxxx: x
	cmpi.b	#' ',(a2)		;sXy[XŎn܂?
	bls	encodecmd3		; xxxx 
	move.l	a0,(LABNAMEPTR,a6)	;(x̏ꍇ)
	move.w	d1,(LABNAMELEN,a6)
	bsr	getmaccmd		;xxxx x/(}ND)
	tst.w	d0
	beq	encodeline4
	move.b	(a0),d0			;x̏ꍇ
	cmpi.b	#'@',d0
	beq	deflocal11
	cmpi.b	#'9',d0
	bls	deflocal21
	movea.l	a1,a0
	bsr	skipspc
	bra	encodecmd		;߂̏

encodeline4:				;߂̉\
	movea.l	a1,a0
	bsr	skipspc
	cmpi.b	#'.',(a0)
	bne	encodeline45
	addq.l	#1,a0			;xxxx.xxxx c 2ڂ߂Ȃ1ڂ̓x
	bra	encodeline46

encodeline45:
;1ڂcinv/cpush/pmove':'Ȃ2ڂ'.'Ŏn܂ĂȂ,
;1ڂ͖߂Ƃɂ
	movea.l	(CMDTBLPTR,a6),a1	;d1/a1͎getwordŔj󂷂̂Ŏg
	move.l	(SYM_FUNC,a1),d1
;getworda1j󂷂̂a1g
	lea.l	(encodeline,pc),a1
	sub.l	a1,d1
	cmp.l	#~cinvpusha-encodeline,d1
	beq	encodeline5		;1ڂcinv/cpushȂ̂1ڂ͖
	cmp.l	#~cinvpushlp-encodeline,d1
	beq	encodeline5		;1ڂcinv/cpushȂ̂1ڂ͖
	cmp.l	#~pmove-encodeline,d1
	beq	encodeline5		;1ڂpmoveȂ̂1ڂ͖
encodeline46:
	bsr	getword
	bsr	getmaccmd
	tst.w	d0
	bne	encodeline5
	tst.l	(CMDTBLPTR,a6)		;2ڂ߁1ڂ͖߂Ɠ̃x
	bne	encodecmd5
encodeline5:
	movea.l	(LABNAMEPTR,a6),a0
	move.w	#-1,(LABNAMELEN,a6)	;x̎
	bra	encodecmd2		;1ڂ߂

;----------------------------------------------------------------
;	':'tx̒`
encodeline8:
	move.b	(a0),d0
	cmpi.b	#'@',d0
	beq	deflocal10
	cmpi.b	#'9',d0
	bls	deflocal20
encodeline10:
	addq.l	#1,a1
	cmpi.b	#':',(a1)
	bne	encodeline11
	addq.l	#1,a1
	st.b	(LABXDEF,a6)		;xxxx:: O`x
encodeline11:
	move.l	a0,(LABNAMEPTR,a6)
	move.w	d1,(LABNAMELEN,a6)
	movea.l	a1,a0
	bsr	skipspc
	cmpi.b	#'.',(a0)
	beq	encodecmd1		;xxxx: .xxxx
	bsr	getword
	tst.w	d2
	bmi	encodecmd3
	cmpi.b	#':',(a1)
	bne	encodecmd3		;xxxx: xxxx
	bsr	deflabel		;xxxx: xxxx: ŏ̃x`
	sf.b	(LABXDEF,a6)
	bra	encodeline10

;----------------------------------------------------------------
;	߂̃R[h
encodecmd:
	cmp.b	#'.',(a0)
	bne	encodecmd2
encodecmd1:				;'.'Ŏn܂閼O͖ߗD
	addq.l	#1,a0
	bsr	getword
	bsr	getcmdmac		;ߗD
	bra	encodecmd4

encodecmd2:
	bsr	getword
encodecmd3:
	bsr	getmaccmd		;}ND
encodecmd4:
	tst.w	d0
	bne	encodecmd9		;߁E}Ň
	tst.l	(CMDTBLPTR,a6)
	beq	encodecmd99		;߂Ȃ
encodecmd5:				;Iy[VTCY𓾂
	st.b	(CMDOPSIZE,a6)		;(move.b #SZ_NONE,(CMDOPSIZE,a6))
	movea.l	a1,a0
	cmpi.b	#'.',(a0)
	bne	encodecmd7		;Iy[VTCYȂ
	moveq.l	#$20,d0
	or.b	(1,a0),d0
	moveq.l	#SZ_BYTE,d1
	cmp.b	#'b',d0			;.b
	beq	encodecmd6
	moveq.l	#SZ_WORD,d1
	cmp.b	#'w',d0			;.w
	beq	encodecmd6
	moveq.l	#SZ_LONG,d1
	cmp.b	#'l',d0			;.l
	beq	encodecmd6
	moveq.l	#SZ_SHORT,d1
	cmp.b	#'s',d0			;.s (short/single)
	beq	encodecmd6
	moveq.l	#SZ_DOUBLE,d1
	cmp.b	#'d',d0			;.d
	beq	encodecmd6
	moveq.l	#SZ_EXTEND,d1
	cmp.b	#'x',d0			;.x
	beq	encodecmd6
	moveq.l	#SZ_PACKED,d1
	cmp.b	#'p',d0			;.p
	beq	encodecmd6
	moveq.l	#SZ_QUAD,d1
	cmp.b	#'q',d0			;.q
	bne	encodecmd7		;TCY݂Ȃ
encodecmd6:				;TCYw肪
	moveq.l	#0,d0			;foo=.low.`ȂǂG[ɂȂ̂
	move.b	(2,a0),d0		;TCY̒̕
	lea.l	(wordtbl,pc),a1		;̒ɋ镶̃e[u
	tst.b	(a1,d0.w)
	bne	encodecmd7		;ꂪĂ̂ŃTCYƌȂȂ
	move.b	d1,(CMDOPSIZE,a6)
	addq.l	#2,a0
	movea.l	(CMDTBLPTR,a6),a1
	cmpi.b	#ST_MACRO,(SYM_TYPE,a1)
	beq	encodecmd7
	move.b	(SYM_SIZE,a1),d0
	tst.b	(CPUTYPE2,a6)
	beq	encodecmd61
	move.b	(SYM_SIZE2,a1),d0	;ColdFirêƂgTCY
encodecmd61:
	moveq.l	#1,d2
	lsl.b	d1,d2
	and.b	d0,d2
	beq	encodecmd7
	tst.b	(ISIFSKIP,a6)		;ifXLbṽG[߂΂ĉȂ
	beq	encodecmd71		;włȂTCY
encodecmd7:
	bsr	skipspc
	move.l	a0,(LINEPTR,a6)
	rts

encodecmd71:
	move.l	a1,(ERRMESSYM,a6)
	tst.w	(SYM_ARCH,a1)
	beq	encodecmd72
	addq.b	#1,d0			;$FF?
	bne	ilsizeerr_op		;TCYwł閽
	bra	ilsizeerr_op_no		;$FF:TCYwłȂ
encodecmd72:
	addq.b	#1,d0			;$FF?
	bne	ilsizeerr_pseudo	;TCYwłȂ^
	bra	ilsizeerr_pseudo_no	;$FF:TCYwłȂ^

encodecmd9:
	tst.b	(ISIFSKIP,a6)		;ifXLbṽG[߂΂ĉȂ
	beq	badopeerr
encodecmd99:				;߂Ȃꍇ
	sf.b	(ISMACRO,a6)
	clr.l	(CMDTBLPTR,a6)
	move.l	a0,(LINEPTR,a6)
	rts

;----------------------------------------------------------------
;	[Jx̒`
deflocal10:				;'@@:'
	addq.l	#1,a1
deflocal11:
	tst.b	(ISIFSKIP,a6)
	bne	deflocal30		;.ifs̓ǂݔ΂Ȃ̂Œ`̕KvȂ
	cmp.w	#2-1,d1
	bne	badopeerr_local
	cmp.b	#'@',(1,a0)
	bne	badopeerr_local		;'@@'łȂ
	moveq.l	#0,d1
	bra	deflocal5

deflocal30:
	move.w	#-1,(LABNAMELEN,a6)	;x̎
	movea.l	a1,a0
	bsr	skipspc
	bra	encodecmd		;.ifs̓ǂݔ΂Ȃ̂Œ`̕KvȂ

deflocal20:				;'0:'`'9:'
	addq.l	#1,a1
deflocal21:
	tst.b	(ISIFSKIP,a6)
	bne	deflocal30		;.ifs̓ǂݔ΂Ȃ̂Œ`̕KvȂ
	move.w	#256-('9'+1),d0		;ʃoCg0ɂ邱
	add.b	(a0)+,d0
	bpl	badopeerr_local
	add.b	#10,d0
	bmi	badopeerr_local
	tst.w	d1
	beq	deflocal22		;1
	cmp.w	(LOCALLENMAX,a6),d1
	bcc	badopeerr_local		;ő包zĂ?
deflocal211:
	move.w	d0,d2			;~1
	add.w	d0,d0			;~2
	add.w	d0,d0			;~4
	add.w	d2,d0			;~5
	add.w	d0,d0			;~10
	move.w	#256-('9'+1),d2		;ʃoCg0ɂ邱
	add.b	(a0)+,d2
	bpl	badopeerr_local
	add.b	#10,d2
	bmi	badopeerr_local
	add.w	d2,d0
	subq.w	#1,d1
	bne	deflocal211
deflocal22:
	move.w	d0,d1
deflocal5:
	move.w	#-1,(LABNAMELEN,a6)	;x̎
	movea.l	a1,a0			;x̒(':'Ƃ':'̒)
	bsr	skipspc
	pea.l	(encodecmd,pc)		;(x`̃Wv)
	movem.l	d0-d2/a0-a2,-(sp)
	movea.l	(LOCALMAXPTR,a6),a2
	move.w	d1,d2
	add.w	d2,d2
	swap.w	d1
	move.w	(a2,d2.w),d1
	addq.w	#1,(a2,d2.w)		;[Jԍi߂
	bsr	isdefdlocsym
	tst.w	d0
	beq	deflabel85		;łɓo^ς
	bsr	deflocsymbol
	bra	deflabel85		;x`sȂ(I疽߂̏)


;----------------------------------------------------------------
;	Iyh̃R[h
;----------------------------------------------------------------
;	in :a0=Iyhւ̃|C^
;	out:(OPRBUF-)=R[hꂽIyh
encodeopr::
	lea.l	(OPRBUF,a6),a2
	tst.b	(ISIFSKIP,a6)
	bne	encodeopr99
encodeopr1:
	move.b	(a0),d0
	cmp.b	#' ',d0
	bls	encodeopr9
	cmp.b	#'.',d0
	beq	encodeexop		;Zq
encodeopr2:
	bsr	getnum
	tst.w	d0
	beq	encodenum		;lꂽ
	bpl	encodereal		;_ꂽ
	bsr	getword
	tst.w	d2
	bpl	encodesymr		;ꂪo
encodeopr3:
	move.b	(a0)+,d0
	cmp.b	#"'",d0
	beq	encodestr		;
	cmp.b	#'"',d0
	beq	encodestr		;
	cmp.b	#'!',d0
	beq	encodeinreal		;_\L
encodeopr5:
	clr.b	(a2)+			;1̃LN^(move.b #OT_CHAR>>8,(a2)+)
	move.b	d0,(a2)+
	cmp.b	#',',d0
	bne	encodeopr1
	bsr	skipspc			;','̌̃Xy[XXLbv
	bra	encodeopr1

encodeopr9:				;IyhI`FbN
	bsr	skipspc
	move.b	(a0)+,d0
	cmp.b	#',',d0			;Xy[X','F
	bne	encodeopr99
	move.w	#','|OT_CHAR,(a2)+
	bsr	skipspc
	bra	encodeopr1

encodeopr99:				;IyhI
	clr.w	(a2)			;(move.w #OT_EOL,(a2))
	rts

;----------------------------------------------------------------
;	Zq̃R[h
encodeexop:
	addq.l	#1,a0
	bsr	getword
	tst.w	d2
	beq	encodesize		;1TCYw
	moveq.l	#1,d1
	lea.l	(opname_tbl,pc),a4
encodeexop1:
	movea.l	a0,a3
encodeexop2:
	move.b	(a4)+,d0
	beq	encodeexop4
	moveq.l	#$20,d2
	or.b	(a3)+,d2
	cmp.b	d0,d2
	beq	encodeexop2
encodeexop3:				;̉Zq
	tst.b	(a4)+
	bne	encodeexop3
encodeexop35:
	addq.b	#1,d1
	tst.b	(a4)
	bpl	encodeexop1
encodeexop_real:			;Zq݂Ȃ
	subq.l	#1,a0			;_̉\
	bsr	strtox			;ɕϊ
	tst.l	d0
	bmi	exprerr			;ϊłȂ΃G[
	move.w	d0,d3
	bra	encodereal

encodeexop4:				;Zq̏ꍇ
	cmpi.b	#'.',(a3)+
	bne	encodeexop35		;ZqIĂȂ
	movea.l	a3,a0
	cmp.b	#OPCOUNT,d1
	bcs	encodeexop5
	sub.b	#OPCOUNT,d1
	lea.l	(opconv_tbl,pc),a4
	move.b	(a4,d1.w),d1		;ZqR[hϊ
encodeexop5:
	or.w	#OT_OPERATOR,d1		;Zq
	move.w	d1,(a2)+
	bra	encodeopr1

;----------------------------------------------------------------
;	TCYw̃R[h
encodesize:
	moveq.l	#$20,d0
	or.b	(a0),d0
	move.w	#OT_SIZE|SZ_BYTE,d2
	cmp.b	#'b',d0			;.b
	beq	encodesize1
	addq.b	#SZ_WORD-SZ_BYTE,d2
	cmp.b	#'w',d0			;.w
	beq	encodesize1
	addq.b	#SZ_LONG-SZ_WORD,d2
	cmp.b	#'l',d0			;.l
	beq	encodesize1
	addq.b	#SZ_SHORT-SZ_LONG,d2
	cmp.b	#'s',d0			;.s (short/single)
	beq	encodesize1
	addq.b	#SZ_DOUBLE-SZ_SHORT,d2
	cmp.b	#'d',d0			;.d
	beq	encodesize1
	addq.b	#SZ_EXTEND-SZ_DOUBLE,d2
	cmp.b	#'x',d0			;.x
	beq	encodesize1
	addq.b	#SZ_PACKED-SZ_EXTEND,d2
	cmp.b	#'p',d0			;.p
	beq	encodesize1
	addq.b	#SZ_QUAD-SZ_PACKED,d2
	cmp.b	#'q',d0			;.q
	beq	encodesize1
	move.w	#OT_MAC|'u',d2
	cmp.b	#'u',d0			;.u
	bne	encodeexop_real		;TCY݂Ȃ
encodesize1:
	move.w	d2,(a2)+
	movea.l	a1,a0
	bra	encodeopr1

;----------------------------------------------------------------
;	lf[^̃R[h
encodenum:
	move.l	d1,d0
	add.l	d0,d0
	moveq.l	#0,d0
	addx.l	d2,d0			;d1>=0d2=0܂d1<0d2=-1Ȃ0
	beq	encodenum02		;32bitœ؂
	tst.l	d2			;d2=0łd1̕gɂȂĂȂ,
	beq	encodenum01		;OT_VALUEQ64bito͂
					;_ɕϊƂd2=0d1<0
					;̐Ƃĕϊ悤ɂ邽
	move.l	(CMDTBLPTR,a6),d0
	beq	overflowerr		;߂Ȃ
	movea.l	d0,a1
	move.b	(SYM_SIZE,a1),d0	;gȂTCỸrbg1
	tst.b	(CPUTYPE2,a6)
	beq	encodenum00
	move.b	(SYM_SIZE2,a1),d0	;ColdFireŎgȂTCỸrbg1
encodenum00:
	tst.b	d0
	bpl	encodenum01		;SZQPMOVEfd
	and.b	#SZS|SZD|SZX|SZP,d0
	bne	overflowerr		;_߂łȂ
	move.b	(CMDOPSIZE,a6),d0
	subq.b	#SZ_SHORT,d0
	blo	overflowerr		;TCYȗ/.s/.d/.x/.p/.q̂ꂩł͂Ȃ
encodenum01:
	move.w	#OT_VALUEQ,(a2)+	;64bitl
	move.l	d2,(a2)+		;32bit
	move.l	d1,(a2)+		;32bit
	bra	encodeopr1

encodenum02:
	cmp.l	#$100,d1
	bcs	encodenum2
	cmp.l	#$10000,d1
	bcs	encodenum1
	move.w	#OT_VALUE,(a2)+		;32bitl
	move.l	d1,(a2)+
	bra	encodeopr1

encodenum1:
	move.w	#OT_VALUEW,(a2)+	;16bitl
	move.w	d1,(a2)+
	bra	encodeopr1

encodenum2:
	or.w	#OT_VALUEB,d1		;8bitl
	move.w	d1,(a2)+
	bra	encodeopr1

;----------------------------------------------------------------
;	_f[^̃R[h
encodereal:
	move.w	#OT_REAL,(a2)+		;f[^
	move.w	d3,(a2)+		;w
	move.l	d1,(a2)+		;
	move.l	d2,(a2)+		;      
	bra	encodeopr1

;----------------------------------------------------------------
;	V{EWX^̃R[h
encodesymr:
	cmp.w	#1,d1
	bne	encodesymr2
	move.w	#OT_REGISTER|REG_D0,d2	;2̏ꍇ
	moveq.l	#$20,d0
	or.b	(a0),d0
	cmp.b	#'d',d0			;Dn?
	beq	encodesymr1
	move.b	#REG_A0,d2
	cmp.b	#'a',d0			;An?
	beq	encodesymr1
	cmp.b	#'s',d0			;SP?
	bne	encodesymr2
	moveq.l	#$20,d0
	or.b	(1,a0),d0
	cmp.b	#'p',d0
	bne	encodesymr2
	move.w	#OT_REGISTER|REG_SP,(a2)+
	movea.l	a1,a0
	bra	encodeopr1

encodesymr1:				;dn,an̏ꍇ
	move.b	(1,a0),d0
	sub.b	#'0',d0
	bcs	encodesymr2
	cmp.b	#7,d0
	bhi	encodesymr2
	add.b	d0,d2
	move.w	d2,(a2)+		;WX^
	movea.l	a1,a0
	bra	encodeopr1

encodesymr2:
	move.b	(a0),d0			;x̏ꍇ
	cmpi.b	#'@',d0
	beq	encodelocal10		;'@...'̓[JxQ
	cmpi.b	#'9',d0
	bls	encodelocal20		;'[0-9]...'̓[JxQ
	move.l	a1,-(sp)
	bsr	isdefdsym		;`ς݃V{ǂ`FbN
	tst.w	d0
	bne	encodesymr5
	move.b	(SYM_TYPE,a1),d1	;V{^Cv
	bmi	encodereg		;WX^
	cmpi.b	#ST_REGSYM,d1
	beq	encoderegsym		;regV{
encodesym:
	move.w	#OT_SYMBOL,(a2)+	;V{
	move.l	a1,(a2)+		;V{e[uւ̃|C^
	movea.l	(sp)+,a0
	bra	encodeopr1

encodesymr5:				;`V{̏ꍇ
	moveq.l	#ST_VALUE,d2
	bsr	defsymbol		;V{o^
	sf.b	(SYM_FIRST,a6)
	bra	encodesym

encodereg:				;WX^
	move.w	#OT_REGISTER,d0
	move.b	(SYM_REGNO,a1),d0
	move.w	d0,(a2)+
	movea.l	(sp)+,a0
	bra	encodeopr1

encoderegsym:				;regV{
	move.w	(SYM_DEFLEN,a1),d0
	movea.l	(SYM_DEFINE,a1),a0
encoderegsym1:
	move.w	(a0)+,(a2)+		;`e]
	dbra	d0,encoderegsym1
	subq.l	#2,a2
	movea.l	(sp)+,a0
	bra	encodeopr1

;----------------------------------------------------------------
;	[JxQƂ𓾂
encodelocal10:				;@f/@b
	moveq.l	#0,d0
	subq.w	#1,d1
	bmi	iloprerr_local		;'@'1ȂG[
	and.w	#$00FF,d1
	move.w	d1,d2
encodelocal11:
	cmpi.b	#'@',(a0)+
	dbne	d2,encodelocal11
	bne	iloprerr_local		;Ō̈ꕶȊOׂ'@'łȂ΃G[
encodelocal12:
	moveq.l	#$20,d2
	or.b	(a0)+,d2
	cmpi.b	#'f',d2			;'@f' = 0,1,2,c
	beq	encodelocal15
	cmpi.b	#'b',d2			;'@b' = -1,-2,-3,c
	bne	iloprerr_local		;'@f','@b'łȂ΃G[
	not.b	d1			;neg.b d1;subq.b #1,d1
encodelocal15:
	ori.w	#OT_LOCALREF,d1		;[JxQ
	move.w	d1,(a2)+
	move.w	d0,(a2)+
	movea.l	a1,a0
	bra	encodeopr1

encodelocal20:				;0f`9f/0b`9b
	cmp.b	#'$',d0
	beq	encodeopr3		;'$'݂͌̃P[VJE^
	move.w	#256-('9'+1),d0		;ʃoCg0ɂ邱
	add.b	(a0)+,d0
	bpl	iloprerr
	add.b	#10,d0
	bmi	iloprerr
	subq.w	#2-1,d1			;-1=1(0),0=2(1),
					;1=3(2),2=4(3),3=5(4)
	beq	encodelocal12		;1Ȃ̂'f'܂'b'̃`FbN
	bcs	iloprerr_local		;1ȉ̓G[
	move.w	d1,d2
	addq.w	#2-1,d2			;0=1(0),1=2(1),
					;2=3(2),3=4(3),4=5(4)
	cmp.w	(LOCALLENMAX,a6),d2
	bhi	iloprerr_local		;ő包zĂ?
encodelocal21:
	move.w	d0,d2			;~1
	add.w	d0,d0			;~2
	add.w	d0,d0			;~4
	add.w	d2,d0			;~5
	add.w	d0,d0			;~10
	move.w	#256-('9'+1),d2		;ʃoCg0ɂ邱
	add.b	(a0)+,d2
	bpl	iloprerr_local
	add.b	#10,d2
	bmi	iloprerr_local
	add.w	d2,d0
	subq.w	#1,d1
	bne	encodelocal21
;	clr.w	d1
	bra	encodelocal12		;d1.w=0

;----------------------------------------------------------------
;	f[^̃R[h
encodestr:
	movea.l	a0,a1
	moveq.l	#-1,d1
encodestr1:
	addq.w	#1,d1
	move.b	(a0)+,d2
	beq	encodestr4
	bmi	encodestr5
	cmp.b	d0,d2
	bne	encodestr1
encodestr2:
	move.w	#OT_STR,d0		;
	move.b	d1,d0
	move.w	d0,(a2)+
	tst.w	d1
	beq	encodeopr1		;kXgO
	subq.w	#1,d1
	bset.l	#0,d1			;(d1.w = even(d1.w) - 1)
encodestr3:
	move.b	(a1)+,(a2)+
	dbra	d1,encodestr3
	bra	encodeopr1

encodestr5:
  .if EUCSRC=0
	cmp.b	#$A0,d2
	bcs	encodestr6
	cmp.b	#$E0,d2
	bcs	encodestr1		;pJ^Ji
  .else
	bra	encodestr1		;EUC
  .endif
encodestr6:
	addq.w	#1,d1
	tst.b	(a0)+			;2oCg2oCg
	bne	encodestr1
encodestr4:
	subq.l	#1,a0			;̓rōsIĂ܂
	cmp.b	#'"',d0
	beq	termerr_doublequote
	bra	termerr_singlequote

;----------------------------------------------------------------
;	_̓\L𓾂('!xxxx....')
encodeinreal:
	cmpi.b	#'=',(a0)
	beq	encodeopr5		;!=
	move.l	(CMDTBLPTR,a6),d0
	beq	encodeopr5		;߂Ȃ
	movea.l	d0,a1
	moveq.l	#0,d0
	moveq.l	#2-1,d3
	tst.b	(SYM_SIZE,a1)		;gȂTCỸrbg1
	bpl	encodeinreal1		;SZQPMOVEfd
	moveq.l	#SZS|SZD|SZX|SZP,d0
	and.b	(SYM_SIZE,a1),d0	;gȂTCỸrbg1
	bne	encodeopr5		;_߂łȂ
	move.b	(CMDOPSIZE,a6),d0
	bsr	getfplen
	move.w	d1,d3
	bmi	iloprerr		;f[^TCY.s/.d/.x/.płȂ̂ŃG[
	moveq.l	#0,d0
encodeinreal1:
	moveq.l	#0,d1
	moveq.l	#8-1,d2
encodeinreal2:
	move.b	(a0)+,d0		;16i1𓾂
	cmp.b	#'_',d0
	beq	encodeinreal2
	sub.b	#'0',d0
	bcs	encodeinreal5
	cmp.b	#9,d0
	bls	encodeinreal3		;0`9
	or.b	#$20,d0
	sub.b	#'a'-('9'+1),d0
	cmp.b	#10,d0			;a`f
	bcs	encodeinreal5
	cmp.b	#15,d0
	bhi	encodeinreal5
encodeinreal3:
	asl.l	#4,d1
	add.l	d0,d1
	dbra	d2,encodeinreal2
	move.w	#OT_VALUE,(a2)+		;32bitl
	move.l	d1,(a2)+
	move.w	#','|OT_CHAR,(a2)+
	subq.w	#1,d3
	bra	encodeinreal1

encodeinreal5:
	addq.w	#1,d3
	bne	iloprerr		;TCYƓ\L̒Ȃ
	cmp.w	#8-1,d2
	bne	iloprerr		;8̔{łȂ̂ŃG[
	subq.l	#2,a2			;(Ō','͕sv)
	subq.l	#1,a0
	bra	encodeopr1

;----------------------------------------------------------------
;	IyhƂė^ꂽl𓾂
;	in :a0=ւ̃|C^
;	out:d0.l=l0/_1/G[Ȃ-1
;	    d2.l:d1.l=ꂽl     /d3.w:d1.l:d2.l=ꂽl
getnum::
	moveq.l	#0,d0
	moveq.l	#0,d1
	moveq.l	#0,d2			;32bit
	movea.l	a0,a1
	move.b	(a0)+,d0		;1ڂ𓾂
	cmp.b	#'0',d0
	beq	getnum5			;0...
	bcs	getnum1
	cmp.b	#'9',d0
	bls	getdec			;1`9c10i
getnum1:
	cmp.b	#'$',d0
	beq	gethex
	cmp.b	#'@',d0
	beq	getoct
	cmp.b	#'%',d0
	beq	getbin
getnum99:
	movea.l	a1,a0			;l̂Ń|C^߂
	moveq.l	#-1,d0
	rts

getnum5:				;'0'Ŏn܂ꍇ
	move.b	(a0)+,d0
	cmp.b	#'x',d0
	beq	gethex			;0x...
	cmp.b	#'o',d0
	beq	getoct			;0o...
	cmp.b	#'b',d0
	beq	getbin			;0b...
	cmp.b	#'f',d0
	beq	getreal			;0f...
	bra	getdec3			;'0'Ŏn܂10i

getdec:					;xxxx 10i
	sub.b	#'0',d0
getdec1:
;d2:d110{d0
	tst.l	d2
	bne	getdec1_1
	cmp.l	#$19999998,d1		;$19999999ȏ10{9ƈ
	bls	getdec1_2
getdec1_1:
	add.l	d1,d1
	addx.l	d2,d2			;d2:d1=d2:d1*2
	bcs	getdec1_4
	moveq.l	#0,d3
	add.l	d1,d0
	addx.l	d2,d3			;d3:d0=d2:d1*2+d0
	bcs	getdec1_4
	add.l	d1,d1
	addx.l	d2,d2			;d2:d1=d2:d1*4
	bcs	getdec1_4
	add.l	d1,d1
	addx.l	d2,d2			;d2:d1=d2:d1*8
	bcs	getdec1_4
	add.l	d0,d1
	addx.l	d3,d2			;d2:d1=d2:d1*10+d0
	bcc	getdec1_3
getdec1_4:
	bra	getdec4

getdec1_2:
	add.l	d1,d1			;d1=d1*2
	add.l	d1,d0			;d0=d1*2+d0
	lsl.l	#2,d1			;d1=d1*8
	add.l	d0,d1			;d1=d1*10+d0
					;10{O$19999998ȉɐĂ̂ňȂ
getdec1_3:
	moveq.l	#0,d0			;ʂj󂵂̂ŃNAĂ
getdec2:
	move.b	(a0)+,d0
getdec3:
	cmp.b	#'_',d0
	beq	getdec2
	sub.b	#'0',d0
	bcs	getdec9
	cmp.b	#9,d0
	bls	getdec1
getdec9:				;lI
	cmp.b	#'.'-'0',d0
	beq	getdecreal		;xxxx. ͕_̉\
	or.b	#$20,d0
	sub.b	#'a'-'0',d0
	bcs	getdec99
	cmp.b	#'z'-'a',d0
	bls	getdecreal1
getdec99:
	subq.l	#1,a0
	moveq.l	#0,d0
	rts

;Lqꂽ64bit𒴂琮ƂĂ̓G[
;	['0'-'9']*{{'.'['0'-'9']+}|{['.']'e'['+'|'-']['0'-'9']+}}
;𔺂ĂΎƂĂ͗L
getdec4:
	move.b	(a0)+,d0
	cmp.b	#'_',d0
	beq	getdec4
	sub.b	#'0',d0
	bcs	getdec5
	cmp.b	#10,d0
	bcs	getdec4			;XLbv
getdec5:
	cmp.b	#'.'-'0',d0
	beq	getdec6			;_Βオ܂͎w
	or.b	#$20,d0
	cmp.b	#'e'-'0',d0
	beq	getdec7
	bra	ilinterr		;̒オ_łwłȂ

getdec6:
	move.b	(a0)+,d0
	sub.b	#'0',d0
	bcs	ilinterr		;_̒オłwłȂ
	cmp.b	#10,d0
	bcs	getdec8			;_̒オȂ̂Ŏ
	or.b	#$20,d0
	cmp.b	#'e'-'0',d0
	bne	ilinterr		;_̒オłwłȂ
getdec7:
	move.b	(a0)+,d0
	cmp.b	#'+',d0
	beq	getdec71
	cmp.b	#'-',d0
	bne	getdec72
getdec71:
	move.b	(a0)+,d0		;e̒オ+-
getdec72:
	sub.b	#'0',d0
	bcs	ilinterr		;wĂȂ
	cmp.b	#10,d0
	bcc	ilinterr		;wĂȂ
getdec8:
	movem.l	d1-d2/a0,-(sp)
	movea.l	a1,a0
	bsr	strtox			;ɕϊ
	tst.l	d0
	bmi	ilinterr		;łȂ
	lea.l	(12,sp),sp		;
	move.w	d0,d3
	moveq.l	#1,d0
	rts

getdecreal:				;l_ǂׂ
;['0'-'9']+'.'̒
;['0'-'9']*{{'.'['0'-'9']+}|{['.']'e'['+'|'-']['0'-'9']+}}ȂΎ
;.eŔfĂ܂ƌ.e??.ƂZqꂽƂɍ͂Ȃ̂,
;wĂ邩ǂ𐳂`FbN邱
	move.b	(a0),d0
	sub.b	#'0',d0
	bcs	getdec99		;_̒オł͂Ȃ̂Ő
	cmp.b	#10,d0
	bcs	getdecreal5		;_̒オȂ̂Ŏ
	or.b	#$20,d0
	cmp.b	#'e'-'0',d0
	bne	getdec99		;_̒オłwłȂ̂Ő
	move.b	(1,a0),d0
	cmp.b	#'+',d0
	beq	getdecreal01
	cmp.b	#'-',d0
	bne	getdecreal02
getdecreal01:
	move.b	(2,a0),d0		;e̒オ+-
getdecreal02:
	sub.b	#'0',d0
	bcs	getdec99		;wĂȂ
	cmp.b	#10,d0
	bcc	getdec99		;wĂȂ
	bra	getdecreal5

getdecreal1:
	cmp.b	#'e'-'a',d0		;xxxxE ͕_
	bne	getnum99		;xxxx[A-Z]͐lł͂Ȃ([JxQ)
getdecreal5:
	movem.l	d1-d2/a0,-(sp)
	movea.l	a1,a0
	bsr	strtox			;ɕϊ
	tst.l	d0
	bmi	getdecreal9		;ϊłȂ
	lea.l	(12,sp),sp
	move.w	d0,d3
	moveq.l	#1,d0
	rts

getdecreal9:				;ϊłȂ̂ŐƂ
	movem.l	(sp)+,d1-d2/a0
	bra	getdec99

getreal:				;0f.... _
	bsr	strtox			;ɕϊ
	tst.l	d0
	bmi	getnum99		;ϊłȂ
	move.w	d0,d3
	moveq.l	#1,d0
	rts

gethex:					;$xxxx 16i
	move.b	(a0)+,d0
	cmp.b	#'_',d0
	beq	gethex
	sub.b	#'0',d0			;'$'116iłȂ΃G[
	bcs	getnum99
	cmp.b	#9,d0
	bls	gethex5			;0`9
	or.b	#$20,d0
	sub.b	#'a'-('9'+1),d0
	cmp.b	#10,d0			;a`f
	bcs	getnum99
	cmp.b	#15,d0
	bhi	getnum99
gethex5:
	cmp.l	#$10000000,d2
	bcc	ilinterr
	rol.l	#4,d1
	moveq.l	#$0F,d3
	lsl.l	#4,d2
	and.b	d1,d3
	or.b	d3,d2
	eor.b	d3,d1
	or.b	d0,d1
gethex6:
	move.b	(a0)+,d0
	cmp.b	#'_',d0
	beq	gethex6
	sub.b	#'0',d0
	bcs	getnum9
	cmp.b	#9,d0
	bls	gethex5			;0`9
	or.b	#$20,d0
	sub.b	#'a'-('9'+1),d0
	cmp.b	#10,d0			;a`f
	bcs	getnum9
	cmp.b	#15,d0
	bls	gethex5
;	bra	getnum9

getnum9:				;lI
	subq.l	#1,a0
	moveq.l	#0,d0
	rts

getoct:					;@xxxx 8i
	move.b	(a0)+,d0
	cmp.b	#'_',d0
	beq	getoct
	sub.b	#'0',d0			;'@'18iłȂ΃G[
	bcs	getnum99
	cmp.b	#7,d0
	bhi	getnum99		;0`7
getoct5:
	cmp.l	#$20000000,d2
	bcc	ilinterr
	rol.l	#3,d1
	moveq.l	#$07,d3
	lsl.l	#3,d2
	and.b	d1,d3
	or.b	d3,d2
	eor.b	d3,d1
	or.b	d0,d1
getoct6:
	move.b	(a0)+,d0
	cmp.b	#'_',d0
	beq	getoct6
	sub.b	#'0',d0
	bcs	getnum9
	cmp.b	#7,d0
	bls	getoct5			;0`7
	bra	getnum9

getbin:					;%xxxx 2i
	move.b	(a0)+,d0
	cmp.b	#'_',d0
	beq	getbin
	sub.b	#'0',d0			;'%'12iłȂ΃G[
	bcs	getnum99
	cmp.b	#1,d0
	bhi	getnum99		;0`1
getbin5:
	add.l	d1,d1
	addx.l	d2,d2
	bcs	ilinterr
	or.b	d0,d1
getbin6:
	move.b	(a0)+,d0
	cmp.b	#'_',d0
	beq	getbin6
	sub.b	#'0',d0
	bcs	getnum9
	cmp.b	#1,d0
	bls	getbin5			;0`1
	bra	getnum9


;----------------------------------------------------------------
;	Tu[`
;----------------------------------------------------------------

;----------------------------------------------------------------
;	񂩂1𔲂o
;	in :a0=w|C^
;	out:a1=o̎̕w|C^
;	    d1.w=o̒-1/d2.w=ƂĔoȂȂ-1
getword::
	moveq.l	#0,d0
	movea.l	a0,a1
	moveq.l	#-2,d1
getword1:
	move.b	(a1)+,d0
	move.b	(wordtbl,pc,d0.w),d0
	beq	getword8		;ɎgȂ
	bgt	getword1		;Ɏg镶
	tst.b	(a1)+			;2oCg1oCg
	bne	getword1
getword8:
	add.w	a1,d1
	sub.w	a0,d1			;̒-1
	move.w	d1,d2
	bpl	getword9
	clr.w	d1
	rts

getword9:
	subq.l	#1,a1
	rts

wordtbl:				;̒ɋ镶̃e[u
	.dc.b	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0		;
	.dc.b	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0		;
	.dc.b	0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0		;    $           
	.dc.b	1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1		;0123456789     ?
	.dc.b	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1		;@ABCDEFGHIJKLMNO
	.dc.b	1,1,1,1,1,1,1,1,1,1,1,0,1,0,0,1		;PQRSTUVWXYZ \  _
	.dc.b	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1		;`abcdefghijklmno
	.dc.b	1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,0		;pqrstuvwxyz   ~
  .if EUCSRC=0
	.dc.b	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	.dc.b	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	.dc.b	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
	.dc.b	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
	.dc.b	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
	.dc.b	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
	.dc.b	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
	.dc.b	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
  .else
	.dc.b	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
	.dc.b	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
	.dc.b	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
	.dc.b	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
	.dc.b	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
	.dc.b	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
	.dc.b	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
	.dc.b	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
  .endif


;----------------------------------------------------------------
	.end

;----------------------------------------------------------------
;	$Log: encode.s,v $
;	Revision 3.2  1999 10/ 8(Fri) 21:48:40 M.Kamada
;	+86 OQƐ錾V{sxƂčĒ`悤ƂƃoXG[ɂȂs
;	+86 ilsymerrו
;	+86 ilsizeerrו
;	+86 EUCΉ
;
;	Revision 3.1  1999  6/ 9(Wed) 20:14:38 M.Kamada
;	+85 Zq!=Lɂ
;
;	Revision 3.0  1999  3/19(Fri) 16:30:23 M.Kamada
;	+83 u[Jx̎QƂsłvǉ
;	+83 [Jx̍ő包4܂őI\
;	+83 foo=.low.`ȂǂG[ɂȂs
;
;	Revision 2.9  1999  3/ 2(Tue) 20:45:47 M.Kamada
;	+82 G[bZ[W{ꉻ
;	+82 skiphasspcp~
;	+82 getwordœK
;
;	Revision 2.8  1999  2/27(Sat) 23:39:29 M.Kamada
;	+81 \[XXg̃tH[}bgύX(st@C+80Ƃ܂)
;
;	Revision 2.7  1999  2/25(Thu) 04:59:19 M.Kamada
;	+80 ColdFireΉ
;	+80 .sizeof.ǉ
;	+80 .offsym <l>,<V{>
;
;	Revision 2.6  1998  8/22(Sat) 15:44:53 M.Kamada
;	+75 [Jx`łȂȂĂ
;
;	Revision 2.5  1998  8/20(Thu) 23:47:22 M.Kamada
;	+74 .ifsɊԈ[Jx(999:Ȃ)ƃG[o 
;
;	Revision 2.4  1998  3/31(Tue) 02:18:51 M.Kamada
;	+63 wrt`͂ȂȂ̂encode.sdeflabel\[X̐擪Ɉړ
;
;	Revision 2.3  1998  1/24(Sat) 21:12:06 M.Kamada
;	+57 ^.sizemǉ
;
;	Revision 2.2  1998  1/10(Sat) 15:59:06 M.Kamada
;	+56 MOVE to USP̃Gb^
;
;	Revision 2.1  1997 11/ 1(Sat) 19:58:30 M.Kamada
;	+53 1.wG[ɂȂs
;
;	Revision 2.0  1997 10/28(Tue) 17:11:16 M.Kamada
;	+52 PMOVE.D #imm,CRPAZułȂs
;	+52 Lqꂽ64bit𒴂G[
;	+52 1.E+10G[ɂȂs
;
;	Revision 1.9  1997  9/15(Mon) 16:47:07 M.Kamada
;	+46 ST_VALUE=0ōœK,aslœK
;
;	Revision 1.8  1997  7/20(Sun) 03:12:08 M.Kamada
;	+41 P[głȂC
;
;	Revision 1.7  1997  6/24(Tue) 22:15:40 M.Kamada
;	+33 vft@CV{CPUɑΉ
;
;	Revision 1.6  1997  5/12(Mon) 22:27:15 M.Kamada
;	+31 scpusha dcƏƃG[ɂȂssC
;
;	Revision 1.5  1997  3/20(Thu) 16:04:35 M.Kamada
;	+11 2̐[Jxg悤ɂ
;	+23 terminator not foundG[
;
;	Revision 1.4  1994/07/10  11:10:54  nakamura
;	RgJnLN^̒ǉ('#')
;	f[^TCYR[h'.q'̒ǉ
;
;	Revision 1.3  1994/06/09  15:07:10  nakamura
;	V{'$'g悤ɂB
;
;	Revision 1.2  1994/02/24  11:24:22  nakamura
;	[JxŌ̃RYƓd`ŃG[ɂȂ̂CB
;
;	Revision 1.1  1994/02/15  11:55:44  nakamura
;	Initial revision
;
;
