;----------------------------------------------------------------
;	X68k High-speed Assembler
;		t|[hϊƉZ
;		< expr.s >
;
;	$Id: expr.s,v 2.2  1999  6/ 9(Wed) 22:59:26 M.Kamada Exp $
;
;		Copyright 1990-94  by Y.Nakamura
;		          1997-99  by M.Kamada
;----------------------------------------------------------------

	.include	has.equ
	.include	register.equ
	.include	tmpcode.equ
	.include	symbol.equ

	.cpu	68000
	.text


;----------------------------------------------------------------
;	t|[hւ̕ϊ
;----------------------------------------------------------------

;----------------------------------------------------------------
;	t|[hL@ɕϊ
;	in :a0=R[hw|C^/a1=ϊobt@ւ̃|C^
;	out:d0.w=݂̂ŕϊł0/ꂽ1/ϊɎs-1
;	    d1.w=ϊ̃[h-1
convrpn::
	movem.l	d2/a1-a3,-(sp)
	move.l	a0,-(sp)
	move.l	sp,(EXPRSPSAVE,a6)
	sf.b	(EXPRISSTR,a6)
	move.b	#SZ_NONE,(EXPRSIZE,a6)
	lea.l	(RPNSTACK,a6),a2
	moveq.l	#0,d1
	clr.b	(a2)+			;X^bN{gݒ
	bsr	convrpndo
	clr.w	(a1)			;GhR[h(move.w #RPN_END,(a1))
	tst.w	d0
	bpl	convrpn1
	move.l	(sp),a0			;ϊɎŝŃ|C^߂
convrpn1:
	addq.l	#4,sp
	movem.l	(sp)+,d2/a1-a3
	rts

;----------------------------------------------------------------
;	ϊ̎
convrpndo:
	bsr	convrpnnum		;l𓾂
	tst.w	d0
	bne	convrpndo9		;G[
	move.w	(a0),d0
	beq	convrpndo1		;I
;	cmp.w	#')'|OT_CHAR,d0		;????
;	beq	convrpndo1		;????
	bsr	getoperator		;Zq𓾂
	tst.w	d0
	beq	convrpndo
	bra	convrpndo2		;ZqȂ

convrpndo1:				;I
	moveq.l	#0,d0
convrpndo2:				;ZqX^bNɎcĂ鉉Zqo
	move.w	#RPN_OPERATOR,d2
	bra	convrpndo8

convrpndo3:
	cmp.b	#OP_NOTB,d2
	blo	convrpndo39		;.notb./.notw.ȊỎZq
	bhi	convrpndo31
	move.w	#OP_NOT|RPN_OPERATOR,(a1)+	;.notb.X(.not.X).and.$FFɕϊ
	move.w	#$FF|RPN_VALUEB,(a1)+
	move.w	#OP_AND|RPN_OPERATOR,(a1)+
	addq.w	#3,d1
	bra	convrpndo8

convrpndo31:
	move.w	#OP_NOT|RPN_OPERATOR,(a1)+	;.notw.X(.not.X).and.$FFFFɕϊ
	move.w	#RPN_VALUEW,(a1)+
	move.w	#$FFFF,(a1)+
	move.w	#OP_AND|RPN_OPERATOR,(a1)+
	addq.w	#4,d1
	bra	convrpndo8

convrpndo39:
	addq.w	#1,d1			;.notb./.notw.ȊỎZq
	move.w	d2,(a1)+
convrpndo8:
	move.b	-(a2),d2
	bne	convrpndo3
convrpndo9:
	rts

;----------------------------------------------------------------
;	lEPZq𓾂
convrpnnum:
	move.w	(a0)+,d0
	beq	convrpnnum9		;IĂ܂
	cmp.w	#OT_VALUEB,d0
	bcs	convrpnnum_char		;LN^
	cmp.w	#OT_VALUEW,d0
	bcs	convrpnnum_b
	beq	convrpnnum_w
	cmp.w	#OT_VALUE,d0
	beq	convrpnnum_l
	cmp.w	#OT_VALUEQ,d0
	beq	convrpnnum_q
	cmp.w	#OT_SYMBOL,d0
	bne	convrpnnum5
convrpnnum_sym:				;V{
	move.l	(a0)+,a3
	cmpi.b	#ST_LOCAL,(SYM_TYPE,a3)	;(ST_VALUE or ST_LOCAL)
	bhi	convrpnnum_sym9		;lV{łȂ
	move.w	#RPN_SYMBOL,(a1)+	;V{
	move.l	a3,(a1)+
	addq.w	#3,d1
	bra	convrpnnumsize		;㑱̃TCY`FbN

convrpnnum_sym9:
	cmpi.b	#ST_REAL,(SYM_TYPE,a3)
	beq	convrpnnum_real		;_̏ꍇ
	moveq.l	#-1,d0
	rts

convrpnnum_q:
	tst.l	(a0)+
	beq	convrpnnum_q_int_1	;32bit0
	move.b	(a0),d0			;32bit̍ŏʃoCg
	add.b	d0,d0
	subx.l	d0,d0			;32bit>=Ȃ0,32bit<0Ȃ-1
	cmp.l	(-4,a0),d0		;32bit32bit̕gƈv邩
	bne	overflowerr		;32bit0ȊOŉ32bit̕głȂ
convrpnnum_q_int_1:
	move.w	#RPN_VALUE,(a1)+	;32bitl
	move.l	(a0)+,(a1)+
	addq.w	#3,d1			;t|[hϊ̃[h
	bra	convrpnnumsize

convrpnnum_l:
	move.w	d0,(a1)+		;32bitl(RPN_VALUE)
	move.l	(a0)+,(a1)+
	addq.w	#3,d1
	bra	convrpnnumsize		;㑱̃TCY`FbN

convrpnnum_w:
	move.w	d0,(a1)+		;16bitl(RPN_VALUEW)
	move.w	(a0)+,(a1)+
	addq.w	#2,d1
	bra	convrpnnumsize		;㑱̃TCY`FbN

convrpnnum_b:
	move.w	d0,(a1)+		;8bitl(RPN_VALUEB)
	addq.w	#1,d1
convrpnnumsize:				;lEV{Ɍ㑱TCY𓾂
	move.w	(a0),d0
	andi.w	#$FF00,d0
	cmpi.w	#OT_SIZE,d0
	bne	convrpnnumsize9		;TCYw肪Ȃ
	move.w	(a0)+,d0
	move.b	d0,(EXPRSIZE,a6)	;TCYw𓾂
convrpnnumsize9:
	moveq.l	#0,d0
	rts

convrpnnum_char:			;LN^̏ꍇ(OT_CHAR)
	cmp.w	#'('|OT_CHAR,d0
	beq	convrpnnum_paren
	cmp.w	#'-'|OT_CHAR,d0
	beq	convrpnnum_neg
	cmp.w	#'+'|OT_CHAR,d0
	beq	convrpnnum_pos
	cmp.w	#'*'|OT_CHAR,d0
	beq	convrpnnum_loc1
	cmp.w	#'$'|OT_CHAR,d0
	beq	convrpnnum_loc2
convrpnnum_char9:
	moveq.l	#-1,d0
	rts

convrpnnum_paren:
	clr.b	(a2)+			;̃X^bN{gݒ
	bsr	convrpndo		;ʓɂčċAIɏ
	tst.w	d0
;	bne	convrpnnum_char9	;ʓŃG[
					;????
	bmi	convrpnnum_char9	;ʓŃG[
	cmp.w	#')'|OT_CHAR,(a0)+
	bne	convrpnnum_char9	;ʂĂȂ
	moveq.l	#0,d0
	rts

convrpnnum_neg:
	move.b	#OP_NEG,(a2)+		;ZqR[hX^bNɐς
	bra	convrpnnum		;l𓾂

convrpnnum_pos:
	move.b	#OP_POS,(a2)+		;ZqR[hX^bNɐς
	bra	convrpnnum		;l𓾂

convrpnnum_loc1:
	move.w	#RPN_LOCATION,(a1)+	;'*'=݂̃P[VJE^
	addq.w	#1,d1
	moveq.l	#0,d0			;(TCY`FbN͂Ȃ)
	rts

convrpnnum_loc2:
	move.w	#RPN_LOCATION|1,(a1)+	;'$'
	addq.w	#1,d1
	moveq.l	#0,d0			;(TCY`FbN͂Ȃ)
	rts

convrpnnum5:
	move.w	d0,d2
	andi.w	#$FF00,d2
	cmp.w	#OT_STR,d2
	beq	convrpnnum_str
	cmp.w	#OT_OPERATOR,d2
	beq	convrpnnum_unary
	cmp.w	#OT_LOCALREF,d2
	beq	convrpnnum_local
	cmp.w	#OT_REAL,d2
	beq	convrpnnum_real
convrpnnum9:
	moveq.l	#-1,d0
	rts

convrpnnum_str:
	st.b	(EXPRISSTR,a6)		;
	and.w	#$00FF,d0
	beq	convrpnnum9		;kXgOG[
	cmp.w	#4,d0
	bhi	convrpnnum9		;4ȏとG[
	subq.w	#1,d0
	moveq.l	#0,d2
convrpnnum_str1:
	asl.l	#8,d2
	move.b	(a0)+,d2
	dbra	d0,convrpnnum_str1
	move.l	a0,d0
	doeven	d0
	movea.l	d0,a0
	move.w	#RPN_VALUE,(a1)+	;l
	move.l	d2,(a1)+
	addq.w	#3,d1
	bra	convrpnnumsize		;㑱̃TCY`FbN

convrpnnum_unary:
	cmp.b	#OPNOTLK,d0
	bcc	convrpnnum_unary1
	cmp.b	#OP_MUL,d0
	bcc	convrpnnum9		;񍀉ZqȂG[
convrpnnum_unary0:
	move.b	d0,(a2)+		;ZqR[hX^bNɐς
	bra	convrpnnum		;l𓾂

convrpnnum_unary1:
	cmp.b	#OP_SIZEOF,d0
	blo	convrpnnum_unary0	;.notb./.notw.
	beq	convrpnnum_sizeof	;.sizeof.
;	cmp.b	#OP_DEFINED,d0
;	bra	convrpnnum_defined	;.defined.

;.defined.
convrpnnum_defined:
	move.w	(a0)+,d0
	cmp.w	#OT_SYMBOL,d0
	bne	convrpnnum_defined1
;.defined.SYMBOL
	bsr	convrpnnum_defined2
convrpnnum_defined9:
	move.w	#OT_VALUE,(a1)+		;32bitlŕԂ(-1ɂȂȂ̂8bit͕s)
	move.l	d0,(a1)+
	addq.w	#3,d1
	bra	convrpnnumsize		;㑱̃TCY`FbN

convrpnnum_defined1:
	cmp.w	#'('|OT_CHAR,d0
	bne	convrpnnum9
;.defined.(SYMBOL)
	cmpi.w	#OT_SYMBOL,(a0)+
	bne	convrpnnum9
	bsr	convrpnnum_defined2
	cmpi.w	#')'|OT_CHAR,(a0)+
	bne	convrpnnum9
	bra	convrpnnum_defined9

convrpnnum_defined2:
	move.w	#OT_VALUEB,d0
	move.l	(a0)+,a3
	move.b	(SYM_ATTRIB,a3),d0	;cmpi.b #SA_UNDEF,SYM_ATTRIB(a3)
	neg.b	d0
	subx.l	d0,d0
	rts

;.sizeof.()
convrpnnum_sizeof:
	movem.l	d1-d7/a1-a6,-(sp)	;getreglist낢
	clr.w	d7			;TCY̍v
	cmpi.w	#'('|OT_CHAR,(a0)+
	bne	convrpnnum_sizeof99
	cmpi.w	#')'|OT_CHAR,(a0)+
	beq	convrpnnum_sizeof99	;.sizeof.()=0
	subq.l	#2,a0
convrpnnum_sizeof1:
	cmpi.b	#OT_STR>>8,(a0)
	bne	convrpnnum_sizeof2
;.sizeof.('`')
convrpnnum_sizeof11:
	move.w	(a0)+,d0
	and.w	#$00FF,d0
	add.w	d0,d7			;񒷂Z
	addq.w	#1,d0
	and.w	#$FFFE,d0
	adda.w	d0,a0			;̒
	cmpi.b	#OT_STR>>8,(a0)
	beq	convrpnnum_sizeof11
	bra	convrpnnum_sizeof7

convrpnnum_sizeof2:
	bsr	getreglist
	bmi	convrpnnum_sizeof3
;.sizeof.(d0-d7/a0-a7)
	clr.w	d0
	clr.w	d2
	moveq.l	#16-1,d3
convrpnnum_sizeof21:
	add.w	d1,d1
	addx.w	d2,d0
	dbra	d3,convrpnnum_sizeof21
	bra	convrpnnum_sizeof6	;WX^*4

;_WX^C040|C060|CFPPłȂΉ߂Ȃ̂,
;C000Ȃǂł.sizeof.(fp0-fp7)Ȃǂ(ł͐ĂȂ),
;ǃG[ɂȂ
convrpnnum_sizeof3:
	bsr	getfpreglist
	bmi	convrpnnum_sizeof4
;.sizeof.(fp0-fp7)
	clr.w	d0
	clr.w	d2
	moveq.l	#8-1,d3
convrpnnum_sizeof31:
	add.b	d1,d1
	addx.w	d2,d0
	dbra	d3,convrpnnum_sizeof31
	move.w	d0,d1
	add.w	d0,d0
	add.w	d1,d0			;WX^*3
	bra	convrpnnum_sizeof6	;WX^*12

convrpnnum_sizeof4:
	bsr	getfpcreglist
	bmi	convrpnnum_sizeof99
;.sizeof.(fpcr/fpsr/fpiar)
	move.w	d2,d0			;WX^-1
	addq.w	#1,d0			;WX^
;	bra	convrpnnum_sizeof6	;WX^*4

convrpnnum_sizeof6:
	asl.w	#2,d0			;WX^*4/*12
	add.w	d0,d7			;TCYZ
convrpnnum_sizeof7:
	move.w	(a0)+,d0
	cmp.w	#','|OT_CHAR,d0
	beq	convrpnnum_sizeof1
	cmp.w	#')'|OT_CHAR,d0
	bne	convrpnnum_sizeof99
convrpnnum_sizeof8:
	move.w	d7,d0			;TCY̍v
	movem.l	(sp)+,d1-d7/a1-a6
	move.w	#OT_VALUEW,(a1)+	;16bitlƂďo,convrpnnum_w̎gp͕s
	move.w	d0,(a1)+
	addq.w	#2,d1
	bra	convrpnnumsize		;㑱̃TCY`FbN

convrpnnum_sizeof99:
	movem.l	(sp)+,d1-d7/a1-a6
	bra	convrpnnum9

convrpnnum_local:			;[Jx
	move.w	(a0)+,d2
	movem.l	d1/a0-a1,-(sp)
	ext.w	d0			;Έʒu𓾂
	move.w	d2,d1
	add.w	d2,d2
	swap.w	d1
	movea.l	(LOCALMAXPTR,a6),a1
	move.w	(a1,d2.w),d1
	add.w	d0,d1			;QƂ郍[Jxԍ
	bsr	isdefdlocsym
	tst.w	d0
	beq	convrpnnum_local1
	bsr	deflocsymbol		;`Ȃ̂ŃV{o^
convrpnnum_local1:
	move.l	a1,d0
	movem.l	(sp)+,d1/a0-a1
	move.w	#RPN_SYMBOL,(a1)+	;V{
	move.l	d0,(a1)+
	addq.w	#3,d1
	moveq.l	#0,d0			;(TCY`FbN͂Ȃ)
	rts

convrpnnum_real:
	move.l	(CMDTBLPTR,a6),d0
	beq	convrpnnum_real1	;߂Ȃ
	movea.l	d0,a3
	move.b	(SYM_SIZE,a3),d0
	andi.b	#SZS|SZD|SZX|SZP,d0
	bne	convrpnnum_real1	;_Z߂łȂ
	move.b	(CMDOPSIZE,a6),d0
	cmpi.b	#SZ_LONG,d0
	bls	convrpnnum_real1	;TCY.b/.w/.l
	moveq.l	#-1,d0			;_Z̃IyhȂG[ŋA
	rts				;(Ȃ悤ɂ邽)

convrpnnum_real1:
	move.l	(EXPRSPSAVE,a6),sp	;X^bN␳
	move.l	(sp)+,a0		;|C^ɖ߂
	move.b	(CMDOPSIZE,a6),-(sp)
	move.b	#SZ_EXTEND,(CMDOPSIZE,a6)
	bsr	calcfexpr		;_vZ
	move.b	(sp)+,(CMDOPSIZE,a6)
	swap.w	d0
	bsr	xtol			;O[hɕϊ
	tst.w	d1
	bmi	overflowerr		;I[o[t[
	movem.l	(sp)+,d2/a1-a3
	move.w	#RPN_VALUE,(a1)		;ʂ𐮐ƂĊi[
	move.l	d0,(2,a1)
	clr.w	(6,a1)
	moveq.l	#0,d0
	moveq.l	#4-1,d1			;[h-1
	rts

;----------------------------------------------------------------
;	񍀉Zq𓾂
getoperator:
	bsr	convgetopr
	tst.w	d0
	bmi	getoperator9
	and.w	#$00FF,d0
getoperator1:
	moveq.l	#0,d2
	move.b	(-1,a2),d2		;ZX^bN̓e
	move.b	(oprprior_tbl,pc,d2.w),d2
	cmp.b	(oprprior_tbl,pc,d0.w),d2
	bhi	getoperator2
	move.b	-(a2),d2		;X^bN̉Zq̕D揇ʂ̂ŁA
	or.w	#$0600,d2		;X^bNo
	move.w	d2,(a1)+
	addq.w	#1,d1
	bra	getoperator1

getoperator2:				;X^bND揇ʂ̂ŁA
	move.b	d0,(a2)+		;ꂽZqX^bNɐς
	moveq.l	#0,d0
	rts

getoperator9:				;ZqȂ
	moveq.l	#1,d0
	rts

oprprior_tbl:				;Zq̗D揇ʃe[u
	.dc.b	-1			;(X^bN{g)
	.dc.b	1,1,1,1,1,1,1,1		;1:-,+,not,high,low,highw,loww,nul
	.dc.b	2,2,2,2,2,2		;2:*,/,mod,shr,shl,asr
	.dc.b	3,3			;3:-,+
	.dc.b	4,4,4,4,4,4,4,4,4,4	;4:=,<>,<,<=,>,>=,...
	.dc.b	5,6,6			;5:and 6:xor,or
	.even

;----------------------------------------------------------------
;	Zq𓾂
convgetopr:
	move.w	(a0)+,d2
	move.w	d2,d0
	and.w	#$FF00,d2
	beq	convgetopr2		;(cmp.w #OT_CHAR,d2)
	cmp.w	#OT_OPERATOR,d2
	bne	convgetopr7		;Zqł͂Ȃ
	cmp.b	#OP_MUL,d0
	bcs	convgetopr7		;PZqȂG[
	rts

convgetopr2:				;Zq̏ꍇ
	lea.l	(operator_tbl,pc),a3
convgetopr3:
	move.w	(a3)+,d2
	beq	convgetopr7
	cmp.b	d0,d2
	bne	convgetopr3
	ror.w	#8,d2
	move.b	d2,d0
	bpl	convgetopr9		;1̉Zq̏ꍇ
	neg.b	d0
	subq.b	#1,d0
	bne	convgetopr4
	move.w	(a0)+,d2		;'<'Ŏn܂鉉Zq
	moveq.l	#OP_SHL,d0
	cmp.w	#'<'|OT_CHAR,d2
	beq	convgetopr9		;'<<'.shl.
	moveq.l	#OP_NE,d0
	cmp.w	#'>'|OT_CHAR,d2
	beq	convgetopr9		;'<>'.ne.
	moveq.l	#OP_LE,d0
	cmp.w	#'='|OT_CHAR,d2
	beq	convgetopr9		;'<='.le.
	moveq.l	#OP_LT,d0
	bra	convgetopr8		;'<' .lt.

convgetopr4:				;'>'Ŏn܂鉉Zq
	subq.b	#1,d0
	bne	convgetopr5
	move.w	(a0)+,d2
	moveq.l	#OP_SHR,d0
	cmp.w	#'>'|OT_CHAR,d2
	beq	convgetopr9		;'>>'.shr.
	moveq.l	#OP_GE,d0
	cmp.w	#'='|OT_CHAR,d2
	beq	convgetopr9		;'>='.ge.
	moveq.l	#OP_GT,d0
	bra	convgetopr8		;'>' .gt.

convgetopr5:				;'='Ŏn܂鉉Zq
	subq.b	#1,d0
	bne	convgetopr6
	moveq.l	#OP_EQ,d0
	cmpi.w	#'='|OT_CHAR,(a0)+
	beq	convgetopr9		;'=='.eq.
	bra	convgetopr8		;'=' .eq.

convgetopr6:				;'!'Ŏn܂鉉Zq
	moveq.l	#OP_NE,d0
	cmpi.w	#'='|OT_CHAR,(a0)+
	beq	convgetopr9		;'!='.ne.
	subq.l	#2,a0
convgetopr7:
	moveq.l	#-1,d0
convgetopr8:
	subq.l	#2,a0
convgetopr9:
	rts

operator_tbl:				;1Zq̃e[u
	.dc.b	OP_ADD,'+',OP_SUB,'-',OP_MUL,'*',OP_DIV,'/'
	.dc.b	OP_AND,'&',OP_XOR,'^',OP_OR,'|'
	.dc.b	-1,'<',-2,'>',-3,'=',-4,'!',0,0


;----------------------------------------------------------------
;	t|[ȟvZ
;----------------------------------------------------------------

;----------------------------------------------------------------
;	t|[hvZ
;	in :a1=t|[hւ̃|C^
;	out:d0.w=ʂ̑(0:萔/1`4:AhXl(ZNVԍ)/
;			    $FFFF:/$01FF:ItZbgtOQ/$02FF:OQƒl)
;	    d1.l=ʂ̒l
calcrpn::
	movem.l	d2-d6/a0-a2,-(sp)
	lea.l	(RPNSTACK,a6),a2
;	bra	calcrpn1

calcrpn1:
	move.w	(a1)+,d0
	move.w	d0,d1
	andi.w	#$FF00,d1
	cmp.w	#RPN_VALUE,d1
	bls	calcrpnvalue		;l
	cmp.w	#RPN_SYMBOL,d1
	beq	calcrpnsym		;V{
	cmp.w	#RPN_LOCATION,d1
	beq	calcrpnlocctr		;P[VJE^l
	cmp.w	#RPN_OPERATOR,d1
	beq	calcrpnopr		;Zq
calcrpn9:
	move.w	-(a2),d0		;
	move.l	-(a2),d1		;
	movem.l	(sp)+,d2-d6/a0-a2
	rts

;----------------------------------------------------------------
;	`V{o
;<a0.l:V{
calcrpnundef:
	cmpi.b	#3,(ASMPASS,a6)
	beq	calcrpnundef01		;pX3Ŗ`ȂG[
	movem.l	(sp)+,d2-d6/a0-a2
	moveq.l	#0,d1
	moveq.l	#-1,d0
	rts

calcrpnundef01:
	cmpi.b	#ST_LOCAL,(SYM_TYPE,a0)	;[JV{ɂ͖OȂ̂
	beq	calcrpnundef02		;bZ[W𕪂Kv
	move.l	a0,(ERRMESSYM,a6)
	bra	undefsymerr

calcrpnundef02:
	cmpi.w	#100,(SYM_LOCALNO,a0)
	blo	undefsymerr_local
	bra	undefsymerr_offsym

;----------------------------------------------------------------
;	OQƂ܂މZȂǃJɏzꍇ
calcrpnref:
	movem.l	(sp)+,d0/d2-d6/a0-a2	;(X^bN̕␳)
	moveq.l	#0,d1
	move.w	#$02FF,d0
	rts

;----------------------------------------------------------------
;	V{
calcrpnsym:
	movea.l	(a1)+,a0
	cmpi.b	#SA_NODET,(SYM_ATTRIB,a0)
	bls	calcrpnundef		;`V{
	cmpi.b	#SECT_RLCOMM,(SYM_EXTATR,a0)
	bcs	calcrpnsym1
	moveq.l	#0,d0			;OQƃV{
	move.l	d0,(a2)+
	move.b	(SYM_EXTATR,a0),d0
	move.w	d0,(a2)+
	move.w	(SYM_VALUE+2,a0),(ROFSTSYMNO,a6)
	bra	calcrpn1

calcrpnsym1:
	cmpi.b	#2,(ASMPASS,a6)
	beq	calcrpnsym2
	move.l	(SYM_VALUE,a0),(a2)+	;`σV{
	clr.w	d0
	move.b	(SYM_SECTION,a0),d0
	move.w	d0,(a2)+
	move.b	(SYM_ORGNUM,a0),(EXPRORGNUM,a6)
	bra	calcrpn1

calcrpnsym2:
	move.l	(SYM_VALUE,a0),d1
	clr.w	d0
	move.b	(SYM_SECTION,a0),d0
	beq	calcrpnsym3
	cmp.b	(SECTION,a6),d0
	bne	calcrpnsym3
	move.b	(SYM_ORGNUM,a0),d2
	cmp.b	(ORGNUM,a6),d2
	bne	calcrpnsym3
	move.b	(SYM_OPTCOUNT,a0),d2
	cmp.b	(OPTCOUNT,a6),d2
	beq	calcrpnsym3
	sub.l	(LOCOFFSET,a6),d1
calcrpnsym3:
	move.l	d1,(a2)+
	move.w	d0,(a2)+
	move.b	(SYM_ORGNUM,a0),(EXPRORGNUM,a6)
	bra	calcrpn1

;----------------------------------------------------------------
;	P[VJE^l
calcrpnlocctr:
	tst.b	d0
	beq	calcrpnlocctr1
	move.l	(LOCATION,a6),d0	;'$'
	cmpi.b	#3,(ASMPASS,a6)
	bne	calcrpnlocctr0
	move.l	(LCURLOC,a6),d0
	bra	calcrpnlocctr0

calcrpnlocctr1:
	move.l	(LTOPLOC,a6),d0		;'*'
calcrpnlocctr0:
	tst.b	(OFFSYMMOD,a6)
	ble	calcrpnlocctr2
	move.l	a1,-(sp)
	movea.l	(OFFSYMTMP,a6),a1
	cmpi.b	#SA_DEFINE,(SYM_ATTRIB,a1)
	beq	calcrpnlocctr3
	movea.l	a1,a0
	movea.l	(sp)+,a1
	bra	calcrpnundef

calcrpnlocctr3:
	add.l	(OFFSYMVAL,a6),d0	;+l
	sub.l	(SYM_VALUE,a1),d0	;-V{l
	movea.l	(sp)+,a1
calcrpnlocctr2:
	move.l	d0,(a2)+
	clr.w	d0
	move.b	(SECTION,a6),d0
	move.w	d0,(a2)+
	move.b	(ORGNUM,a6),(EXPRORGNUM,a6)
	bra	calcrpn1

;----------------------------------------------------------------
;	l
calcrpnvalue:
	cmp.w	#RPN_VALUEB,d1
	bcs	calcrpn9
	bne	calcrpnvalue1
	and.l	#$000000FF,d0		;8bitl
	bra	calcrpnvalue9

calcrpnvalue1:
	cmp.w	#RPN_VALUEW,d1
	bne	calcrpnvalue2
	moveq.l	#0,d0			;16bitl
	move.w	(a1)+,d0
	bra	calcrpnvalue9

calcrpnvalue2:
	move.l	(a1)+,d0		;32bitl
calcrpnvalue9:
	move.l	d0,(a2)+
	clr.w	(a2)+			;(萔l)
	bra	calcrpn1

;----------------------------------------------------------------
;	Zq
calcrpnopr:
	moveq.l	#0,d4
	move.b	d0,d4
	move.w	-(a2),d2		;A
	move.l	-(a2),d0
	cmp.b	#OP_MUL,d4
	bcs	calcrpnopr1		;PZq (opr)A
	move.l	d0,d1
	move.w	d2,d3
	move.w	-(a2),d2		;B B(opr)A
	move.l	-(a2),d0
calcrpnopr1:
	add.w	d4,d4
	move.w	(oprjp_tbl,pc,d4.w),d4
	jsr	(oprjp_tbl,pc,d4.w)
	move.l	d0,(a2)+
	move.w	d2,(a2)+
	bra	calcrpn1

;----------------------------------------------------------------
;	Zq̃Wve[u
oprjp_tbl:
	.dc.w	0			;(_~[)
	.dc.w	_neg-oprjp_tbl		; -	(PZq)
	.dc.w	_pos-oprjp_tbl		; +
	.dc.w	_not-oprjp_tbl		;.not.
	.dc.w	_high-oprjp_tbl		;.high.
	.dc.w	_low-oprjp_tbl		;.low.
	.dc.w	_highw-oprjp_tbl	;.highw.
	.dc.w	_loww-oprjp_tbl		;.loww.
	.dc.w	_nul-oprjp_tbl		;.nul.
	.dc.w	_mul-oprjp_tbl		; *	(񍀉Zq)
	.dc.w	_div-oprjp_tbl		; /
	.dc.w	_mod-oprjp_tbl		;.mod.
	.dc.w	_shr-oprjp_tbl		;.shr.	(>>)
	.dc.w	_shl-oprjp_tbl		;.shl.	(<<)
	.dc.w	_asr-oprjp_tbl		;.asr.
	.dc.w	_sub-oprjp_tbl		; -
	.dc.w	_add-oprjp_tbl		; +
	.dc.w	_eq-oprjp_tbl		;.eq.	(=,==)
	.dc.w	_ne-oprjp_tbl		;.ne.	(<>,!=)
	.dc.w	_lt-oprjp_tbl		;.lt.	(<)
	.dc.w	_le-oprjp_tbl		;.le.	(<=)
	.dc.w	_gt-oprjp_tbl		;.gt.	(>)
	.dc.w	_ge-oprjp_tbl		;.ge.	(>=)
	.dc.w	_slt-oprjp_tbl		;.slt.
	.dc.w	_sle-oprjp_tbl		;.sle.
	.dc.w	_sgt-oprjp_tbl		;.sgt.
	.dc.w	_sge-oprjp_tbl		;.sge.
	.dc.w	_and-oprjp_tbl		;.and.	(&)
	.dc.w	_xor-oprjp_tbl		;.xor.	(^)
	.dc.w	_or-oprjp_tbl		;.or.	(|)

;----------------------------------------------------------------
;	PZq
_neg:
	neg.l	d0
_pos:
	tst.w	d2
	bne	calcrpnref		;萔ȊOɑ΂鉉Z̓JɎz
	rts

_not:
	not.l	d0
	bra	_pos

_high:
	lsr.l	#8,d0
_low:
	and.l	#$000000FF,d0
	bra	_pos

_loww:
	swap.w	d0
_highw:
	clr.w	d0
	swap.w	d0
	bra	_pos

_nul:
	moveq.l	#0,d0
	bra	_pos

;----------------------------------------------------------------
;	񍀉Zq
_mul:
	or.w	d3,d2
	bne	calcrpnref		;萔młȂ΃JɎz
	move.l	d0,d4			;A(=d0)~B(=d1)
	eor.l	d1,d4
	tst.l	d0
	bpl	_mul1
	neg.l	d0			;A<0
_mul1:
	tst.l	d1
	bpl	_mul2
	neg.l	d1			;B<0
_mul2:
	move.l	d0,d2
	move.l	d0,d3
	mulu.w	d1,d0			;Al~Bl
	swap.w	d2
	mulu.w	d1,d2			;Ah~Bl
	swap.w	d2
	clr.w	d2
	add.l	d2,d0			;A~Bl
	swap.w	d1
	mulu.w	d1,d3			;Al~Bh
	swap.w	d3
	clr.w	d3
	add.l	d3,d0
	tst.l	d4
	bpl	_mul3
	neg.l	d0			;ʂ
_mul3:
	moveq.l	#0,d2
	rts

_div:
	or.w	d3,d2
	bne	calcrpnref		;萔młȂ΃JɎz
_divl:
	move.l	d0,d4			;A(=d0)B(=d1)
	move.l	d0,d5
	eor.l	d1,d4
	tst.l	d0
	bpl	_divl1
	neg.l	d0			;A<0
_divl1:
	tst.l	d1
	beq	divzeroerr		;0
	bpl	_divl2
	neg.l	d1			;B<0
_divl2:
	moveq.l	#0,d2			;]
	moveq.l	#0,d3			;
	moveq.l	#32-1,d6
_divl3:
	add.l	d3,d3			;d2.ld0.ld3.l
	roxl.l	#1,d0
	roxl.l	#1,d2
	cmp.l	d1,d2
	bcs	_divl4
	sub.l	d1,d2
	addq.l	#1,d3
_divl4:
	dbra	d6,_divl3
	move.l	d3,d0
	tst.l	d4
	bpl	_divl5
	neg.l	d0			;ʂ
_divl5:
	move.l	d2,d1
	tst.l	d5
	bpl	_divl6
	neg.l	d1			;]肪
_divl6:
	moveq.l	#0,d2
	rts

_mod:
	or.w	d3,d2
	bne	calcrpnref		;萔młȂ΃JɎz
	bsr	_divl
	move.l	d1,d0
	rts

_sub:
	cmp.w	#SECT_RLCOMM,d2
	bcc	_sub3
	cmp.w	#SECT_RLCOMM,d3
	bcc	calcrpnref		;<??>-<O>
	cmp.w	d2,d3
	bne	_sub2
	tst.w	d2
	beq	_sub1
	cmpi.b	#1,(ASMPASS,a6)		;<AhX>-<AhX> (ZNV)
	bne	_sub1
	tst.b	(OPTIMIZE,a6)
	beq	calcrpnref		;œKꍇ̃pX1Ȃۗ
_sub1:
	moveq.l	#0,d2			;<萔>-<萔>
_sub15:
	sub.l	d1,d0
	rts

_sub2:					;ZNVႤꍇ
	tst.w	d2
	beq	calcrpnref		;<萔>-<AhX>
	tst.w	d3
	bne	calcrpnref		;<AhX>-<AhX>
	cmpi.b	#1,(ASMPASS,a6)		;<AhX>-<萔>
	bne	_sub15
	tst.b	(OPTIMIZE,a6)
	beq	calcrpnref		;œKꍇ̃pX1Ȃۗ
	bra	_sub15

_sub3:
	tst.w	d3
	bne	calcrpnref		;<O>-<O>/<O>-<AhX>
	move.w	#$01FF,d2		;<O>-<萔>(ItZbgtOQ)
	bra	_sub15

_add:
	cmp.w	#SECT_RLCOMM,d2
	bcc	_add3			;<O>+<??>
	cmp.w	#SECT_RLCOMM,d3
	bcc	_add4			;<??>+<O>
	move.w	d3,d4
	or.w	d2,d4
	bne	_add1
	add.l	d1,d0			;<萔>+<萔>
	rts

_add1:
	tst.w	d3
	beq	_add2
	tst.w	d2
	bne	calcrpnref		;<AhX>+<AhX>
_add2:
	cmpi.b	#1,(ASMPASS,a6)		;<AhX>+<萔>/<萔>+<AhX>
	bne	_add25
	tst.b	(OPTIMIZE,a6)
	beq	calcrpnref		;œKꍇ̃pX1Ȃۗ
_add25:
	add.l	d1,d0
	add.l	d3,d2
	rts

_add3:
	exg.l	d0,d1
	exg.l	d2,d3
_add4:
	cmp.w	#SECT_RLCOMM,d2
	bcc	calcrpnref		;<O>+<O>
	tst.w	d2
	bne	calcrpnref		;<AhX>+<O>
	add.l	d1,d0			;<萔>+<O>
	move.w	#$01FF,d2		;(ItZbgtOQ)
	rts

_shr:
	lsr.l	d1,d0
_shr9:
	or.w	d3,d2
	bne	calcrpnref		;萔młȂ΃JɎz
	rts

_shl:
	lsl.l	d1,d0
	bra	_shr9

_asr:
	asr.l	d1,d0
	bra	_shr9

_eq:
	cmp.l	d1,d0
	seq.b	d0
_eq9:
	ext.w	d0
	ext.l	d0
	bra	_shr9

_ne:
	cmp.l	d1,d0
	sne.b	d0
	bra	_eq9

_lt:
	cmp.l	d1,d0
	scs.b	d0
	bra	_eq9

_le:
	cmp.l	d1,d0
	sls.b	d0
	bra	_eq9

_gt:
	cmp.l	d1,d0
	shi.b	d0
	bra	_eq9

_ge:
	cmp.l	d1,d0
	scc.b	d0
	bra	_eq9

_slt:
	cmp.l	d1,d0
	slt.b	d0
	bra	_eq9

_sle:
	cmp.l	d1,d0
	sle.b	d0
	bra	_eq9

_sgt:
	cmp.l	d1,d0
	sgt.b	d0
	bra	_eq9

_sge:
	cmp.l	d1,d0
	sge.b	d0
	bra	_eq9

_and:
	and.l	d1,d0
	bra	_shr9

_xor:
	eor.l	d1,d0
	bra	_shr9

_or:
	or.l	d1,d0
	bra	_shr9


;----------------------------------------------------------------
	.end

;----------------------------------------------------------------
;	$Log: expr.s,v $
;	Revision 2.2  1999  6/ 9(Wed) 22:59:26 M.Kamada
;	+85 Zq.notb./.notw.ǉ
;
;	Revision 2.1  1999  3/19(Fri) 15:26:42 M.Kamada
;	+83 [Jx̍ő包4܂őI\
;
;	Revision 2.0  1999  2/28(Sun) 20:09:14 M.Kamada
;	+82 G[bZ[W{ꉻ
;
;	Revision 1.9  1999  2/27(Sat) 23:40:53 M.Kamada
;	+81 \[XXg̃tH[}bgύX(st@C+80Ƃ܂)
;
;	Revision 1.8  1999  2/24(Wed) 21:45:56 M.Kamada
;	+80 .sizeof..defined.ǉ
;	+80 .offsym <l>,<V{>
;
;	Revision 1.7  1997 11/23(Sun) 15:58:06 M.Kamada
;	+54 _C~fBGCg̕\Lɕ̐Ȃs
;
;	Revision 1.6  1997 10/26(Sun) 16:36:13 M.Kamada
;	+52 PMOVE.D #imm,CRPAZułȂs
;
;	Revision 1.5  1994/07/10  15:04:26  nakamura
;	኱̃oOtBbNX
;
;	Revision 1.4  1994/06/09  14:30:56  nakamura
;	ʓɕ_ꍇ̃X^bN␳̃oOCB
;
;	Revision 1.3  1994/05/29  10:04:56  nakamura
;	pX2Ő̒lȂƂoOC
;
;	Revision 1.2  1994/03/06  09:10:26  nakamura
;	'$'P[VJE^lwȂƂoOfix
;
;	Revision 1.1  1994/02/15  16:00:04  nakamura
;	Initial revision
;
;
