;----------------------------------------------------------------
;	X68k High-speed Assembler
;		IuWFNgt@C
;		< objgen.s >
;
;	$Id: objgen.s,v 2.9  1999 10/ 8(Fri) 21:52:11 M.Kamada Exp $
;
;		Copyright 1990-94  by Y.Nakamura
;			  1996-99  by M.Kamada
;----------------------------------------------------------------

	.include	has.equ
	.include	symbol.equ
	.include	register.equ
	.include	tmpcode.equ
	.include	cputype.equ
	.include	eamode.equ

.ifdef	DO_CDTOR
O_CTOR:		.equ	$4c01
O_DTOR:		.equ	$4d01
O_CTORSIZE:	.equ	$c00c
O_DTORSIZE:	.equ	$c00d
O_DOCTOR:	.equ	$e00c
O_DODTOR:	.equ	$e00d
.endif	/* DO_CDTOR */

	.cpu	68000
	.text


;----------------------------------------------------------------
;	pX3(IuWFNgt@C̐)
;----------------------------------------------------------------
asmpass3::
	move.b	#3,(ASMPASS,a6)
	tst.b	(MAKEPRN,a6)
	beq	asmpass31
	lea.l	(SOURCEPTR,a6),a1
	bsr	frewind			;\[Xt@C擪Ɉړ
	move.l	a1,(INPFILPTR,a6)
asmpass31:
	move.l	(CPUSYMBOL,a6),d0
	beq	asmpass319
	movea.l	d0,a1
	move.l	(STARTCPU,a6),(SYM_VALUE,a1)
asmpass319:
	lea.l	(TEMPFILPTR,a6),a1
	bsr	frewind			;e|t@C擪Ɉړ
	lea.l	(OBJFILPTR,a6),a0
	move.l	a0,(OUTFILPTR,a6)
	movea.l	(OBJFILE,a6),a0
	bsr	createopen		;IuWFNgt@C̃I[v

	clr.w	(NUMOFERR,a6)
	sf.b	(ISASMEND,a6)
	clr.l	(DSBSIZE,a6)
	clr.l	(OBJLENCTR,a6)
	sf.b	(ISOBJOUT,a6)
	clr.w	(OBJCONCTR,a6)

	clr.w	(IFNEST,a6)
	clr.w	(INCLDNEST,a6)
	clr.w	(MACNEST,a6)
	clr.w	(MACREPTNEST,a6)
	clr.w	(MACLOCSMAX,a6)
	sf.b	(ISNLIST,a6)
	clr.w	(PAGEFLG,a6)
	sf.b	(ISMACDEF,a6)

	bsr	makeobjhead		;IuWFNgwb_̍쐬
	bsr	resetlocctr		;P[VJE^̏
	bsr	outaligninfo		;ACg̏o
	bsr	outxrefdef		;OV{̏o
	bsr	dopass3			;pX3̎s
	bsr	xdefmodify		;O`V{o͂̏C
	bsr	prnsymtbl		;V{e[ȕo
	bsr	prnundefsym		;`V{Xg̏o
	bsr	inpclose		;t@C̃N[Y
	bra	outclose
**	rts


;----------------------------------------------------------------
;	IuWFNgt@C̃wb_쐬
;----------------------------------------------------------------
makeobjhead:
	move.w	#$D000,d0		;D000 [t@CTCY] t@C` 00
	bsr	wrtd0w
	moveq.l	#0,d0
	bsr	wrtd0l
	lea.l	(SOURCENAME,a6),a0
	bsr	wrtstr
	lea.l	(section_name,pc),a0
	lea.l	(LOCCTRBUF,a6),a1
	moveq.l	#4-1,d1
	move.w	#$C001,d2
	tst.b	(MAKERSECT,a6)
	beq	makeobjhead1
	moveq.l	#10-1,d1		;΃ZNVgpꍇ
makeobjhead1:
	move.w	d2,d0
	bsr	wrtd0w			;C0[ZNVԍ] [IuWFNg] ZNV` 00
	move.l	(a1)+,d0		;P[VJE^l
	bsr	wrtd0l
	bsr	wrtstr			;ZNV
	addq.b	#1,d2
	dbra	d1,makeobjhead1

.ifdef	DO_CDTOR
		move.l	(CTORSIZE,a6),d0
		add.l	(DTORSIZE,a6),d0
		beq	makeobjhead_cdtor_skip

		lea	(cdtor_name,pc),a0
		lea	(CTORSIZE,a6),a1
		move	#O_CTORSIZE,d2
		moveq	#2-1,d1
makeobjhead_cdtor_loop:
		move	d2,d0
		bsr	wrtd0w
		move.l	(a1)+,d0
		bsr	wrtd0l
		bsr	wrtstr
		addq.b	#1,d2
		dbra	d1,makeobjhead_cdtor_loop
makeobjhead_cdtor_skip:
.endif	/* DO_CDTOR */

	move.l	(REQFILPTR,a6),d0
	beq	makeobjhead9		;requestt@CȂ
makeobjhead2:
	movea.l	d0,a1
	move.w	#$E001,d0		;E001 requestt@C` 00
	bsr	wrtd0w
	lea.l	(4,a1),a0
	bsr	wrtstr
	move.l	(a1),d0
	bne	makeobjhead2
makeobjhead9:

.ifdef	DO_CDTOR
		tst.b	(DOCTOR_FLAG,a6)
		beq	@f
		move	#O_DOCTOR,d0		;.doctor
		bsr	wrtd0w
@@:
		tst.b	(DODTOR_FLAG,a6)
		beq	@f
		move	#O_DODTOR,d0		;.dodtor
		bsr	wrtd0w
@@:
.endif	/* DO_CDTOR */

	rts

section_name:				;ZNV
	.dc.b	'text',0,'data',0,'bss',0,'stack',0
	.dc.b	'rdata',0,'rbss',0,'rstack',0,'rldata',0,'rlbss',0,'rlstack',0
.ifdef	DO_CDTOR
cdtor_name:	.dc.b	'ctor',0,'dtor',0
.endif
	.even


;----------------------------------------------------------------
;	ACgo͂
;----------------------------------------------------------------
outaligninfo:
	move.b	(MAKEALIGN,a6),d0
	or.b	(MAKESYMDEB,a6),d0
	beq	outaligninfo9		;ACgfobOsv
	tst.b	(MAKEALIGN,a6)
	bne	outaligninfo1		;fobÔ݂Kvȏꍇ,
	move.b	#1,(MAXALIGN,a6)		;ACl2^1=2ƂB
outaligninfo1:
	lea.l	(LINEBUF,a6),a0
	move.b	#'*',(a0)+		;'*'+t@C+'*' ƂV{쐬
	movea.l	(SOURCEFILE,a6),a1
	bsr	strcpy
	move.b	#'*',(a0)+
	clr.b	(a0)+
	move.w	#$B204,d0		;B204 [ACl] '*'+t@C+'*' ` 00
	bsr	wrtd0w
	moveq.l	#0,d0
	move.b	(MAXALIGN,a6),d0
	bsr	wrtd0l
	lea.l	(LINEBUF,a6),a0
	bra	wrtstr

outaligninfo9:
	rts


;----------------------------------------------------------------
;	OQƁE`V{o͂
;----------------------------------------------------------------
outxrefdef:
	clr.l	(XREFSYMNO,a6)
	sf.b	(ISXDEFMOD,a6)
	sf.b	(ISUNDEFSYM,a6)

	move.l	(SYMTBLBEGIN,a6),d3
	beq	outxrefdef9		;V{Ȃ
outxrefdef1:
	movea.l	d3,a1
	move.w	#SYMEXTCOUNT-1,d2	;1̃e[uubÑV{
	move.l	(a1)+,d3
	bne	outxrefdef2		;܂̃ubN
	sub.w	(SYMTBLCOUNT,a6),d2	;Ō̃ubN̏ꍇ

outxrefdef2:
	tst.b	(SYM_TYPE,a1)		;cmpi.b #ST_VALUE,(SYM_TYPE,a1)
	bne	outxrefdef7		;lV{ȊOȂ牽Ȃ

	move.b	(SYM_EXTATR,a1),d0
	cmpi.b	#SECT_XDEF,d0
	beq	outxdef			;O`V{
	cmpi.b	#SECT_XREF,d0
	beq	outxref			;OQƃV{
	cmpi.b	#SECT_GLOBL,d0
	beq	outglobl		;globlV{
	tst.b	d0
	bne	outcomm			;RV{

	tst.b	(SYM_ATTRIB,a1)		;(cmpi.b #SA_UNDEF,(SYM_ATTRIB,a1))
	beq	outxrefdef3
	tst.b	(ALLXDEF,a6)		;`σV{̏ꍇ
	bne	outxdef0		;/dIvVΊO`ɂ
	bra	outxrefdef8

outxrefdef3:
	tst.b	(ALLXREF,a6)		;`V{̏ꍇ
	bne	outxref0		;/uIvVΊOQƂɂ
outxrefdef5:
	st.b	(ISUNDEFSYM,a6)		;`V{̏ꍇ
outxrefdef8:
	lea.l	(SYM_TBLLEN,a1),a1	;̃V{AhX
	dbra	d2,outxrefdef2
	tst.l	d3
	bne	outxrefdef1		;̃e[uubN

	cmp.l	#$8000,(XREFSYMNO,a6)
	bcc	toomanyexabort		;OQƃV{̂Œ~
outxrefdef9:
	rts

outxrefdef7:
	cmpi.b	#ST_REAL,(SYM_TYPE,a1)
	bne	outxrefdef8
	tst.b	(SYM_FSIZE,a1)
	bpl	outxrefdef8
	st.b	(ISUNDEFSYM,a6)		;`̕_V{̏ꍇ
	bra	outxrefdef8

outglobl:				;globlV{̏o
	tst.b	(SYM_ATTRIB,a1)		;(cmpi.b #SA_UNDEF,(SYM_ATTRIB,a1))
	beq	outxref0		;`ȂOQƂɂ

outxdef0:
;??Ŏn܂V{O`ɂȂ
	movea.l	(SYM_NAME,a1),a0	;̐擪
	cmpi.b	#'?',(a0)+
	bne	outxdef0x
	cmpi.b	#'?',(a0)+
	bne	outxdef0x
		move.b	(a0)+,d0
		beq	outxdef0x
outxdef0_chk_lp:
		subi.b	#'0',d0
		subi.b	#9,d0
		bls	@f
		subq.b	#'A'-'9',d0
		subq.b	#'F'-'A',d0
		bhi	outxdef0x
@@:		move.b	(a0)+,d0
		bne	outxdef0_chk_lp
		bra	outxrefdef8
outxdef0x:
	move.b	#SECT_XDEF,(SYM_EXTATR,a1)
outxdef:				;O`V{̏o
	cmpi.b	#SA_NODET,(SYM_ATTRIB,a1)
	bcs	outxrefdef5		;`ȂG[
	bhi	outxdef1
	st.b	(ISUNDEFSYM,a6)
	st.b	(ISXDEFMOD,a6)		;mlȂ̂ŌŏC
outxdef1:
	GETFPTR	OBJFILPTR,d0		;݂̃t@C|C^𓾂
	move.l	d0,(SYM_NEXT,a1)	;V{l̏Cp
	move.b	(SYM_SECTION,a1),d1
	bsr	outsymbol
	bra	outxrefdef8

outxref0:
	move.b	#SECT_XREF,(SYM_EXTATR,a1)
outxref:				;OQƃV{̏o
	move.b	#SA_DEFINE,(SYM_ATTRIB,a1)
	addq.l	#1,(XREFSYMNO,a6)	;V{ԍt
	move.l	(XREFSYMNO,a6),(SYM_VALUE,a1)
	moveq.l	#SECT_XREF,d1
	move.b	d1,(SYM_SECTION,a1)
	bsr	outsymbol
	bra	outxrefdef8

outcomm:				;RV{̏o
	move.b	#SA_DEFINE,(SYM_ATTRIB,a1)
	move.b	d0,d1
	move.b	d0,(SYM_SECTION,a1)
	bsr	outsymbol
	addq.l	#1,(XREFSYMNO,a6)	;o͌ɃV{ԍt
	move.l	(XREFSYMNO,a6),(SYM_VALUE,a1)
	bra	outxrefdef8

outsymbol:				;V{̏o
	move.w	#$B200,d0		;B2[ZNVԍ] [l] V{` 00
	move.b	d1,d0
	bsr	wrtd0w
	move.l	(SYM_VALUE,a1),d0	;xdef:V{l/xref:V{ԍ/comm:GATCY
	bsr	wrtd0l
	movea.l	(SYM_NAME,a1),a0
	bra	wrtstr


;----------------------------------------------------------------
;	O`V{̏C
;----------------------------------------------------------------
xdefmodify:
	tst.b	(ISXDEFMOD,a6)
	beq	xdefmodify9		;O`V{̏C͕sv
	sf.b	(ISUNDEFSYM,a6)

	move.l	(SYMTBLBEGIN,a6),d3
	beq	xdefmodify9		;V{Ȃ
xdefmodify1:
	movea.l	d3,a0
	move.w	#SYMEXTCOUNT-1,d2	;1̃e[uubÑV{
	move.l	(a0)+,d3
	bne	xdefmodify2		;܂̃ubN
	sub.w	(SYMTBLCOUNT,a6),d2	;Ō̃ubN̏ꍇ

xdefmodify2:
	tst.b	(SYM_TYPE,a0)		;cmpi.b #ST_VALUE,(SYM_TYPE,a0)
	bne	xdefmodify7		;lV{ȊOȂ牽Ȃ

	cmpi.b	#SECT_XDEF,(SYM_EXTATR,a0)
	beq	xdefdomodify		;O`V{
	tst.b	(SYM_ATTRIB,a0)		;(cmpi.b #SA_UNDEF,(SYM_ATTRIB,a1))
	bne	xdefmodify5
xdefmodify3:
	st.b	(ISUNDEFSYM,a6)		;`V{̏ꍇ
xdefmodify5:
	lea.l	(SYM_TBLLEN,a0),a0	;̃V{AhX
	dbra	d2,xdefmodify2
	tst.l	d3
	bne	xdefmodify1		;̃e[uubN
xdefmodify9:
	rts

xdefmodify7:
	cmpi.b	#ST_REAL,(SYM_TYPE,a0)
	bne	xdefmodify5
	tst.b	(SYM_FSIZE,a0)
	bpl	xdefmodify5
	st.b	(ISUNDEFSYM,a6)		;`̕_V{̏ꍇ
	bra	xdefmodify5

xdefdomodify:
	cmpi.b	#SA_NODET,(SYM_ATTRIB,a0)
	bls	xdefmodify3		;mȂG[
	lea.l	(OBJFILPTR,a6),a1
	move.l	(SYM_NEXT,a0),d1
	move.w	#$B200,d0		;B2[ZNVԍ] [l] V{` 00
	move.b	(SYM_SECTION,a0),d0	;ZNVԍ
	bsr	fmodify
	move.l	(SYM_VALUE,a0),d0	;V{l
	addq.l	#2,d1
	swap.w	d0
	bsr	fmodify
	addq.l	#2,d1
	swap.w	d0
	bsr	fmodify
	bra	xdefmodify5


;----------------------------------------------------------------
;	pX3̎s(IuWFNg̏o)
;----------------------------------------------------------------
dopass3:
	move.l	sp,(SPSAVE,a6)
	lea.l	(dopass31,pc),a0
	move.l	a0,(ERRRET,a6)
	st.b	(PFILFLG,a6)
	bsr	scdinit			;SCDf[^p[N̏
	clr.l	(LINENUM,a6)		;sԍJE^Zbg
dopass31:
	move.l	(LOCATION,a6),(LCURLOC,a6)
	bsr	tmpreadd0w
	move.w	d0,d1
	beq	dopass32		;e|t@CI
dopass315:
	clr.b	d1
	sub.w	d1,d0
	ror.w	#6,d1
	jsr	(pass3_tbl-4,pc,d1.w)
	move.l	(LOCATION,a6),(LCURLOC,a6)
	bsr	tmpreadd0w
	move.w	d0,d1
	bne	dopass315
dopass32:
	sf.b	(ISOBJOUT,a6)		;(offsetZNVŏÎ)
	bsr	outobj1w		;0000:IuWFNgt@CI
	bsr	scdout			;SCDf[^̏o
	lea.l	(OBJFILPTR,a6),a1
	bsr	fflush			;IuWFNgt@Cobt@tbV
	move.l	(OBJLENCTR,a6),d0	;IuWFNgt@C
	moveq.l	#2,d1
	swap.w	d0
	bsr	fmodify
	moveq.l	#4,d1
	swap.w	d0
	bsr	fmodify
	tst.b	(MAKEPRN,a6)
	bne	prnline			;PRNt@CŏIso
	rts

;----------------------------------------------------------------
;	e|t@CR[hAhX
pass3_tbl:
	bra.w	linetop		;01	1sJn
	bra.w	symdata		;02	V{l
	bra.w	rpndata		;03	t|[h

	bra.w	dispadr		;04	(d,An)
	bra.w	disppc		;05	(d,PC)
	bra.w	indexadr	;06	(d,An,Rn)
	bra.w	indexpc		;07	(d,PC,Rn)
	bra.w	extcode		;08	g[h
	bra.w	bdadr		;09	AhXWX^Ԑڃx[XfBXv[Xg
	bra.w	bdpc		;0A	PCԐڃx[XfBXv[Xg
	bra.w	odisp		;0B	AE^fBXv[Xg

	bra.w	bracmd		;0C	bra/bsr/b<cc>.s/.w/.l
	bra.w	cpbracmd	;0D	cpb<cc>.w/.l
	bra.w	dspcode		;0E	(d,An)/(d,PC)̖߃R[h
	bra.w	coderpn		;0F	߃R[hߍݎf[^
	bra.w	constdata	;10	AhXˑf[^
	bra.w	bitfield	;11	rbgtB[hf[^
	bra.w	dscmd		;12	.ds
	bra.w	dcbcmd		;13	.dcb
	bra.w	aligncmd	;14	ACg̒
	bra.w	sectchg		;15	ZNVύX
	bra.w	ofstcmd		;16	.offset
	bra.w	equconst	;17	萔.equ/.set
	bra.w	equexpr		;18	EAhX.equ/.set
	bra.w	xdefcmd		;19	.xdef
	bra.w	prnctrl		;1A	Xgo͐
	bra.w	pagecmd		;1B	.page
	bra.w	subttlcmd	;1C	.subttl
	bra.w	orgcmd		;1D	.org
	bra.w	endcmd		;1E	.end
	bra.w	incldopen	;1F	includet@CJn
	bra.w	incldend	;20	includet@CI
	bra.w	macdef		;21	}N`Jn
	bra.w	macext		;22	}NWJJn
	bra.w	exitmcmd	;23	.exitm
	bra.w	reptcmd		;24	.reptWJJn
	bra.w	irpcmd		;25	.irp/.irpcWJJn
	bra.w	mdefbgn		;26	}N`Jn
	bra.w	mdefend		;27	}N`I
	bra.w	lncmd		;28	.ln
	bra.w	valcmd		;29	.val
	bra.w	tagcmd		;2A	.tag
	bra.w	scdshort	;2B	.endef(Z`)
	bra.w	scdlong		;2C	.endef(`)
	bra.w	funcend		;2D	.scl -1(֐`I)

	bra.w	fequset		;2E	.fequ/.fset
	bra.w	symdef		;2F	V{`
	bra.w	fdcbcmd		;30	.dcb(_)
	bra.w	jbracmd		;31	jbra/jbsr/jb<cc>
	bra.w	dispopc		;32	(d,OPC)
	bra.w	linkcmd		;33	link.w/.l

	bra.w	nopdeath	;34	폜ׂNOP
	bra.w	nopalive	;35	}ꂽNOP

	bra.w	prnadv		;36	PRNt@Cւ̐so

	bra.w	offsymcmd	;37	.offsym

	bra.w	error		;38	G[

	bra.s	cpucmd		;39	.cpu

.ifdef	DO_CDTOR
	bra.w	ctorcmd		;3a	.ctor
	bra	dtorcmd		;3b	.dtor

;----------------------------------------------------------------
dtorcmd:
		bsr	tmpreadsymex
		move	#O_DTOR,d2
		bra	@f
ctorcmd:
		bsr	tmpreadsymex
		move	#O_CTOR,d2
@@:		subq.b	#SECT_TEXT,d0
		bne	iloprerr
		move	d2,d0
		bsr	outobj1w
		move.l	d1,d0		;AhX
		bra	wrtd0l
.endif	/* DO_CDTOR */

;----------------------------------------------------------------
cpucmd:					;39xx .cpu
	bsr	tmpreadd0w
	move	d0,(CPUTYPE,a6)
	rts

;----------------------------------------------------------------
error:
	move.w	d0,d3
	bsr	tmpreadd0l		;(ERRMESSYM,a6)
	exg.l	d0,d3			;d0.w=G[R[h
					;d3.l=V{(0=V{Ȃ)
	bra	errout_d3

;----------------------------------------------------------------
nopdeath:				;34xx 폜ׂNOP
	bra	tmpreadd0w		;1[hǂݔ΂(0ɂȂĂ͂)

;----------------------------------------------------------------
nopalive:				;35xx }ꂽNOP
	bsr	f43gwarn
	bra	constdata

;----------------------------------------------------------------
symdef:					;2FXX V{`
	bra	tmpreadd0l

;----------------------------------------------------------------
dspcode:				;0Exx (d,An)/(d,PC)̖߃R[h
extcode:				;08xx g[h
	moveq.l	#2-1,d0
;	bra	constdata		;g[ho͂

;----------------------------------------------------------------
constdata:				;10xx AhXˑf[^
	move.w	d0,d1
constdata1:
	bsr	tmpreadd0w
	subq.w	#2,d1
	bcs	constdata2		;c1or2oCgŃf[^I
	bsr	out1wobj
	addq.l	#2,(LOCATION,a6)
	bra	constdata1

constdata2:
	addq.w	#1,d1
	bne	constdata3
	bsr	out1wobj		;oCgŃf[^Iꍇ
	addq.l	#2,(LOCATION,a6)
	rts

constdata3:				;oCgŃf[^Iꍇ
	lsr.w	#8,d0
	bsr	out1bobj
	addq.l	#1,(LOCATION,a6)
	rts

;----------------------------------------------------------------
prnadv:					;36xx PRNt@Cւ̐so
	tst.b	(MAKEPRN,a6)
	bne	prnlineadv
	rts

;----------------------------------------------------------------
linetop:				;01xx 1sJn
	tst.b	(MAKEPRN,a6)
	bne	linetop5
	cmp.b	#$02,d0
	bcc	linetop1		;}NWJ͍sԍύXȂ
	addq.l	#1,(LINENUM,a6)
linetop1:
	move.l	(LOCATION,a6),(LTOPLOC,a6)
	tst.b	(MAKESYMDEB,a6)
	bne	linetop7		;'-g'XCb`w肳ꂽꍇ
	rts

linetop5:				;XeBOsꍇ
	bsr	prnline			;O1so
	move.w	(PAGEFLG,a6),d0
	beq	linetop6
	and.w	#$FF,d0
	bsr	prnnextpage		;y[W
	clr.w	(PAGEFLG,a6)
linetop6:
	bsr	getline
	move.w	d0,(PRNLATR,a6)
	bra	linetop1

linetop7:				;fobOpsԍo͂
	tst.b	d0
	bne	linetop9		;.includet@C/}NWJł͏o͂Ȃ
	cmpi.b	#SECT_TEXT,(SECTION,a6)
	bne	linetop9		;.textZNVȊOł͏o͂Ȃ
	movea.l	(SCDLNPTR,a6),a0
	adda.l	(LNOFST,a6),a0
	move.l	(LOCATION,a6),(a0)+	;P[V
	move.l	(LINENUM,a6),d0
	move.w	d0,(a0)+		;sԍ
	addq.l	#6,(LNOFST,a6)
	addq.l	#1,(NUMOFLN,a6)
linetop9:
	rts

;----------------------------------------------------------------
symdata:				;02xx V{l
	move.w	d0,d2
	bsr	getdtsize
	add.l	d0,(LOCATION,a6)
	bsr	tmpreadsym		;V{l𓾂
	bra	outobjexpr

;----------------------------------------------------------------
rpndata:				;03xx t|[h
	move.w	d0,d2
	bsr	getdtsize
	add.l	d0,(LOCATION,a6)
	bsr	tmpreadexpr		;̒l𓾂
	bra	outobjexpr

;----------------------------------------------------------------
dispadr:				;04xx (d,An)
	bsr	tmpreadd0w
	move.w	d0,d2
	and.b	#3,d2			;(ESZ_OPTrbgNA)
	beq	tmpreadsymex1		;fBXv[XgTvXꂽ
	or.b	#ESZ_ADR,d2
	addq.l	#2,(LOCATION,a6)
	cmp.b	#ESZ_ADR|SZ_WORD,d2	;fBXv[XgTCY
	beq	dispadr_w
dispadr_l:				;fBXv[XgO[hȂ̂
	addq.l	#4,(LOCATION,a6)	;x[XfBXv[XgɂȂ
	bra68	d0,dispadr_lerr
;ColdFireł̓x[XfBXv[Xg͕s
	tst.b	(CPUTYPE2,a6)
	bne	dispadr_lerr
	move.w	#EXW_FULL|EXW_BDL|EXW_IS,d0	;O[h̏ꍇ̊g[h
	bsr	out1wobj		;g[ho͂
	move.w	d2,d0
dispadr_w:
	bsr	tmpreadsymex1
	bra	outobjexpr

dispadr_lerr:				;68000/68010Ȃ32bitItZbg͎gpłȂ
	bsr	tmpreadsymex1		;fBXv[Xgǂݔ΂
	bra	exprerr

;----------------------------------------------------------------
indexadr:				;06xx (d,An,Rn)
	bsr	tmpreadd0w		;g[hǂݍ
	move.w	d0,d2
	bsr	tmpreadd0w
	exg.l	d0,d2
	and.b	#3,d2			;(ESZ_OPTrbgNA)
	or.b	#ESZ_ADR,d2
	cmp.b	#ESZ_ADR|SZ_SHORT,d2	;fBXv[XgTCY
	beq	indexadr_s
	cmp.b	#ESZ_ADR|SZ_LONG,d2
	beq	indexadr_l
indexadr_w:
	addq.l	#4,(LOCATION,a6)
	or.w	#EXW_FULL|EXW_BDW,d0
	bra	indexadr_l1

indexadr_l:
	addq.l	#6,(LOCATION,a6)
	or.w	#EXW_FULL|EXW_BDL,d0
indexadr_l1:
	bsr	out1wobj		;g[ho͂
	bra	indexadr2

indexadr_s:
	addq.l	#2,(LOCATION,a6)
	lsr.w	#8,d0
	bsr	out1bobj		;g[h̏ʂo͂
indexadr2:
	move.w	d2,d0
	bsr	tmpreadsymex1
	bra	outobjexpr

;----------------------------------------------------------------
bdadr:					;09xx AhXWX^Ԑڃx[XfBXv[Xg
odisp:					;0Bxx AE^fBXv[Xg
	bsr	tmpreadd0w
	move.w	d0,d2
	and.b	#3,d2			;(ESZ_OPTrbgNA)
	beq	tmpreadsymex1		;fBXv[XgTvXꂽ
	or.b	#ESZ_ADR,d2
	addq.l	#2,(LOCATION,a6)
	cmp.b	#ESZ_ADR|SZ_LONG,d2	;fBXv[XgTCY
	bne	bdadr_w
bdadr_l:
	addq.l	#2,(LOCATION,a6)
bdadr_w:
	bsr	tmpreadsymex1
	bra	outobjexpr

;----------------------------------------------------------------
disppc:					;05xx (d,PC)
	move.l	(LOCATION,a6),d5	;(PCԐڂ̊AhX)
	bsr	tmpreadd0w
	move.w	d0,d2
	and.b	#3,d2			;(ESZ_OPTrbgNA)
	addq.l	#2,(LOCATION,a6)
	cmp.b	#SZ_WORD,d2		;fBXv[XgTCY
	beq	outpcdisp
	addq.l	#4,(LOCATION,a6)
	move.w	#EXW_FULL|EXW_BDL|EXW_IS,d0	;O[h̏ꍇ̊g[h
	bsr	out1wobj		;g[ho͂
	move.w	d2,d0
	bra	outpcdisp

;----------------------------------------------------------------
dispopc:				;32xx (d,OPC)
	move.l	(LOCATION,a6),d5	;(PCԐڂ̊AhX)
	bsr	tmpreadd0w
	move.w	d0,d2
	and.b	#3,d2			;(ESZ_OPTrbgNA)
	addq.l	#2,(LOCATION,a6)
	cmp.b	#SZ_WORD,d2		;fBXv[XgTCY
	beq	outpcdisp
	addq.l	#2,(LOCATION,a6)	;(d,PC)xxxx.l
	bsr	tmpreadsymex1
	bra	outobjexpr

;----------------------------------------------------------------
indexpc:				;07xx (d,PC,Rn)
	move.l	(LOCATION,a6),d5	;(PCԐڂ̊AhX)
	bsr	tmpreadd0w		;g[hǂݍ
	move.w	d0,d2
	bsr	tmpreadd0w
	exg.l	d0,d2
	and.b	#3,d2			;(ESZ_OPTrbgNA)
	cmp.b	#SZ_SHORT,d2		;fBXv[XgTCY
	beq	indexpc_s
	cmp.b	#SZ_LONG,d2
	beq	indexpc_l
indexpc_w:
	addq.l	#4,(LOCATION,a6)
	or.w	#EXW_FULL|EXW_BDW,d0
	bra	indexpc_l1

indexpc_l:
	addq.l	#6,(LOCATION,a6)
	or.w	#EXW_FULL|EXW_BDL,d0
indexpc_l1:
	bsr	out1wobj		;g[ho͂
	bra	indexpc2

indexpc_s:
	addq.l	#2,(LOCATION,a6)
	lsr.w	#8,d0
	bsr	out1bobj		;g[h̏ʂo͂
indexpc2:
	move.w	d2,d0
	bra	outpcdisp

;----------------------------------------------------------------
bdpc:					;0Axx PCԐڃx[XfBXv[Xg
	move.l	(LOCATION,a6),d5
	subq.l	#2,d5			;(PCԐڂ̊AhX(g[h̃AhX))
	bsr	tmpreadd0w
	move.w	d0,d2
	and.b	#3,d2			;(ESZ_OPTrbgNA)
	beq	tmpreadsymex1		;fBXv[XgTvXꂽ
	addq.l	#2,(LOCATION,a6)
	cmp.b	#SZ_LONG,d2		;fBXv[XgTCY
	bne	outpcdisp
	addq.l	#2,(LOCATION,a6)
	bra	outpcdisp

;----------------------------------------------------------------
linkcmd:				;33xx link.w/.l
	move.l	(LOCATION,a6),d5
	addq.l	#2,d5
	move.l	d5,(LCURLOC,a6)		;('$'̃AhX)
	move.w	d0,d3
	bsr	tmpreadd0w
	move.w	d0,d2
	and.b	#3,d2			;(ESZ_OPTrbgNA)
	cmp.b	#SZ_WORD,d2		;fBXv[XgTCY
	beq	link_w
link_l:
	addq.l	#2,(LOCATION,a6)
	or.w	#$4808,d3		;link.l̖߃R[h
	bra	link9

link_w:
	or.w	#$4E50,d3		;link.w̖߃R[h
link9:
	move.w	d3,d0
	bsr	out1wobj		;߃R[ho͂
	addq.l	#4,(LOCATION,a6)
	move.w	d2,d0
	bsr	tmpreadsymex1
	bra	outobjexpr

;----------------------------------------------------------------
jbracmd:				;31xx jbra/jbsr/jb<cc>
	move.l	(LOCATION,a6),d5
	addq.l	#2,d5			;(fBXv[Xg̊AhX)
	bsr	tmpreadd0w		;߃R[hǂݍ
	move.w	d0,d3
	bsr	tmpreadd0w
	move.w	d0,d2
	and.b	#3,d2			;(ESZ_OPTrbgNA)
	beq	tmpreadsymex1		;u`߂TvXꂽ
	cmp.b	#SZ_LONG,d2		;fBXv[XgTCY
	bne	bracmd1			;.lłȂbra/bsr/b<cc>
	move.w	#$4EB9,d1		;(jsr̖߃R[h)
	cmp.w	#$6100,d3
	beq	jbracmd9		;bsr  jsr
	bcs	jbracmd8		;bra  jmp
	eori.w	#$0106,d3		;b<cc>  b</cc> $+8 & jmp
	move.w	d3,d0
	bsr	out1wobj		;߃R[ho͂
	addq.l	#2,(LOCATION,a6)
jbracmd8:
	move.w	#$4EF9,d1		;(jmp̖߃R[h)
jbracmd9:
	move.w	d1,d0
	bsr	out1wobj		;߃R[ho͂
	addq.l	#6,(LOCATION,a6)
	move.w	d2,d0
	bsr	tmpreadsymex1
	tst.w	d0			;l̃ZNV
	beq	ilrelerr_const		;萔ȂG[
	bra	outobjexpr

;----------------------------------------------------------------
bracmd:					;0Cxx bra/bsr/b<cc>.s/.w/.l
	move.l	(LOCATION,a6),d5
	addq.l	#2,d5			;(fBXv[Xg̊AhX)
	bsr	tmpreadd0w		;߃R[hǂݍ
	move.w	d0,d3
	bsr	tmpreadd0w
	move.w	d0,d2
	and.b	#3,d2			;(ESZ_OPTrbgNA)
	beq	tmpreadsymex1		;u`߂TvXꂽ
bracmd1:
	cmp.b	#SZ_SHORT,d2		;fBXv[XgTCY
	beq	bracmd_s
	cmp.b	#SZ_WORD,d2
	beq	bracmd_w_test
bracmd_l:
	addq.l	#2,(LOCATION,a6)
	st.b	d3			;ʃ[h$FFȂ烍O[hu`
bracmd_w:				;ʃ[h$00Ȃ烏[hu`
	move.w	d3,d0
	bsr	out1wobj		;߃R[ho͂
	addq.l	#4,(LOCATION,a6)
	move.w	d2,d0
	bra	outpcbra

bracmd_s:
	addq.l	#2,(LOCATION,a6)
	move.w	d3,d0
	lsr.w	#8,d0
	bsr	out1bobj		;߃R[ho͂
	move.w	d2,d0
	bra	outpcbra

;jbsrg
bracmd_w_test:
	tst.b	(OPTBSR,a6)
	beq	bracmd_w		;ւbsrœKȂ
	cmp.b	#SZ_WORD|$40,d0
	bne	bracmd_w		;ւbsrł͂Ȃ
	addq.l	#4,(LOCATION,a6)
	move.w	d2,d0
	st.b	d3
	bsr	tmpreadsymex1
;AhXlȊO⑼̃ZNVւ̃ItZbg͍œK̑Ώۂł͂Ȃ̂,
;ւbsr̃tO,ɂ͂Ȃ
;	move.w	d0,d4			;l̃ZNV
;	beq	ilrelerr_const		;萔ȂG[
;	cmp.b	SECTION(a6),d4
;	bne	bracmd_w_rsect		;̃ZNVւ̃ItZbg
	sub.l	d5,d1			;݂̃AhX̑Βl
	move.l	d1,d0
	subq.l	#2,d0
	bne	bracmd_w_bsr		;alignȂǂ̉eŊԂĂ܂Ă
bracmd_w_pea:
	move.l	#$487A_0002,d0
	bsr	out1lobj		;pea (2,pc)
	bra	prnpccode

;ւbsraligñpfBOׂƂ,peaɒuĂ͂ȂȂ.
;peaɕςĂ܂,aligñpfBOs^C~OωĂ܂,
;aligñpfBOӖ̂R[hꍇɖ肪\.
bracmd_w_bsr:
	move.w	#$6100,d0
	bsr	out1wobj		;bsr.w
	bra	outpcdisp_w

;bracmd_w_rsect:
;	move.w	#$6100,d0
;	bsr	out1wobj
;	bra	outpcdisp5

;----------------------------------------------------------------
cpbracmd:				;0Dxx cpb<cc>.w/.l
	move.l	(LOCATION,a6),d5
	addq.l	#2,d5			;(fBXv[Xg̊AhX)
	bsr	tmpreadd0w		;߃R[hǂݍ
	move.w	d0,d3
	bsr	tmpreadd0w
	move.w	d0,d2
	and.b	#3,d2			;(ESZ_OPTrbgNA)
	beq	tmpreadsymex1		;u`߂TvXꂽ
	cmp.b	#SZ_WORD,d2		;fBXv[XgTCY
	beq	cpbracmd_w
cpbracmd_l:
	addq.l	#2,(LOCATION,a6)
	or.w	#$0040,d3		;b6=1Ȃ烍O[hu`
cpbracmd_w:				;b6=0Ȃ烏[hu`
	move.w	d3,d0
	bsr	out1wobj		;߃R[ho͂
	addq.l	#4,(LOCATION,a6)
	move.w	d2,d0
;	bra	outpcbra

;----------------------------------------------------------------
;	PCԐڃItZbgo͂
;	in :d0.w=T_SYMBOL or T_RPN/d2.b=TCY/d5.l=AhX
outpcbra:				;bra/cpbra
	st.b	d3
	bsr	tmpreadsymex1
	move.w	d0,d4			;l̃ZNV
	bne	outpcdisp0
	bra	ilrelerr_const		;萔ȂG[

outpcdisp:				;PCԐڃAhbVO
	sf.b	d3
	bsr	tmpreadsymex1
	move.w	d0,d4			;l̃ZNV
	beq	outpcdisp1		;萔̏ꍇ
outpcdisp0:
	cmp.b	(SECTION,a6),d4
	bne	outpcdisp5		;̃ZNVւ̃ItZbg
	sub.l	d5,d1			;݂̃AhX̑Βl
outpcdisp1:
	cmp.b	#SZ_SHORT,d2		;fBXv[XgTCY
	beq	outpcdisp_s
	cmp.b	#SZ_LONG,d2
	beq	outpcdisp_l
outpcdisp_w:
	move.l	d1,d0
	ext.l	d0
	cmp.l	d1,d0
	bne	ilrelerr_outside	;16bitItZbg͈̔͊O
	bsr	out1wobj
	bra	prnpccode

outpcdisp_l:
	bra68	d0,ilrelerr_outside	;68000/68010Ȃ32bitItZbg͎gpłȂ
;ColdFireł32rbg̃ItZbg͕s
	tst.b	(CPUTYPE2,a6)
	bne	ilrelerr_outside
	move.l	d1,d0
	bsr	out1lobj
	bra	prnpccode

outpcdisp_s:
	move.l	d1,d0
	ext.w	d0
	ext.l	d0
	cmp.l	d1,d0
	bne	ilrelerr_outside	;8bitItZbg͈̔͊O
	tst.b	d3
	beq	outpcdisp_s1
	tst.b	d1			;u`ItZbg̏ꍇ
	beq	ilrelerr_outside	;(ItZbg$00ȂG[)
	cmp.b	#$FF,d1
	beq	ilrelerr_outside	;(ItZbg$FFȂG[)
outpcdisp_s1:
	bsr	out1bobj
	bra	prnpccode

outpcdisp5:				;̃ZNVւ̃ItZbg
	bsr	prnextcode
	cmp.w	#SECT_XREF,d4
	beq	outpcdisp8		;OQƒlւ̃ItZbg
	bhi	outpcdisp7
	bsr	prnopccode
outpcdisp7:
	bsr	outobjrpn		;t|[ho
	move.w	#$8000,d0		;݂̃P[VJE^lX^bNɐς
	move.b	(SECTION,a6),d0
	bsr	outobj1w
	move.l	d5,d0
	bsr	wrtd0l
	move.w	#$A00F,d0		;X^bŇZ(ItZbg߂)
	bsr	wrtd0w

	move.w	#$9300,d0
	cmp.b	#SZ_SHORT,d2
	beq	wrtd0w
	move.w	#$9900,d0
	cmp.b	#SZ_WORD,d2
	beq	wrtd0w
	move.w	#$9200,d0
	bra	wrtd0w

outpcdisp8:				;OQƒlւ̃ItZbg
	move.w	#$6B00,d0		;V[gItZbg
	cmp.b	#SZ_SHORT,d2
	beq	outpcdisp9
	move.w	#$6500,d0		;[hItZbg
	cmp.b	#SZ_WORD,d2
	bne	outpcdisp7		;(O[hItZbgȂ)
outpcdisp9:
	move.b	(SECTION,a6),d0
	bsr	outobj1w
	move.l	d5,d0
	bsr	wrtd0l
	move.w	d1,d0			;OQƔԍ
	bra	wrtd0w

;----------------------------------------------------------------
;	PCԐڃf[^PRNt@Cɏo͂
prnpccode:
	tst.b	(MAKEPRN,a6)
	beq	prnpccode9
	movea.l	(PRNLPTR,a6),a0
	move.b	#'_',(a0)+
	move.l	d1,d0
	add.l	d5,d0
	bsr	convhex8
	move.b	#-1,(a0)+
	move.l	a0,(PRNLPTR,a6)
prnpccode9:
	rts

;----------------------------------------------------------------
;	̃ZNVւ̃ItZbgPRNt@Cɏo͂
prnopccode:
	tst.b	(MAKEPRN,a6)
	beq	prnopccode9
	movea.l	(PRNLPTR,a6),a0		;'_(xx)xxxxxxxx'
	move.b	#'_',(a0)+
	move.b	#'(',(a0)+
	move.b	d4,d0
	bsr	convhex2		;ZNVԍ
	move.b	#')',(a0)+
	move.l	d1,d0
	bsr	convhex8
	move.b	#-1,(a0)+
	move.l	a0,(PRNLPTR,a6)
prnopccode9:
	rts

;----------------------------------------------------------------
coderpn:				;0Fxx ߃R[hߍݎf[^
	move.w	d0,d1
	addq.l	#2,(LOCATION,a6)
	bsr	tmpreadd0w		;߃R[hǂݍ
	move.w	d0,d3
	subq.w	#1,d1
	bmi	cmdimm8			;TCR_IMM8
	beq	cmdimm8s		;TCR_IMM8S
	subq.w	#2,d1
	bmi	cmdmoveq		;TCR_MOVEQ
	subq.w	#1,d1
	bmi	cmdtrap			;TCR_TRAP
	subq.w	#1,d1
	bmi	cmdbkpt			;TCR_BKPT
;	bra	cmdimm3q		;TCR_IMM3Q

cmdimm3q:				;mov3q
	bsr	tmpreadsymex		;㑱̃f[^ǂݍ
	tst.w	d0
	bne	cmdimmer		;萔łȂꍇ
	tst.l	d1
	beq	ilquickerr_mov3q	;-1,1`7͈̔͊O
	bpl	cmdimm81
	addq.l	#1,d1
	bra	cmdimm81

cmdimm8s:				;sftrot
	bsr	tmpreadsymex		;㑱̃f[^ǂݍ
	tst.w	d0
	bne	cmdimmer		;萔łȂꍇ
	subq.l	#1,d1
	cmp.l	#8,d1
	bcc	ilquickerr_sftrot	;NCbNTCY͈̔͊O
	bra	cmdimm82

cmdimm8:				;subq,addq,...
	bsr	tmpreadsymex		;㑱̃f[^ǂݍ
	tst.w	d0
	bne	cmdimmer		;萔łȂꍇ
	subq.l	#1,d1
cmdimm81:
	cmp.l	#8,d1
	bcc	ilquickerr_addsubq	;NCbNTCY͈̔͊O
cmdimm82:
	addq.w	#1,d1
	and.w	#$0007,d1
	ror.w	#7,d1
	or.w	d3,d1			;߃R[hƍ
	move.w	d1,d0
	bra	out1wobj

cmdimmer:
	cmp.w	#SECT_COMM,d0
	bls	ilvalueerr		;AhXlȂG[
	bra	featureerr_xref		;OQƒl͖T|[g

cmdmoveq:				;moveq
	bsr	tmpreadsymex		;㑱̃f[^ǂݍ
	tst.w	d0
	bne	cmdmoveq5		;萔łȂꍇ
	move.l	d1,d0
	ext.w	d0
	ext.l	d0
	cmp.l	d1,d0
	beq	cmdmoveq1		;-$80`$7F̏ꍇ
	cmp.l	#$100,d1
	bcc	ilquickerr_moveq	;$100ȏ̓G[
cmdmoveq1:
	exg.l	d0,d3
	move.b	d3,d0			;߃R[hƍ
	bra	out1wobj

cmdmoveq5:
	cmp.w	#SECT_COMM,d0
	bls	ilvalueerr		;AhXlȂG[
	exg.l	d0,d3
	lsr.w	#8,d0
	bsr	out1bobj		;߃R[ho
	exg.l	d0,d3
	moveq.l	#SZ_SHORT,d2
	bra	outobjexpr

cmdtrap:				;trap
	bsr	tmpreadsymex		;㑱̃f[^ǂݍ
	tst.w	d0
	bne	cmdimmer		;萔łȂꍇ
	cmp.l	#16,d1
	bcc	ilvalueerr		;l0`15܂
	or.w	d3,d1			;߃R[hƍ
	move.w	d1,d0
	bra	out1wobj

cmdbkpt:				;bkpt
	bsr	tmpreadsymex		;㑱̃f[^ǂݍ
	tst.w	d0
	bne	cmdimmer		;萔łȂꍇ
	cmp.l	#8,d1
	bcc	ilvalueerr		;l0`8܂
	or.w	d3,d1			;߃R[hƍ
	move.w	d1,d0
	bra	out1wobj

;----------------------------------------------------------------
bitfield:				;11xx rbgtB[hf[^
	move.w	d0,d1
	addq.l	#2,(LOCATION,a6)
	bsr	tmpreadd0w		;߃R[hǂݍ
	move.w	d0,d3
	subq.w	#1,d1
	bpl	bitfield1
	bsr	bitfgetof		;TBF_OF(ItZbg)
	move.w	d3,d0
	bra	out1wobj

bitfield1:
	subq.w	#1,d1
	bpl	bitfield2
	bsr	bitfgetwd		;TBF_WD()
	move.w	d3,d0
	bra	out1wobj

bitfield2:
	bsr	bitfgetof		;TBF_OFWD(ItZbgEƂ)
	bsr	bitfgetwd
	move.w	d3,d0
	bra	out1wobj

bitfgetof:				;ItZbg𓾂
	bsr	tmpreadsymex		;㑱̃f[^ǂݍ
	tst.w	d0
	bne	cmdimmer		;萔łȂꍇ
	cmp.l	#31,d1
	bhi	ilvalueerr		;ItZbgl0`31
	lsl.w	#6,d1
	or.w	d1,d3
	rts

bitfgetwd:				;𓾂
	bsr	tmpreadsymex		;㑱̃f[^ǂݍ
	tst.w	d0
	bne	cmdimmer		;萔łȂꍇ
	tst.l	d1
	beq	ilvalueerr		;1`32
	cmp.l	#32,d1
	bhi	ilvalueerr
	and.w	#31,d1
	or.w	d1,d3
	rts

;----------------------------------------------------------------
dscmd:					;12xx .ds
	bsr	tmpreadd0l
	add.l	d0,(LOCATION,a6)
	tst.b	(ISOBJOUT,a6)
	bne	dscmd1
	add.l	d0,(DSBSIZE,a6)
dscmd1:
	rts

;----------------------------------------------------------------
dcbcmd:					;13xx .dcb
	bsr	tmpreadd0w		;f[^̌
	move.w	d0,d3
	bsr	tmpreadd0w
	move.w	d0,d2
	bsr	getdtsize		;f[^TCY𓾂
	move.w	d3,d4
	addq.w	#1,d4
	mulu.w	d4,d0			;f[^̃TCY
	add.l	d0,(LOCATION,a6)	;KvȃTCYJE^i߂
	move.l	d0,d5
	move.w	d2,d0
	bsr	tmpreadsymex1

	tst.b	(MAKEPRN,a6)
	beq	dcbcmd1
	cmp.l	#128,d5
	bcc	dcbcmd5
dcbcmd1:
	movem.l	d0-d3,-(sp)
	bsr	outobjexpr		;f[^o
	movem.l	(sp)+,d0-d3
	dbra	d3,dcbcmd1
	rts

dcbcmd5:				;PRNt@Co͎Af[^128bytesȏ̏ꍇ
	movea.l	(PRNLPTR,a6),a0
	lea.l	(dcb_msg,pc),a1
	bsr	strcpy			;'value= '
	move.l	a0,(PRNLPTR,a6)
dcbcmd6:
	movem.l	d0-d3,-(sp)
	bsr	outobjexpr		;f[^o
	sf.b	(MAKEPRN,a6)		;(PRNt@Cɏo͍͂̂ŏ1)
	movem.l	(sp)+,d0-d3
	dbra	d3,dcbcmd6
dcbcmd65:
	st.b	(MAKEPRN,a6)
	movea.l	(PRNLPTR,a6),a0
	lea.l	(dcb_msg2,pc),a1
	move.b	#-1,(a0)+		;(PRNt@CR[hs)
	bsr	strcpy			;'count= '
	move.l	d5,d0			;o̓oCg
	cmp.l	#$FFFF,d0
	bhi	dcbcmd7
	bsr	convhex4
	bra	dcbcmd8

dcbcmd7:
	bsr	convhex8
dcbcmd8:
	bsr	strcpy			;'bytes'
	move.b	#-1,(a0)+
	move.l	a0,(PRNLPTR,a6)
	rts

dcb_msg:	.dc.b	'value= ',0
dcb_msg2:	.dc.b	'count= ',0,'bytes',0
	.even

;----------------------------------------------------------------
fdcbcmd:				;30xx .dcb(_)
	move.w	d0,d1			;f[^
	move.w	d0,d4
	bsr	tmpreadd0w		;f[^̌
	move.w	d0,d3
	ext.l	d0
	addq.l	#1,d0
	add.l	d0,d0
	add.l	d0,d0
	moveq.l	#0,d2
fdcbcmd1:
	add.l	d0,d2
	dbra	d1,fdcbcmd1
	add.l	d2,(LOCATION,a6)		;KvȃTCYJE^i߂
	lea.l	(OPRBUF,a6),a2
	movea.l	a2,a1
	moveq.l	#3-1,d1
fdcbcmd2:
	bsr	tmpreadd0l		;f[^ǂݏo
	move.l	d0,(a1)+
	dbra	d1,fdcbcmd2
	tst.b	(MAKEPRN,a6)
	beq	fdcbcmd3
	cmp.l	#128,d2
	bcc	fdcbcmd5
fdcbcmd3:
	move.w	d4,d1
	movea.l	a2,a1
fdcbcmd4:
	move.l	(a1)+,d0
	bsr	out1lobj		;f[^o
	dbra	d1,fdcbcmd4
	dbra	d3,fdcbcmd3
	rts

fdcbcmd5:				;PRNt@Co͎Af[^128bytesȏ̏ꍇ
	movea.l	(PRNLPTR,a6),a0
	lea.l	(dcb_msg,pc),a1
	bsr	strcpy			;'value= '
	move.l	a0,(PRNLPTR,a6)
	move.l	d2,d5			;o̓oCg
fdcbcmd6:
	move.w	d4,d1
	movea.l	a2,a1
fdcbcmd7:
	move.l	(a1)+,d0
	bsr	out1lobj		;f[^o
	dbra	d1,fdcbcmd7
	sf.b	(MAKEPRN,a6)		;(PRNt@Cɏo͍͂̂ŏ1)
	dbra	d3,fdcbcmd6
	bra	dcbcmd65

;----------------------------------------------------------------
aligncmd:				;14xx ACg̒
	moveq.l	#1,d1
	lsl.l	d0,d1
	subq.l	#1,d1			;d1=2^d0 - 1
	move.l	(LOCATION,a6),d2
	move.l	d2,d0
	add.l	d1,d2
	not.l	d1
	and.l	d2,d1
	move.l	d1,(LOCATION,a6)
	sub.l	d0,d1
	lsr.w	#1,d1
	bcc	aligncmd1
	moveq.l	#0,d0			;܂2oCgE𒲐
	bsr	out1bobj
aligncmd1:
	bsr	tmpreadd0w		;pfBOlǂݍ
	bra	aligncmd3

aligncmd2:
	bsr	out1wobj
aligncmd3:
	dbra	d1,aligncmd2
	bra	tmpreadd0w		;pfBO͓ǂݔ΂

;----------------------------------------------------------------
sectchg:				;15xx ZNVύX
	bsr	chgsection
;offsymŃV{Ȃ̂Ƃ0ɂȂĂ܂
;pX2ȍ~ł͓d`G[͏oȂ͂Ȃ̂Ŗ
	sf.b	(OFFSYMMOD,a6)
	move.l	(LOCATION,a6),(LTOPLOC,a6)	;prnlineŎg
	sf.b	(ISOBJOUT,a6)
	or.w	#$2000,d0		;20xx 0000 0000 :ZNVύX
	bsr	outobj1w
	moveq.l	#0,d0
	bra	wrtd0l

;----------------------------------------------------------------
offsymcmd:				;37xx .offsym
	clr.w	d0
	bsr	chgsection		;offsetZNVɕύX
	tst.l	(DSBSIZE,a6)
	beq	offsymcmd1
	bsr	outdsb
offsymcmd1:
	bsr	flushobj		;IuWFNgobt@tbV
	st.b	(ISOBJOUT,a6)		;Ȍ̃IuWFNgo͂}
	bsr	tmpreadd0l		;lǂݏo
	move.l	d0,(OFFSYMVAL,a6)
	bsr	tmpreadd0l		;V{ǂݏo
	move.l	d0,(OFFSYMSYM,a6)
	bsr	tmpreadd0l		;V{ǂݏo
	move.l	d0,(OFFSYMTMP,a6)
	move.b	#1,(OFFSYMMOD,a6)	;offsymŃV{
	clr.l	(LOCATION,a6)
	clr.l	(LTOPLOC,a6)		;prnlineŎg
	rts

;----------------------------------------------------------------
ofstcmd:				;16xx .offset
	clr.w	d0
	bsr	chgsection		;offsetZNVɕύX
	tst.l	(DSBSIZE,a6)
	beq	ofstcmd1
	bsr	outdsb
ofstcmd1:
	bsr	flushobj		;IuWFNgobt@tbV
	st.b	(ISOBJOUT,a6)		;Ȍ̃IuWFNgo͂}
	bsr	tmpreadd0l
	move.l	d0,(LOCATION,a6)
	rts

;----------------------------------------------------------------
equconst:				;17xx 萔.equ/.set
	bsr	tmpreadd0l		;V{ւ̃|C^
	move.l	d0,a0
	bsr	tmpreadd0l		;V{l
	move.l	d0,(SYM_VALUE,a0)
	clr.w	(SYM_SECTION,a0)	;(SYM_ORGNUM)
	move.l	d0,d1
	moveq.l	#SECT_ABS,d0
equconst1:
	tst.b	(MAKEPRN,a6)
	beq	equconst9
	movea.l	(PRNLPTR,a6),a0
	move.b	#'=',(a0)+
	tst.b	d0
	beq	equconst2
	move.b	#'(',(a0)+
	bsr	convhex2
	move.b	#')',(a0)+
equconst2:
	move.l	d1,d0
	bsr	convhex8
	move.l	a0,(PRNLPTR,a6)
equconst9:
	rts

;----------------------------------------------------------------
equexpr:				;18xx EAhX.equ/.set
	bsr	tmpreadd0l		;V{ւ̃|C^
	move.l	d0,-(sp)
	bsr	tmpreadsymex
	movea.l	(sp)+,a0
	cmp.w	#$00FF,d0
	bcc	equexpr9		;V{lm肵Ȃ
	move.b	d0,(SYM_SECTION,a0)
	move.l	d1,(SYM_VALUE,a0)
	move.b	#SA_DEFINE,(SYM_ATTRIB,a0)
	bra	equconst1

equexpr9:
	clr.b	(SYM_SECTION,a0)
	clr.l	(SYM_VALUE,a0)
	move.b	#SA_DEFINE,(SYM_ATTRIB,a0)
	bra	iloprerr_not_fixed	;lm肵Ȃ̂ŃG[

;----------------------------------------------------------------
fequset:				;2Exx .fequ/.fset
	move.w	d0,d1
	bsr	tmpreadd0l		;V{ւ̃|C^
	movea.l	d0,a1
	move.b	d1,(SYM_FSIZE,a1)	;V{̃TCY
	movea.l	(SYM_FVPTR,a1),a0	;V{lւ̃|C^
	moveq.l	#3-1,d1
fequset1:
	bsr	tmpreadd0l
	move.l	d0,(a0)+		;V{lǂݍ
	dbra	d1,fequset1
	tst.b	(MAKEPRN,a6)
	beq	fequcmd9
	movea.l	(PRNLPTR,a6),a0
	move.b	#'=',(a0)+
	moveq.l	#0,d0
	move.b	(SYM_FSIZE,a1),d0	;V{̃TCY
	movea.l	(SYM_FVPTR,a1),a2	;V{lւ̃|C^
	bsr	getfplen		;f[^𓾂
fequcmd2:
	move.l	(a2)+,d0
	bsr	convhex8
	dbra	d1,fequcmd2
	move.l	a0,(PRNLPTR,a6)
fequcmd9:
	rts

;----------------------------------------------------------------
xdefcmd:				;19xx .xdef
	bsr	tmpreadd0l		;V{ւ̃|C^
	movea.l	d0,a1
	tst.b	(SYM_ATTRIB,a1)		;(cmpi.b #SA_UNDEF,(SYM_ATTRIB,a1))
	beq	xdefcmd01		;xdefꂽV{`
	rts

xdefcmd01:
;[JV{͊O`łȂ̂ōlȂĂ悢
	move.l	a1,(ERRMESSYM,a6)
	bra	undefsymerr

;----------------------------------------------------------------
prnctrl:				;1Axx Xgo͐
	subq.w	#1,d0
	beq	prnlist
	subq.w	#1,d0
	beq	prnnlist
	subq.w	#1,d0
	beq	prnsall
	subq.w	#1,d0
	beq	prnlall
	rts

prnlist:				;.list
	sf.b	(ISNLIST,a6)
	rts

prnnlist:				;.nlist
	st.b	(ISNLIST,a6)
	rts

prnsall:				;.sall
	sf.b	(ISLALL,a6)
	rts

prnlall:				;.lall
	st.b	(ISLALL,a6)
	rts

;----------------------------------------------------------------
pagecmd:				;1Bxx .page
	or.w	#$FF00,d0
	move.w	d0,(PAGEFLG,a6)
	rts

;----------------------------------------------------------------
subttlcmd:				;1Cxx .subttl
	bsr	tmpreadd0l
	move.l	d0,(PRNSUBTTL,a6)
	rts

;----------------------------------------------------------------
orgcmd:					;1Dxx .org
	bsr	tmpreadd0l		;P[VJE^lǂݏo
	move.l	d0,(LOCATION,a6)
	tst.b	(MAKEPRN,a6)
	beq	orgcmd9
	movea.l	(PRNLPTR,a6),a0
	move.b	#'=',(a0)+
	bsr	convhex8
	move.l	a0,(PRNLPTR,a6)
orgcmd9:
	rts

;----------------------------------------------------------------
endcmd:					;1Exx .end
	bsr	tmpreadsymex
	tst.w	d0
	bmi	iloprerr_not_fixed	;mlȂG[
	beq	iloprerr		;萔ȂG[
	tst.b	d0
	bmi	iloprerr_end_xref	;OQƒlȂG[
	move.w	d0,d2
	move.w	#$E000,d0
	bsr	outobj1w
	move.w	d2,d0			;sJnZNV
	bsr	wrtd0w
	move.l	d1,d0			;sJnAhX
	bra	wrtd0l

;----------------------------------------------------------------
incldopen:				;1Fxx includet@CJn
	bsr	tmpreadd0l		;t@Cւ̃|C^
	tst.b	(MAKEPRN,a6)
	bne	incldopen5
	movea.l	(INCLDINFPTR,a6),a0
	tst.w	(INCLDNEST,a6)
	bne	incldopen3
	lea.l	(INCLDINF,a6),a0
incldopen3:
	move.l	(LINENUM,a6),(a0)+	;̍sԍޔ
	move.l	(INPFILE,a6),(a0)+
	move.l	a0,(INCLDINFPTR,a6)
	move.l	d0,(INPFILE,a6)
	addq.w	#1,(INCLDNEST,a6)
	clr.l	(LINENUM,a6)
	rts

incldopen5:
	move.l	d0,-(sp)
	bsr	prnline
	movea.l	(sp)+,a0
	bsr	openincld
	st.b	(PFILFLG,a6)		;t@Ct
	rts

;----------------------------------------------------------------
incldend:				;20xx includet@CI
	tst.b	(MAKEPRN,a6)
	bne	incldend5
	movea.l	(INCLDINFPTR,a6),a0	;ޔĂsԍ߂
	move.l	-(a0),(INPFILE,a6)
	move.l	-(a0),(LINENUM,a6)
	move.l	a0,(INCLDINFPTR,a6)
	subq.w	#1,(INCLDNEST,a6)
	rts

incldend5:
	bsr	prnline
	bsr	closeincld
	st.b	(PFILFLG,a6)		;t@Ct
	rts

;----------------------------------------------------------------
macdef:					;21xx }N`Jn
	bsr	tmpreadd0l
	movea.l	d0,a0			;V{ւ̃|C^
	bsr	tmpreadd0l
	move.l	d0,(SYM_DEFINE,a0)	;`eւ̃|C^
	rts

;----------------------------------------------------------------
macext:					;22xx }NWJJn
	tst.b	(MAKEPRN,a6)
	beq	macext5
	move.b	d0,-(sp)		;Iy[VTCY

	bsr	tmpreadd0l		;V{ւ̃|C^
	movea.l	d0,a0
	move.l	a0,-(sp)
	movea.l	(SYM_DEFINE,a0),a0
	clr.w	d0
	bsr	exmacsetup		;}NWJ
	movea.l	(sp)+,a0
	move.b	(sp)+,(MACSIZE,a6)	;Iy[VTCY
	move.w	(SYM_MACLOCS,a0),d0
	add.w	d0,(MACLOCSMAX,a6)
	lea.l	(LINEBUF,a6),a0
	moveq.l	#0,d1
	bsr	tmpreadd0w		;}NXg̊Jnʒu
	move.w	d0,d1
	adda.l	d1,a0

	movea.l	(MACPARAEND,a6),a1
	bsr	defmacpara
	move.l	a1,(MACPARAEND,a6)
	rts

macext5:
	moveq.l	#3*2,d0
	bra	tempskip

;----------------------------------------------------------------
exitmcmd:				;23xx .exitm
	tst.b	(MAKEPRN,a6)
	bne	macexexitm
	rts

;----------------------------------------------------------------
reptcmd:				;24xx .reptWJJn
	tst.b	(MAKEPRN,a6)
	beq	reptcmd9
	bsr	tmpreadd0w
	move.w	d0,d1
	bsr	tmpreadd0l
	movea.l	d0,a0
	move.w	d1,d0
	suba.l	a1,a1
	bra	exmacsetup		;̍sreptJn

reptcmd9:
	moveq.l	#3*2,d0
	bra	tempskip

;----------------------------------------------------------------
irpcmd:					;25xx .irp/.irpcWJJn
	tst.b	(MAKEPRN,a6)
	beq	irpcmd9
	bsr	tmpreadd0w
	move.w	d0,d1
	bsr	tmpreadd0l
	movea.l	d0,a1
	bsr	tmpreadd0l
	movea.l	d0,a0
	move.w	d1,d0
	bra	exmacsetup		;̍sirp/irpcJn

irpcmd9:
	moveq.l	#5*2,d0
	bra	tempskip

;----------------------------------------------------------------
mdefbgn:				;26xx }N`Jn
	st.b	(ISMACDEF,a6)
	rts

;----------------------------------------------------------------
mdefend:				;27xx }N`I
	sf.b	(ISMACDEF,a6)
	rts


;----------------------------------------------------------------
;	SCDf[^p[N̏
;----------------------------------------------------------------
scdinit:
	tst.b	(MAKESCD,a6)
	bne	scdinit01
	tst.b	(MAKESYMDEB,a6)
	bne	scdinit0
	rts				;SCDR[h͏o͂Ȃ

scdinit0:				;'-g'XCb`w肳ꂽꍇ
	move.l	(LINENUM,a6),d0
	addq.l	#1,d0
	move.l	d0,(NUMOFLN,a6)
	moveq.l	#6,d0			;֐{,.bf,.ef̕
	move.l	d0,(NUMOFSCD,a6)	;gV{̐
	move.l	d0,(NUMOFFNC,a6)
scdinit01:
	move.l	(TEMPPTR,a6),d2
	doeven	d2
	movea.l	d2,a0
	move.l	d2,(SCDLNPTR,a6)	;sԍf[^p[N
	move.l	(NUMOFLN,a6),d0
	add.l	d0,d0
	move.l	d0,d1
	add.l	d0,d0
	add.l	d1,d0			;d0~6
	add.l	d0,d2
	move.l	d2,(SCDDATAPTR,a6)	;gV{p[N
	move.l	(NUMOFSCD,a6),d0
	addq.l	#8,d0			;.file,.text,.data,.bss̕
	add.l	d0,d0
	move.l	d0,d1
	lsl.l	#3,d0
	add.l	d1,d0			;d0~$12
	move.l	d0,(NUMOFSCD,a6)	;gpgV{̃TCY
	add.l	d0,d2
	move.l	d2,(TEMPPTR,a6)
	bsr	memcheck
scdinit1:
	clr.l	(a0)+			;mۂ[NNA
	cmp.l	a0,d2
	bhi	scdinit1
	lea.l	(NUMOFTAG,a6),a0	;^O/֐/ϐf[^f[^Jnԍɂ
	moveq.l	#5-1,d0
	moveq.l	#2,d1			;ŏ̔ԍ2(.file̎)
scdinit2:
	move.l	(a0),d2
	move.l	d1,(a0)+
	add.l	d2,d1
	dbra	d0,scdinit2
	move.l	(NUMOFTAG,a6),(TAGBEGIN,a6)
	move.l	(NUMOFGLB,a6),(GLBDEFNUM,a6)
	clr.l	(LNOFST,a6)
	tst.b	(MAKESYMDEB,a6)
	beq	scdtempclr
	moveq.l	#2,d0			;'-g'XCb`w肳ꂽꍇ
	movea.l	(SCDLNPTR,a6),a0
	move.l	d0,(a0)+		;sԍf[^ŏ̃Gg쐬
	clr.w	(a0)+
	moveq.l	#6,d0
	move.l	d0,(LNOFST,a6)
	moveq.l	#1,d0
	move.l	d0,(NUMOFLN,a6)
scdtempclr:				;SCDf[^ꎞobt@NA
	lea.l	(SCDTEMP,a6),a0
	moveq.l	#(SCD_TBLLEN/4)-1,d0
scdtempclr1:
	clr.l	(a0)+
	dbra	d0,scdtempclr1
	move.w	#-2,(SCD_SECT+SCDTEMP,a6)
	rts

;----------------------------------------------------------------
;	SCDf[^ԍΉobt@̃AhX𓾂
getscdadr:
	movea.l	(SCDDATAPTR,a6),a0
	add.l	d0,d0
	move.l	d0,d1
	lsl.l	#3,d0
	add.l	d1,d0			;d0~$12
	adda.l	d0,a0
	rts

;----------------------------------------------------------------
lncmd:					;28xx .ln
	bsr	tmpreadd0w		;sԍ
	move.w	d0,d3
	bsr	tmpreadsymex		;P[V
	cmpi.b	#SECT_TEXT,d0
	bne	iloprerr		;.textZNVȊOȂG[
	movea.l	(SCDLNPTR,a6),a0
	adda.l	(LNOFST,a6),a0
	move.l	d1,(a0)+
	move.w	d3,(a0)+
	addq.l	#6,(LNOFST,a6)
	rts

;----------------------------------------------------------------
valcmd:					;29xx .val
	bsr	tmpreadsymex		;̒l𓾂
	cmp.w	#$FF,d0
	bhi	iloprerr
	tst.w	d0
	bne	valcmd1
	moveq.l	#-1,d0			;萔̏ꍇ(X^bNt[̃ItZbglȂ)
valcmd1:
	move.l	d1,(SCD_VAL+SCDTEMP,a6)
	move.w	d0,(SCD_SECT+SCDTEMP,a6)
	rts

;----------------------------------------------------------------
tagcmd:					;2Axx .tag
	bsr	tmpreadd0l
	movea.l	d0,a1			;^Oւ̃|C^
	move.l	(TAGBEGIN,a6),d0
	bsr	tagsearch
	tst.l	d0
	beq	tagcmd9
	moveq.l	#2,d0
	bsr	tagsearch
	tst.l	d0
	bne	iloprerr		;^O݂Ȃ
tagcmd9:
	rts

tagsearch:				;^O`Y^OT
	move.l	d0,d2
	bsr	getscdadr
	move.b	(SCD_SCL,a0),d0
	cmp.b	#10,d0			;struct
	beq	tagsearch1
	cmp.b	#12,d0			;union
	beq	tagsearch1
	cmp.b	#15,d0			;enum
	bne	tagsearch9		;^Oł͂Ȃ
tagsearch1:
	movea.l	a0,a2
	movea.l	a1,a3
	tst.l	(a0)
	bne	tagsearch4
	move.l	(4,a0),d0		;V{8ȏ
	movea.l	(EXNAMEPTR,a6),a2
tagsearch2:
	cmp.l	(4,a2),d0
	beq	tagsearch3
	movea.l	(a2),a2
	bra	tagsearch2

tagsearch3:
	addq.l	#8,a2
tagsearch4:
	move.b	(a2)+,d0
	cmp.b	(a3)+,d0
	bne	tagsearch5
	tst.b	d0
	bne	tagsearch4
	move.l	d2,(SCD_TAG+SCDTEMP,a6)	;^O
	moveq.l	#0,d0
	rts

tagsearch5:				;^OႤ
	move.l	(SCD_NEXT,a0),d0
	bne	tagsearch		;̃^O
tagsearch9:
	moveq.l	#-1,d0			;Y^OȂ
	rts

;----------------------------------------------------------------
scdshort:				;2Bxx .endef(Z`)
scdlong:				;2Cxx .endef(`)
	move.w	d0,d2			;f[^̃^Cv
	lea.l	(SCDTEMP,a6),a0
	moveq.l	#4-1,d1
scddata1:
	bsr	tmpreadd0w		;V{
	move.w	d0,(a0)+
	dbra	d1,scddata1
	addq.l	#6,a0
	moveq.l	#2-1,d1
scddata2:
	bsr	tmpreadd0w		;type/scl
	move.w	d0,(a0)+
	dbra	d1,scddata2
	tst.b	d0
	beq	scddata4
	addq.l	#4,a0			;Of[^̏ꍇ
	moveq.l	#6-1,d1
scddata3:
	bsr	tmpreadd0w		;size/line/dim
	move.w	d0,(a0)+
	dbra	d1,scddata3
scddata4:
	cmpi.b	#16,(SCD_SCL+SCDTEMP,a6)
	bne	scddata5
	move.w	#-2,(SCD_SECT+SCDTEMP,a6)	;enumõZNV(݂Ȃ)
scddata5:
	move.w	d2,d0
	move.w	d2,d1
	and.w	#$F0,d0
	cmp.w	#$10,d0
	beq	scddttag		;^O
	cmp.w	#$20,d0
	beq	scddtfnc		;֐
scddata6:				;f[^
	and.w	#$00F0,d2
	lsr.w	#2,d2
	lea.l	(NUMOFSCD,a6),a1
	move.l	(a1,d2.w),d0
	bsr	getscdadr
	lea.l	(SCDTEMP,a6),a2
	move.b	(SCD_LEN,a2),d0
	ext.w	d0
scddata7:
	moveq.l	#9-1,d1
scddata8:
	move.w	(a2)+,(a0)+
	dbra	d1,scddata8
	addq.l	#1,(a1,d2.w)
	dbra	d0,scddata7
	bra	scdtempclr

scddttag:
	and.w	#$0F,d1
	beq	scddata6
	subq.w	#1,d1
	bne	scdtagend
	move.l	(NUMOFTAG,a6),(TAGDEFNUM,a6)	;^O`Jn
	bra	scddata6

scdtagend:				;^O`I
	bsr	scddata6		;.eosf[^
	move.l	(TAGDEFNUM,a6),d0
	bsr	getscdadr
	move.l	(NUMOFTAG,a6),(SCD_NEXT,a0)	;^O``FCȂ
	rts

scddtfnc:
	and.w	#$0F,d1
	beq	scddata6
	subq.w	#1,d1
	beq	scdfncbgn
	sub.w	#$B-1,d1
	beq	scdfncbb
	subq.w	#1,d1
	beq	scdfnceb
	subq.w	#1,d1
	beq	scdfncbf
	bra	scdfncef

scdfncbgn:				;֐`Jn
	move.l	(NUMOFFNC,a6),(FNCDEFNUM,a6)
	move.l	(NUMOFTAG,a6),(TAGBEGIN,a6)	;(֐O̓^OɑΉ邽)
	clr.l	(FNCBBNUM,a6)
	movea.l	(LNOFST,a6),a0
	move.l	a0,(SCD_DIM+SCDTEMP,a6)
	adda.l	(SCDLNPTR,a6),a0
	move.l	(NUMOFFNC,a6),(a0)+
	clr.w	(a0)+
	addq.l	#6,(LNOFST,a6)
	bra	scddata6

scdfncbb:				;ubNJn
	move.l	(FNCBBNUM,a6),(SCD_NEXT+SCDTEMP,a6)
	move.l	(NUMOFFNC,a6),(FNCBBNUM,a6)
	bra	scddata6

scdfnceb:				;ubNI
	bsr	scddata6		;.ebf[^
	move.l	(FNCBBNUM,a6),d0
	bsr	getscdadr
	move.l	(SCD_NEXT,a0),(FNCBBNUM,a6)	;ubN`FC
	move.l	(NUMOFFNC,a6),(SCD_NEXT,a0)	;.bb.eb̎̈ʒu
	rts

scdfncbf:				;֐Jn
	move.l	(NUMOFFNC,a6),(FNCBFNUM,a6)
	bra	scddata6

scdfncef:				;֐I
	move.l	(FNCBFNUM,a6),d0
	bsr	getscdadr
	move.l	(NUMOFFNC,a6),(SCD_NEXT,a0)	;.bf.ef̈ʒu
	bra	scddata6

;----------------------------------------------------------------
funcend:				;2Dxx .scl -1(֐`I)
	move.l	(FNCDEFNUM,a6),d0
	bsr	getscdadr
	move.l	(NUMOFFNC,a6),(SCD_NEXT,a0)	;֐``FCȂ
	move.l	(LOCATION,a6),d0
	sub.l	(SCD_VAL,a0),d0
	move.l	d0,(SCD_SIZE,a0)	;֐TCY
	move.l	#2,(TAGBEGIN,a6)
	rts


;----------------------------------------------------------------
;	SCDf[^̏o
;----------------------------------------------------------------
scdout:
	tst.b	(MAKESCD,a6)
	bne	scdout01
	tst.b	(MAKESYMDEB,a6)
	bne	scdout0
	rts				;SCDR[h͏o͂Ȃ

scdout0:
	move.l	(NUMOFFNC,a6),d0	;'-g'XCb`w肳ꂽꍇ
	bsr	getscdadr		;֐,.bf,.ef̃Gg쐬
	movea.l	a0,a2
	move.l	(SCDFILENUM,a6),(4,a2)	;֐̓\[Xt@CƂ
	moveq.l	#SECT_TEXT,d0
	move.w	d0,(SCD_SECT,a2)		;ZNV .text (֐)
	move.w	d0,(SCD_SECT+SCD_TBLLEN,a2)	;		  (.bf)
	move.w	d0,(SCD_SECT+SCD_TBLLEN*2,a2)	;		  (.ef)
	move.w	#$20,(SCD_TYPE,a2)	;f[^^ void() (֐)
	move.w	#$0301,(SCD_SCL,a2)	;LNX static (֐)
	move.w	#$6501,d0
	move.w	d0,(SCD_SCL+SCD_TBLLEN,a2)	;LNX.bf/.ef(.bf)
	move.w	d0,(SCD_SCL+SCD_TBLLEN*2,a2)	;		  (.ef)
	moveq.l	#SECT_TEXT,d0
	bsr	chgsection		;.textZNṼTCY𓾂
	move.l	(LOCATION,a6),d0
	move.l	d0,(SCD_SIZE,a2)	;TCY(֐)
	move.l	d0,(SCD_VAL+SCD_TBLLEN*2,a2)	;V{l(.ef)
	moveq.l	#8,d0
	move.l	d0,(SCD_NEXT,a2)	;̊֐Gg(֐)
	moveq.l	#6,d0
	move.l	d0,(SCD_NEXT+SCD_TBLLEN,a2)	;Ή.ef̈ʒu(.bf)
	move.w	#1,(SCD_SIZE+SCD_TBLLEN,a2)	;ŏ̍sԍ(.bf)
	move.l	(LINENUM,a6),d0
	move.w	d0,(SCD_SIZE+SCD_TBLLEN*2,a2)	;s(.ef)
	lea.l	(scdstr_bfef,pc),a1
	lea.l	(SCD_TBLLEN,a2),a0
	bsr	strcpy			;V{'.bf'
	lea.l	(SCD_TBLLEN*2,a2),a0
	bsr	strcpy			;V{'.ef'
scdout01:
	bsr	scdtempclr
	lea.l	(scdsect_name,pc),a3	;.fileGg
	move.l	(GLBDEFNUM,a6),(SCD_VAL+SCDTEMP,a6)
	move.w	#$6701,(SCD_SCL+SCDTEMP,a6)
	movea.l	(SCDFILE,a6),a0
	movea.l	a0,a2
	lea.l	(SCD_TAG+SCDTEMP,a6),a1
	moveq.l	#14-1,d0
scdout1:				;t@CtB[hɃt@Ci[
	move.b	(a0)+,(a1)+
	dbeq	d0,scdout1
	beq	scdout15
	tst.b	(a0)
	beq	scdout15		;14傤ǂ̏ꍇ
	movea.l	a1,a0
scdout12:				;t@C14ȏ̏ꍇ
	move.b	(a2)+,d0
	beq	scdout15
	cmp.b	#'.',d0
	bne	scdout12		;gqT
	moveq.l	#3,d0
scdout13:
	tst.b	(a2)+
	dbeq	d0,scdout13
	bne	scdout15		;gq3ȏ
	subq.l	#1,a2
scdout14:				;gq3ȉȂ,
	move.b	-(a2),d0		;t@C+gqɂȂ悤ɂ
	move.b	d0,-(a0)
	cmp.b	#'.',d0
	bne	scdout14
	move.l	(SCDFILENUM,a6),(a1)
scdout15:
	moveq.l	#0,d0
	bsr	scdsectout		;.fileo
	moveq.l	#SECT_ABS,d0
	bsr	chgsection
	move.l	(NUMOFLN,a6),(SCD_SIZE+SCDTEMP,a6)
	moveq.l	#3-1,d3
	lea.l	(LOCCTRBUF,a6),a4
	moveq.l	#0,d2			;܂ł̃ZNVTCY̍v
	moveq.l	#SECT_TEXT,d4
	move.l	(NUMOFSECT,a6),d5
scdout2:
	move.l	d2,(SCD_VAL+SCDTEMP,a6)
	move.w	d4,(SCD_SECT+SCDTEMP,a6)
	move.w	#$7801,(SCD_SCL+SCDTEMP,a6)
	move.l	(a4),(SCD_TAG+SCDTEMP,a6)	;̃ZNṼTCY
	add.l	(a4)+,d2
	move.l	d5,d0
	bsr	scdsectout		;.text/.data/.bsso
	addq.w	#1,d4
	addq.l	#2,d5
	dbra	d3,scdout2
	move.l	(LNOFST,a6),d0		;sԍf[^
	bsr	wrtd0l
	move.l	(NUMOFSCD,a6),d0	;gV{f[^
	bsr	wrtd0l
	move.l	(EXNAMELEN,a6),d0	;V{f[^
	bsr	wrtd0l
	movea.l	(SCDLNPTR,a6),a0	;sԍf[^o
	move.l	(LNOFST,a6),d1
	beq	scdout30		;(sԍf[^Ȃ)
scdout3:
	move.w	(a0)+,d0
	bsr	wrtd0w
	subq.l	#2,d1
	bhi	scdout3
scdout30:
	movea.l	(SCDDATAPTR,a6),a0	;gV{f[^o
	move.l	(NUMOFSCD,a6),d1
scdout31:
	move.w	(a0)+,d0
	bsr	wrtd0w
	subq.l	#2,d1
	bhi	scdout31
	lea.l	(EXNAMEPTR,a6),a0	;V{f[^o
scdout4:
	move.l	(a0),d0
	beq	scdout9			;f[^I
	movea.l	d0,a0
	lea.l	(8,a0),a1		;f[^{
scdout5:
	clr.w	d0
	move.b	(a1)+,d0
	beq	scdout6
	lsl.w	#8,d0
	move.b	(a1)+,d0
	beq	scdout6
	bsr	wrtd0w
	bra	scdout5

scdout6:
	bsr	wrtd0w
	bra	scdout4

scdout9:
	rts

scdsectout:
	lea.l	(SCDTEMP,a6),a1
	movea.l	a1,a2
scdsectout1:				;ZNV
	move.b	(a3)+,(a2)+
	bne	scdsectout1
	bsr	getscdadr
	moveq.l	#18-1,d1		;gV{obt@ɏo͂
scdsectout2:
	move.w	(a1)+,(a0)+
	dbra	d1,scdsectout2
	bra	scdtempclr

scdsect_name:				;SCDɏo͂ZNV
	.dc.b	'.file',0,'.text',0,'.data',0,'.bss',0

scdstr_bfef:
	.dc.b	'.bf',0,'.ef',0
	.even


;----------------------------------------------------------------
;	V{e[ȕo
;----------------------------------------------------------------
prnsymtbl:
	tst.b	(MAKEPRN,a6)
	beq	prnsymtbl9
	tst.b	(ISNLIST,a6)
	bne	prnsymtbl9
	bsr	makesymptr		;V{ւ̃|C^e[u쐬
	moveq.l	#-1,d0
	bsr	prnnextpage		;y[W
	bsr	prnsymtable		;V{e[u\
prnsymtbl9:
	rts

;----------------------------------------------------------------
;	V{ւ̃|C^e[u쐬AɃ\[g
makesymptr:
	move.l	(TEMPPTR,a6),d0
	doquad	d0
	move.l	d0,(TEMPPTR,a6)
	movea.l	d0,a3
	movea.l	(MEMLIMIT,a6),a4
	movea.l	a3,a0			;|C^e[u̐擪AhX

	move.l	(SYMTBLBEGIN,a6),d3
	beq	makesymptr9		;V{Ȃ
makesymptr1:
	movea.l	d3,a1
	move.w	#SYMEXTCOUNT-1,d2	;1̃e[uubÑV{
	move.l	(a1)+,d3
	bne	makesymptr2		;܂̃ubN
	sub.w	(SYMTBLCOUNT,a6),d2	;Ō̃ubN̏ꍇ
makesymptr2:
	tst.b	(SYM_TYPE,a1)		;cmpi.b #ST_VALUE,(SYM_TYPE,a1)
	bne	makesymptr5		;lV{ȊOȂ牽Ȃ
	cmpi.b	#SA_DEFINE,(SYM_ATTRIB,a1)
	blo	makesymptr5		;lm肵ĂȂΉȂ
	move.l	a1,(a3)+		;V{ւ̃|C^
	cmp.l	a3,a4
	bcc	makesymptr5
	addq.l	#4,sp			;Ȃ̂
	rts				;V{e[u͍쐬Ȃ

makesymptr5:
	lea.l	(SYM_TBLLEN,a1),a1	;̃V{AhX
	dbra	d2,makesymptr2
	tst.l	d3
	bne	makesymptr1		;̃e[uubN
makesymptr9:
	clr.l	(a3)			;|C^e[ȕI[

sortsymptr:
	move.l	a6,-(sp)
	moveq.l	#$FFFFFFFC,d2		;2rbg}XN
	clr.l	-(sp)			;X^bN{g
	bra	sortsymptr1

sortsymptr0:				;X^bNԗ[̃f[^𓾂
	movea.l	d0,a0
	movea.l	(sp)+,a3
sortsymptr1:
	move.l	a3,d0
	sub.l	a0,d0			;ԃTCY
	lsr.l	#1,d0
	and.w	d2,d0			;and.l
	beq	sortsymptr9		;Ԃ1ɂȂ̂ŕI

	lea.l	(a0,d0.l),a4		;Ԓ
	move.l	a4,d1
	movea.l	(a4),a5
	movea.l	(SYM_NAME,a5),a5
	movea.l	a0,a1
	movea.l	a3,a2
	bra	sortsymptr3

sortsymptr2:				;f[^
	move.l	-(a1),d0
	move.l	(a2),(a1)+
	move.l	d0,(a2)
sortsymptr3:				;擪Ώۃf[^
	movea.l	(a1)+,a4
	movea.l	(SYM_NAME,a4),a4
	movea.l	a5,a6
sortsymptr4:
	move.b	(a6)+,d0
	beq	sortsymptr5
	cmp.b	(a4)+,d0
	bhi	sortsymptr3
	beq	sortsymptr4
sortsymptr5:				;Ώۃf[^
	movea.l	-(a2),a4
	movea.l	(SYM_NAME,a4),a4
	movea.l	a5,a6
sortsymptr6:
	move.b	(a4)+,d0
	beq	sortsymptr65
	cmp.b	(a6)+,d0
	bhi	sortsymptr5
	beq	sortsymptr6
sortsymptr65:
	cmpa.l	a1,a2			;|C^܂ŌJԂ
	bcc	sortsymptr2
	subq.l	#4,a1
	cmpa.l	d1,a1			;Z̋Ԃɏ
	bcc	sortsymptr8

sortsymptr7:				;擪̕ɏ
	movem.l	a1/a3,-(sp)
	movea.l	a1,a3
	bra	sortsymptr1

sortsymptr8:				;̕ɏ
	movem.l	a0/a1,-(sp)
	movea.l	a1,a0
	bra	sortsymptr1

sortsymptr9:
	move.l	(sp)+,d0
	bne	sortsymptr0
	movea.l	(sp)+,a6
	rts

;----------------------------------------------------------------
;	V{e[u\
prnsymtable:
	lea.l	(crlf_msg,pc),a0
	bsr	prnlout
	lea.l	(seg1_msg,pc),a0
	bsr	prnlout
	lea.l	(seg2_msg,pc),a0
	bsr	prnlout
	tst.b	(MAKERSECT,a6)
	beq	prnsymtable01
	lea.l	(seg21_msg,pc),a0
	bsr	prnlout
prnsymtable01:
	lea.l	(crlf_msg,pc),a0
	bsr	prnlout
	bsr	prnlout
	lea.l	(seg3_msg,pc),a0
	bsr	prnlout
	movea.l	(TEMPPTR,a6),a1		;|C^e[u̐擪AhX
	moveq.l	#0,d1
	move.w	(PRNWIDTH,a6),d1
	divu.w	#21,d1			;1sɕ\łV{̐
	subq.w	#1,d1
prnsymtable1:
	lea.l	(OPRBUF,a6),a0
	move.w	d1,d2
prnsymtable2:				;' xxxxxxxx(xx) xxxxxxxx '
	move.l	(a1)+,d0
	beq	prnsymtable9		;SV{\
	movea.l	d0,a2
	move.b	#' ',(a0)+
	move.l	(SYM_VALUE,a2),d0
	bsr	convhex8		;V{l
	bsr	prnsymsec		;ZNV
	move.b	#' ',(a0)+
	movea.l	(SYM_NAME,a2),a3
	moveq.l	#8-1,d0
prnsymtable3:
	move.b	(a3)+,(a0)+		;V{(擪8)
	dbeq	d0,prnsymtable3
	bne	prnsymtable5
	subq.l	#1,a0
prnsymtable4:
	move.b	#' ',(a0)+
	dbra	d0,prnsymtable4
prnsymtable5:
	dbra	d2,prnsymtable2
  .if UNIX_NEWLINE=0
	move.b	#CR,(a0)+
  .endif
	move.b	#LF,(a0)+
	clr.b	(a0)
	lea.l	(OPRBUF,a6),a0
	bsr	prnlout			;1s\
	bra	prnsymtable1

prnsymtable9:
	cmp.w	d1,d2
	beq	prnsymtable0
  .if UNIX_NEWLINE=0
	move.b	#CR,(a0)+
  .endif
	move.b	#LF,(a0)+
	clr.b	(a0)
	lea.l	(OPRBUF,a6),a0
	bsr	prnlout			;Ō1s\
prnsymtable0:
	lea.l	(crlf_msg,pc),a0
	bra	prnlout

;----------------------------------------------------------------
;	ZNV\
prnsymsec:
	move.b	(SYM_SECTION,a2),d0
	beq	prnsymabs		;萔
	cmp.b	#SECT_XREF,d0
	beq	prnsymext		;.xref
	cmp.b	#SECT_COMM,d0
	beq	prnsymcom		;.comm
	cmp.b	#SECT_RCOMM,d0
	beq	prnsymrcom		;.rcomm
	cmp.b	#SECT_RLCOMM,d0
	beq	prnsymrlcom		;.rlcomm
	move.b	#'(',(a0)+
	bsr	convhex2		;ZNVԍ
	move.b	#')',(a0)+
	rts

prnsymabs:
	lea.l	(abs_msg,pc),a3
	bra	prnsymout

prnsymext:
	lea.l	(ext_msg,pc),a3
	bra	prnsymout

prnsymcom:
	lea.l	(com_msg,pc),a3
	bra	prnsymout

prnsymrcom:
	lea.l	(rcom_msg,pc),a3
	bra	prnsymout

prnsymrlcom:
	lea.l	(rlcom_msg,pc),a3
prnsymout:
	moveq.l	#4-1,d0
prnsymout1:
	move.b	(a3)+,(a0)+
	dbra	d0,prnsymout1
	rts

seg1_msg:	mes	'ZOge[u'
		.dc.b	CRLF,0
seg2_msg:	.dc.b	' 01 text     02 data     03 bss      04 stack   ',0
seg21_msg:	.dc.b	CRLF
		.dc.b	'             05 rdata    06 rbss     07 rstack  ',CRLF
		.dc.b	'             08 rldata   09 rlbss    0A rlstack ',0
seg3_msg:	mes	'V{e[u'
		.dc.b	CRLF,0
abs_msg:	.dc.b	' abs'
ext_msg:	.dc.b	' ext'
com_msg:	.dc.b	' com'
rcom_msg:	.dc.b	' rcm'
rlcom_msg:	.dc.b	' rlc'
undef_msg:	mes	'`V{'
		.dc.b	CRLF,0
	.even


;----------------------------------------------------------------
;	`V{Xg̏o
;----------------------------------------------------------------
prnundefsym:
	tst.b	(ISUNDEFSYM,a6)
	beq	prnundefsym9
	lea.l	(undef_msg,pc),a0
	bsr	prnstdout

	move.l	(SYMTBLBEGIN,a6),d3
	beq	prnundefsym9		;V{1Ȃ
prnundefsym1:
	movea.l	d3,a2
	move.w	#SYMEXTCOUNT-1,d2	;1̃e[uubÑV{
	move.l	(a2)+,d3
	bne	prnundefsym2		;܂̃ubN
	sub.w	(SYMTBLCOUNT,a6),d2	;Ō̃ubN̏ꍇ

prnundefsym2:
	tst.b	(SYM_TYPE,a2)		;cmpi.b #ST_VALUE,(SYM_TYPE,a2)
	bne	prnundefsym7		;lV{ȊOȂ牽Ȃ
	cmpi.b	#SA_DEFINE,(SYM_ATTRIB,a2)
	bcc	prnundefsym8		;mς݃V{
prnundefsym3:
	lea.l	(LINEBUF,a6),a0
	movea.l	(SYM_NAME,a2),a1
	bsr	strcpy
	lea.l	(crlf_msg,pc),a1
	bsr	strcpy
	clr.b	(a0)
	lea.l	(LINEBUF,a6),a0
	bsr	prnstdout
prnundefsym8:
	lea.l	(SYM_TBLLEN,a2),a2	;̃V{AhX
	dbra	d2,prnundefsym2
	tst.l	d3
	bne	prnundefsym1		;̃e[uubN
prnundefsym9:
	rts

prnundefsym7:
	cmpi.b	#ST_REAL,(SYM_TYPE,a2)
	bne	prnundefsym8
	tst.b	(SYM_FSIZE,a2)
	bpl	prnundefsym8
	bra	prnundefsym3		;`̕_V{̏ꍇ


;----------------------------------------------------------------
;	PRNt@C쐬[`
;----------------------------------------------------------------

;----------------------------------------------------------------
;o̓[`
;	o͍ς݂łȂΏ]prnlinȅsĉo͍ς݃tOZbg
;	o͍ς݂̂Ƃ1sڂprn1line4
;:o͂gƂ͍s̍Ō̃f[^܂ŉo͂gďo͂邱
prnlineadv:
	tst.b	(PFILFLG,a6)
	bne	prnfname
	tst.b	(ISNLIST,a6)
	bne	prnline9		;.nlistĂ̂ōs\Ȃ
	cmpi.w	#2,(PRNLATR,a6)
	bne	prnlineadv1
	tst.b	(ISLALL,a6)
	beq	prnline9		;.sallł̃}NWJs͕\Ȃ
prnlineadv1:
	tst.b	(PADVFLG,a6)
	bne	prnlineadv2
	st.b	(PADVFLG,a6)
	bsr	prn1line
	bra	prnline9

prnlineadv2:
	movea.l	(PRNLPTR,a6),a1
	clr.b	(a1)
	lea.l	(PRNCODE,a6),a1
prnlineadv3:
	tst.b	(a1)
	ble	prnline9
	move.w	#15-1,d0
	lea.l	(OPRBUF,a6),a0
prnlineadv4:
	move.b	#' ',(a0)+
	dbra	d0,prnlineadv4
	bsr	prn1code		;R[ho
  .if UNIX_NEWLINE=0
	move.b	#CR,(a0)+
  .endif
	move.b	#LF,(a0)+
	clr.b	(a0)
	lea.l	(OPRBUF,a6),a0
	bsr	prnlout
	bra	prnlineadv3

;----------------------------------------------------------------
;	1so͂
prnline:
	tst.b	(PFILFLG,a6)
	bne	prnfname		;t@C\
	tst.b	(ISNLIST,a6)
	bne	prnline9		;.nlistĂ̂ōs\Ȃ
	cmpi.w	#2,(PRNLATR,a6)
	bne	prnline1
	tst.b	(ISLALL,a6)
	beq	prnline9		;.sallł̃}NWJs͕\Ȃ
prnline1:
;	o͍ς݂łȂΏ]prnlineƓ
;	o͍ς݂̂Ƃ͏o͂ɉo͍ς݃tOZbg
	tst.b	(PADVFLG,a6)
	beq	prnline2
	sf.b	(PADVFLG,a6)
	rts

prnline2:
	bsr	prn1line
prnline9:
	lea.l	(PRNCODE,a6),a0
	move.l	a0,(PRNLPTR,a6)
	rts

;----------------------------------------------------------------
;	PRNt@C̃t@Cs\
prnfname::
	sf.b	(PFILFLG,a6)
	lea.l	(OPRBUF,a6),a2
	move.b	#'<',(a2)+		;'< ` >'
	movea.l	(INPFILE,a6),a0
	bsr	getfilename
prnfname1:
	move.b	(a1)+,(a2)+
	bne	prnfname1
	move.b	#'>',(-1,a2)
  .if UNIX_NEWLINE=0
	move.b	#CR,(a2)+
  .endif
	move.b	#LF,(a2)+
	clr.b	(a2)
	lea.l	(OPRBUF,a6),a0
	bsr	prnlout
	bra	prnline9

;----------------------------------------------------------------
;	PRNt@C1s\
prn1line:
	movea.l	(PRNLPTR,a6),a0
	clr.b	(a0)
	lea.l	(OPRBUF,a6),a0
	move.l	(LINENUM,a6),d0
	moveq.l	#5,d1			;(5Ń[TvX)
	bsr	convdec			;'xxxxx '(sԍ)
	move.b	#' ',(a0)+
	move.l	(LTOPLOC,a6),d0
	tst.b	(OFFSYMMOD,a6)
	ble	prn1line02
	movea.l	(OFFSYMTMP,a6),a1
	cmpi.b	#SA_DEFINE,(SYM_ATTRIB,a1)
	beq	prn1line01
	moveq.l	#0,d0			;G[̂Ƃ0ɂĂ
	bra	prn1line02

prn1line01:
	add.l	(OFFSYMVAL,a6),d0	;+l
	sub.l	(SYM_VALUE,a1),d0	;-V{l
prn1line02:
	bsr	convhex8		;'xxxxxxxx '(P[VJE^)
	moveq.l	#' ',d0
	cmpi.w	#2,(PRNLATR,a6)
	bne	prn1line1
	moveq.l	#'*',d0			;}NWJ
prn1line1:
	move.b	d0,(a0)+
	lea.l	(PRNCODE,a6),a1
	lea.l	(LINEBUF,a6),a2
prn1line2:
	bsr	prn1code		;R[ho
	bsr	prn1srce		;\[Xo
  .if UNIX_NEWLINE=0
	move.b	#CR,(a0)+
  .endif
	move.b	#LF,(a0)+
	clr.b	(a0)
	lea.l	(OPRBUF,a6),a0
	bsr	prnlout
prn1line3:
	tst.b	(a1)+
	bmi	prn1line3
	bne	prn1line4
	tst.b	(a2)
	beq	prn1line9
prn1line4:
	subq.l	#1,a1
	move.w	#15-1,d0		;2sȏɂ܂ꍇ
	lea.l	(OPRBUF,a6),a0
prn1line5:
	move.b	#' ',(a0)+
	dbra	d0,prn1line5
	bra	prn1line2

prn1line9:
	rts

prn1code:				;R[ho
	move.w	#16-1,d0
prn1code1:
	move.b	(a1)+,(a0)+
	dble	d0,prn1code1
	bgt	prn1code5
	subq.l	#1,a0			;R[hrŏI
	subq.l	#1,a1
	addq.w	#1,d0
prn1code2:
	move.b	#' ',(a0)+
	dbra	d0,prn1code2
	rts

prn1code5:				;R[h̍sɑ
	move.b	#' ',d0
	tst.b	(a1)
	ble	prn1code6
	tst.b	(1,a1)
	bgt	prn1code6
	move.b	(a1)+,d0
prn1code6:
	move.b	d0,(a0)+
	rts

prn1srce:				;\[Xo
	clr.w	d0
	move.w	(PRNWIDTH,a6),d2
	sub.w	#32,d2
prn1srce1:
	move.b	(a2)+,d1
	beq	prn1srce9
	bmi	prn1srce2
	cmp.b	#TAB,d1
	bne	prn1srce5
	addq.w	#8,d0			;TABR[h̏ꍇ
	and.w	#$FFF8,d0
	bra	prn1srce6

prn1srce2:
  .if EUCSRC=0
	cmp.b	#$A0,d1
	bcs	prn1srce3
	cmp.b	#$E0,d1
	bcs	prn1srce5
  .else
	bra	prn1srce5		;EUC
  .endif
prn1srce3:				;R[h̏ꍇ
	addq.w	#2,d0
	cmp.w	d2,d0
	bhi	prn1srce9
	move.b	d1,(a0)+
	move.b	(a2)+,d1
	beq	prn1srce9
	bra	prn1srce6

prn1srce5:
	addq.w	#1,d0
prn1srce6:
	move.b	d1,(a0)+
	cmp.w	d2,d0
	bcs	prn1srce1
	rts

prn1srce9:
	subq.l	#1,a2
	rts


;----------------------------------------------------------------
;	V{t@C쐬[`
;----------------------------------------------------------------
makesymfile::
	lea.l	(sym_msg,pc),a0
	bsr	prnlout

	move.l	(SYMTBLBEGIN,a6),d3
	beq	makesymfile9		;V{1Ȃ
makesymfile1:
	movea.l	d3,a2
	move.w	#SYMEXTCOUNT-1,d2	;1̃e[uubÑV{
	move.l	(a2)+,d3
	bne	makesymfile2		;܂̃ubN
	sub.w	(SYMTBLCOUNT,a6),d2	;Ō̃ubN̏ꍇ
makesymfile2:
	cmpi.b	#ST_LOCAL,(SYM_TYPE,a2)
	beq	makesymfile8		;[JV{Ȃ牽Ȃ
	lea.l	(LINEBUF,a6),a0
	movea.l	(SYM_NAME,a2),a1
	moveq.l	#16,d1
makesymfile3:
	subq.w	#1,d1
	move.b	(a1)+,(a0)+		;V{]
	bne	makesymfile3
	subq.l	#1,a0
	tst.w	d1
	bmi	makesymfile5
makesymfile4:
	move.b	#' ',(a0)+		;]Xy[XŖ߂
	dbra	d1,makesymfile4
makesymfile5:
	move.b	#' ',(a0)+
	move.b	#':',(a0)+
	move.b	#' ',(a0)+

	move.b	(SYM_TYPE,a2),d0
	cmp.b	#ST_REAL,d0
	beq	makesymreal
	cmp.b	#ST_REGSYM,d0
	beq	makesymreg
	cmp.b	#ST_MACRO,d0
	beq	makesymmac
	cmpi.b	#SA_DEFINE,(SYM_ATTRIB,a2)
	bcs	makesymundef

	lea.l	(symabs_msg,pc),a1
	move.b	(SYM_EXTATR,a2),d0
	beq	makesymabs
	cmp.b	#SECT_XREF,d0
	beq	makesymext
	cmp.b	#SECT_COMM,d0
	beq	makesymcom
	cmp.b	#SECT_RCOMM,d0
	beq	makesymrcom
	cmp.b	#SECT_RLCOMM,d0
	beq	makesymrlcom
	bra	makesymglobl

makesymext:
	lea.l	(symext_msg,pc),a1
	bra	makesymcom1

makesymcom:
	lea.l	(symcom_msg,pc),a1
	bra	makesymcom1

makesymrcom:
	lea.l	(symrcom_msg,pc),a1
	bra	makesymcom1

makesymrlcom:
	lea.l	(symrlcom_msg,pc),a1
makesymcom1:
	bsr	strcpy
	lea.l	(symno_msg,pc),a1
	bsr	strcpy
	move.l	(SYM_VALUE,a2),d0
	bsr	convhex4
	bra	makesymfile7

makesymglobl:
	lea.l	(symglb_msg,pc),a1
makesymabs:
	bsr	strcpy
	move.b	#' ',(a0)+
	clr.w	d0
	move.b	(SYM_SECTION,a2),d0
	mulu.w	#6,d0
	lea.l	(symsec_msg,pc,d0.w),a1
	bsr	strcpy
	move.b	#' ',(a0)+
	move.b	#' ',(a0)+
	move.b	#' ',(a0)+
	move.l	(SYM_VALUE,a2),d0
	bsr	convhex8
	bra	makesymfile7

makesymundef:
	lea.l	(symudf_msg,pc),a1
	bra	makesymmac1

makesymreal:
	tst.b	(SYM_FSIZE,a2)
	bmi	makesymundef		;V{͖`
	lea.l	(symreal_msg,pc),a1
	bra	makesymmac1

makesymreg:
	lea.l	(symreg_msg,pc),a1
	bra	makesymmac1

makesymmac:
	lea.l	(symmac_msg,pc),a1
makesymmac1:
	bsr	strcpy

makesymfile7:
  .if UNIX_NEWLINE=0
	move.b	#CR,(a0)+
  .endif
	move.b	#LF,(a0)+
	clr.b	(a0)
	lea.l	(LINEBUF,a6),a0
	bsr	prnlout
makesymfile8:
	lea.l	(SYM_TBLLEN,a2),a2	;̃V{AhX
	dbra	d2,makesymfile2
	tst.l	d3
	bne	makesymfile1		;̃e[uubN
makesymfile9:
	rts

symsec_msg:
	.dc.b	'abs  ',0,'text ',0,'data ',0,'bss  ',0,'stack',0
	.dc.b	'rdata',0,'rbss ',0,'rstck',0,'rldta',0,'rlbss',0,'rlstk',0
sym_msg:
	.dc.b	'SYMBOL           : class    section location',CRLF,CRLF,0
symabs_msg:	.dc.b	'absolute',0
symglb_msg:	.dc.b	'global  ',0
symext_msg:	.dc.b	'external',0
symcom_msg:	.dc.b	'common  ',0
symrcom_msg:	.dc.b	'rcommon ',0
symrlcom_msg:	.dc.b	'rlcommon',0
symudf_msg:	.dc.b	'(undefined)',0
symreg_msg:	.dc.b	'(register list)',0
symmac_msg:	.dc.b	'(macro)',0
symreal_msg:	.dc.b	'(float)',0
symno_msg:	.dc.b	'         No. ',0
	.even


;----------------------------------------------------------------
;	Tu[`
;----------------------------------------------------------------

;----------------------------------------------------------------
;	e|t@CV{ԍEǂݍ݁A̒l𓾂
;	in :---
;	out:d0.w=ʂ̑(0:萔/1`4:AhXl(ZNVԍ)/
;			    $FF:OQƒl/$FE:RV{/
;			    $FFFF:/$01FF:ItZbgtOQ/$02FF:OQƒl)
;	    d1.l=ʂ̒l/d2.w=TCY
tmpreadsymex:
	bsr	tmpreadd0w
	move.w	d0,d2
tmpreadsymex1:
	and.w	#$FF00,d0
	cmp.w	#T_SYMBOL,d0
	bne	tmpreadexpr

;----------------------------------------------------------------
;	e|t@CV{ԍǂݍ݁A̒l𓾂
;	in :---
;	out:d0.w=ʂ̑/d1.l=ʂ̒l
tmpreadsym:
	lea.l	(OPRBUF,a6),a0
	move.w	#RPN_SYMBOL,(a0)+
	bsr	tmpreadd0l
	move.l	d0,(a0)+
	clr.w	(a0)+

;----------------------------------------------------------------
;	ŏIIȃV{l𓾂
;	in :d0.l=V{ւ̃|C^
;	out:d0.w=ʂ̑/d1.l=ʂ̒l
getsymdata:
	movea.l	d0,a0
	cmpi.b	#ST_LOCAL,(SYM_TYPE,a0)	;(ST_VALUE or ST_LOCAL)
	bhi	exprerr			;lV{łȂ
	cmpi.b	#SA_DEFINE,(SYM_ATTRIB,a0)
	blo	getsymdata01		;`V{
	clr.w	d0
	move.b	(SYM_SECTION,a0),d0
	move.l	(SYM_VALUE,a0),d1
	rts

getsymdata01:
	cmpi.b	#ST_LOCAL,(SYM_TYPE,a0)	;[JV{ɂ͖OȂ̂
	beq	getsymdata02		;bZ[W𕪂Kv
	move.l	a0,(ERRMESSYM,a6)
	bra	undefsymerr

getsymdata02:
	cmpi.w	#100,(SYM_LOCALNO,a0)
	blo	undefsymerr_local
	bra	undefsymerr_offsym

;----------------------------------------------------------------
;	e|t@Ct|[hǂݍ݁A̒l𓾂
;	in :---
;	out:d0.w=ʂ̑/d1.l=ʂ̒l
tmpreadexpr:
	bsr	tmpreadd0w
	move.w	d0,d1			;t|[h̒
	lea.l	(OPRBUF,a6),a1
tmpreadexpr1:
	bsr	tmpreadd0w		;{̂ǂݍ
	move.w	d0,(a1)+
	dbra	d1,tmpreadexpr1
	clr.w	(a1)+			;(GhR[h)
	lea.l	(OPRBUF,a6),a1
	bra	calcrpn			;ǂݍ񂾎vZ

;----------------------------------------------------------------
;	EV{lt@Cɏo͂
;	in :d0.w=f[^݂̑ZNV/d1.l=f[^/d2.w=f[^̃TCY
;	out:---
outobjexpr:
	tst.w	d0
	beq	outobjconst		;萔
	bmi	iloprerr_not_fixed	;lm
	cmp.b	#SECT_RLCOMM,d0
	bcs	outobjadrs		;AhXl

	cmp.w	#$01FF,d0
	beq	outobjrofst		;ItZbgtOQƒl
	cmp.w	#$02FF,d0
	beq	outobjrexpr		;OQƂ܂މZ

	bsr	prnextcode		;OQƒl̏o
	move.w	#$4000,d3
	bsr	outobjcom
	move.w	d1,d0
	bra	wrtd0w			;V{ԍo͂

;----------------------------------------------------------------
;	萔̏o
outobjconst:
	cmp.b	#ESZ_ABS,d2
	bcc	outobjcon_abs
outobjcon_imm:				;C~fBGCgf[^
	bsrl	chkdtsize,d0
	move.l	d1,d0
	cmp.b	#SZ_SHORT,d2
	beq	out1bobj		;.s
	cmp.b	#SZ_LONG,d2
	bne	out1wobj		;.b/.w
	bra	out1lobj		;.l

outobjcon_abs:				;΃AhbVOf[^
	cmp.b	#ESZ_ADR,d2
	bcc	outobjcon_adr
	cmp.b	#ESZ_ABS|SZ_LONG,d2
	beq	outobjcon_absl
outobjcon_absw:
	move.w	d1,d0
	ext.l	d0
	cmp.l	d1,d0
	beq	outobjcon_absw1
	cmp.l	#$00010000,d1
	bcc	overflowerr
	bsr	shvalwarn_d16
outobjcon_absw1:
	bsr	absshwarn
	bra	out1wobj

outobjcon_absl:
	bsr	abswarn
	move.l	d1,d0
	bra	out1lobj		;.l

outobjcon_adr:				;AhXWX^ԐڃfBXv[Xg
	cmp.b	#ESZ_ADR|SZ_SHORT,d2
	beq	outobjcon_adrs
	cmp.b	#ESZ_ADR|SZ_WORD,d2
	beq	outobjcon_adrw
	move.l	d1,d0
	bra	out1lobj		;.l

outobjcon_adrs:
	move.b	d1,d0
	ext.w	d0
	ext.l	d0
	cmp.l	d1,d0
	beq	out1bobj
	cmp.l	#$00000100,d1
	bcc	overflowerr
	bsr	shvalwarn_d8
	bra	out1bobj

outobjcon_adrw:
	move.w	d1,d0
	ext.l	d0
	cmp.l	d1,d0
	beq	out1wobj
	cmp.l	#$00010000,d1
	bcc	overflowerr
	bsr	shvalwarn_d16
	bra	out1wobj

;----------------------------------------------------------------
;	AhXl̏o
outobjadrs:
	and.w	#3,d2
	cmp.b	#SECT_RDATA,d0
	bcc	outobjadrs1		;΃ZNVł̓G[ɂȂ
	cmp.b	#SZ_LONG,d2
	bne	iladrerr		;.lȊO̓G[
outobjadrs1:
	tst.b	(MAKEPRN,a6)
 	beq	outobjadrs9
	movea.l	(PRNLPTR,a6),a0		;'(xx)xxxxxxxx'
	move.b	#'(',(a0)+
	bsr	convhex2		;ZNVԍ
	move.b	#')',(a0)+
	move.w	d0,-(sp)
	move.l	d1,d0
	cmp.b	#SZ_LONG,d2
	beq	outobjadrs3
	cmp.b	#SZ_WORD,d2
	beq	outobjadrs2
	bsr	convhex2
	bra	outobjadrs4

outobjadrs2:
	bsr	convhex4
	bra	outobjadrs4

outobjadrs3:
	bsr	convhex8
outobjadrs4:
	move.b	#-1,(a0)+
	move.l	a0,(PRNLPTR,a6)
	move.w	(sp)+,d0
outobjadrs9:
	move.w	#$4000,d3
	bsr	outobjcom
	move.l	d1,d0
	bra	wrtd0l

;----------------------------------------------------------------
;	ItZbgtOQƒl̏o
outobjrofst:
	bsr	prnextcode
	move.w	#$5000,d3
	bsr	outobjcom
	move.w	(ROFSTSYMNO,a6),d0
	bsr	wrtd0w
	move.l	d1,d0
	bra	wrtd0l

;----------------------------------------------------------------
;	OQƒl܂ގ̏o
outobjrexpr:
	bsr	prnextcode
	bsr	outobjrpn
	move.w	d2,d0
	and.w	#3,d0
	lsl.w	#8,d0
	or.w	#$9000,d0
	bra	outobj1w

;----------------------------------------------------------------
prnextcode:				;OQƃf[^PRNt@Cɏo͂
	tst.b	(MAKEPRN,a6)
	beq	prnextcode9
	movea.l	(PRNLPTR,a6),a0
	move.w	d0,-(sp)
	move.w	d2,d0
	bsr	getdtsize
	add.w	d0,d0
	subq.w	#1,d0
prnextcode1:
	move.b	#'?',(a0)+
	dbra	d0,prnextcode1
	move.l	a0,(PRNLPTR,a6)
	move.w	(sp)+,d0
prnextcode9:
	rts

;----------------------------------------------------------------
;	IuWFNgt@C̋t|[ho͂
;	in :---
;	out:---
outobjrpn:
	lea.l	(OPRBUF,a6),a1
outobjrpn1:
	move.w	(a1)+,d0
	beq	outobjrpn9		;I(RPN_END)
	move.w	d0,d1
	and.w	#$FF00,d1
	cmp.w	#RPN_VALUEB,d1
	beq	outobjrpnb		;.b
	cmp.w	#RPN_VALUEW,d1
	beq	outobjrpnw		;.w
	cmp.w	#RPN_VALUE,d1
	beq	outobjrpnl		;.l
	cmp.w	#RPN_SYMBOL,d1
	beq	outobjrpnsym		;V{
	cmp.w	#RPN_LOCATION,d1
	beq	outobjrpnloc		;݂̃P[VJE^l
	cmp.w	#RPN_OPERATOR,d1
	bne	exprerr
	and.w	#$00FF,d0		;Zq
	or.w	#$A000,d0
	bsr	outobj1w
	bra	outobjrpn1

outobjrpn9:
	rts

outobjrpnb:				;lf[^
	moveq.l	#0,d1
	move.b	d0,d1
	bra	outobjrpncon

outobjrpnw:
	moveq.l	#0,d1
	move.w	(a1)+,d1
	bra	outobjrpncon

outobjrpnl:
	move.l	(a1)+,d1
outobjrpncon:				;萔lZX^bNɐςރR[h
	move.w	#$8000,d0
	bsr	outobj1w
outobjrpncon1:
	move.l	d1,d0
	swap.w	d0
	bsr	outobj1w
	swap.w	d0
	bsr	outobj1w
	bra	outobjrpn1

outobjrpnsym:				;V{
	move.l	(a1)+,d0
	bsr	getsymdata
	or.w	#$8000,d0
	bsr	outobj1w
	cmp.b	#SECT_RLCOMM,d0
	bcs	outobjrpncon1
	move.w	d1,d0			;OQƒl̏ꍇAQƔԍo
	bsr	outobj1w
	bra	outobjrpn1

outobjrpnloc:				;݂̃P[VJE^l
	move.l	(LTOPLOC,a6),d1		;'*'
	tst.b	d0
	beq	outobjrpnloc1
	move.l	(LCURLOC,a6),d1		;'$'
outobjrpnloc1:
	move.w	#$8000,d0
	move.b	(SECTION,a6),d0
	bsr	outobj1w
	bra	outobjrpncon1

;----------------------------------------------------------------
;	ZNVԍ/TCY܂߂IuWFNgt@CR}ho͂
;	in :d0.b=ZNVԍ/d2.w=f[^TCY/d3.w=IuWFNgt@CR}h
;	out:---
outobjcom:
	movem.w	d0/d2,-(sp)
	exg.l	d0,d3
	move.b	d3,d0
	and.w	#$0003,d2
	lsl.w	#8,d2
	or.w	d2,d0
	bsr	outobj1w
	movem.w	(sp)+,d0/d2
	rts

;----------------------------------------------------------------
;	t@Cɏo͂
;	in :a0=ւ̃|C^
;	out:a0=Iʒuւ̃|C^
wrtstr:
	move.w	d0,-(sp)
wrtstr1:
	clr.w	d0
	move.b	(a0)+,d0
	beq	wrtstr9
	lsl.w	#8,d0
	move.b	(a0)+,d0
	beq	wrtstr9
	bsr	wrtd0w
	bra	wrtstr1

wrtstr9:
	bsr	wrtd0w
	move.w	(sp)+,d0
	rts

;----------------------------------------------------------------
;	IuWFNg1O[ho͂
;	in :d0.l=o̓f[^
;	out:---
out1lobj:
	swap.w	d0
	bsr	out1wobj
	swap.w	d0

;----------------------------------------------------------------
;	IuWFNg1[ho͂
;	in :d0.w=o̓f[^
;	out:---
out1wobj:
	move.w	d0,-(sp)
	lsr.w	#8,d0
	bsr	out1bobj
	move.w	(sp)+,d0

;----------------------------------------------------------------
;	IuWFNg1oCgo͂
;	in :d0.b=o̓f[^
;	out:---
out1bobj:
	tst.l	(DSBSIZE,a6)
	beq	out1bobj1
	bsr	outdsb
out1bobj1:
	tst.b	(MAKEPRN,a6)
	beq	out1bobj2
	move.l	a0,-(sp)
	movea.l	(PRNLPTR,a6),a0
	bsr	convhex2
	move.l	a0,(PRNLPTR,a6)
	movea.l	(sp)+,a0
out1bobj2:
	bra	wrt1bobj0		;(P[VJE^͕ύXȂ)

;----------------------------------------------------------------
;	IuWFNgo͌A1[ho͂
;	in :d0.w=o̓f[^
;	out:---
outobj1w:
	tst.l	(DSBSIZE,a6)
	beq	wrtobjd0w
	bsr	outdsb
	bra	wrtobjd0w

;----------------------------------------------------------------
;	.ds.b̃f[^o͂
;	in :---
;	out:---
outdsb:
	move.l	d0,-(sp)
	move.w	#$3000,d0		;3000 [] :.ds.b
	bsr	wrtobjd0w
	move.l	(DSBSIZE,a6),d0
	bsr	wrtd0l
	clr.l	(DSBSIZE,a6)
	move.l	(sp)+,d0
	rts


;----------------------------------------------------------------
	.end

;----------------------------------------------------------------
;	$Log: objgen.s,v $
;	Revision 2.9  1999 10/ 8(Fri) 21:52:11 M.Kamada
;	+86 sR[h̕ύXɑΉ
;	+86 EUCΉ
;	+86 '%s ɊOQƒl͎wł܂'
;
;	Revision 2.8  1999  3/ 3(Wed) 14:47:01 M.Kamada
;	+82 G[bZ[W{ꉻ
;	+82 bZ[W{ꉻ
;	+82 T_ERROR$FF00ʏ̃R[hɕύX
;	+82 doevendoquad
;
;	Revision 2.7  1999  2/27(Sat) 23:43:22 M.Kamada
;	+81 \[XXg̃tH[}bgύX(st@C+80Ƃ܂)
;
;	Revision 2.6  1999  2/25(Thu) 03:37:23 M.Kamada
;	+80 objgen.schkdtsize̎QƂbsrlɕύX
;	+80 ColdFireΉ
;	+80 .offsym <l>,<V{>
;
;	Revision 2.5  1998 10/10(Sat) 02:34:36 M.Kamada
;	+77 -p̂Ƃ.INSERT1x256oCgȏǂݏoƌ듮삷
;
;	Revision 2.4  1998  1/24(Sat) 17:56:16 M.Kamada
;	+57 ^.sizemǉ
;
;	Revision 2.3  1998  1/ 9(Fri) 22:25:16 M.Kamada
;	+56 -f43g폜
;
;	Revision 2.2  1997 10/13(Mon) 15:40:56 M.Kamada
;	+51 ւbsrpea
;	+52 jmp/jsrœK
;
;	Revision 2.1  1997  9/15(Mon) 16:05:17 M.Kamada
;	+46 ST_VALUE=0ōœK
;
;	Revision 2.0  1997  9/14(Sun) 18:46:52 M.Kamada
;	+45 $opsize,shift
;
;	Revision 1.9  1997  6/25(Wed) 13:39:30 M.Kamada
;	+33 vft@CV{CPUɑΉ
;	+34 vft@CV{ɑΉ
;
;	Revision 1.8  1996 11/13(Wed) 15:28:40 M.Kamada
;	+04 ??Ŏn܂V{O`ɂȂ
;		??Ŏn܂V{O`ɂȂ
;
;	Revision 1.7  1994/07/13  14:10:16  nakamura
;	኱̃oOtBbNX
;
;	Revision 1.6  1994/04/25  14:33:58  nakamura
;	œKsȂƂɕsȃIuWFNgt@Co͂邱Ƃ̂oOCB
;
;	Revision 1.5  1994/04/12  15:09:08  nakamura
;	-m68000/68010(d,An)œKȂƂoOCB
;
;	Revision 1.4  1994/03/10  15:54:40  nakamura
;	̖߂ւ̃u`폜Ɩ\oOC
;
;	Revision 1.3  1994/03/06  13:03:06  nakamura
;	68000,68010[h32bitfBXv[Xgo͂Ă܂oOfix
;	.ln^߂ЂƂȂ\[XAZuƈُSCDR[ho͂oOfix
;	jbra,jbsr,jbccopcɑ΂鏈ǉ
;	'$'P[VJE^lwȂƂoOfix
;	G[Ƀx̒`lƃP[VAhXoOfix
;
;	Revision 1.2  1994/02/20  14:25:22  nakamura
;	V{e[u|C^̋EYĂ̂ŏCB
;
;	Revision 1.1  1994/02/15  12:12:58  nakamura
;	Initial revision
;
;
